<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.0
	 */

	/**
	 * eBag service usage (list of connected service lists)
	 */

	load_f('mb_wrap');

	class ARTICALUSAGE	{

		var $COLUMN_names	=	array(	'personID', 'contactname', 'city', 'date_of_creation', 'date_of_deadline', 'quantity', 'unit' );

		var $COLUMN_names_AS	=	array();

		var $TABLE		=	'';

		function __construct()	{

			global $__SQL, $__CONF, $__LANG, $__BOX;

			$this->SQL	=	&$__SQL;

			$this->FORMAT	=	$__CONF->get('date', 'sql_format');

			$this->LANG	=	&$__LANG;

			$this->BOX	=	&$__BOX;

			$this->BASE	=	$_SESSION['BASE'];

			if (isset($_SESSION['year_is_closed']))	{

				$this->STOCKBASE = $_SESSION['BASE'];

			}	else	  {

				$this->STOCKBASE = 'ebagstock';
			}

			unset($_SESSION['ID']);

			foreach ($this->COLUMN_names as $COLUMN) 	{

				$this->COLUMN_names_AS[$COLUMN] = $this->LANG->get($COLUMN);
			}
		}


		private function readartical($ID)	{

			$this->SQL->query("	SELECT `code`, `articalname` as `name`, `unit`
						FROM $this->STOCKBASE.finished_goods_stock
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows()) return FALSE;

			$this->ARTICALDATA	=	$this->SQL->RESULT->fetch_assoc();

			$this->CODE		=	$this->SQL->r_escape($this->ARTICALDATA['code']);

			return TRUE;
		}

		public function create($ID)	{

			if (! $this->readartical($ID)) return 'unexistentartical';

			$this->TABLE	=	"<table class=\"list\" width=\"400\">\n"
						.'<tr class="list-column-names">'."\n";

			foreach ($this->COLUMN_names_AS as $key=>$COLUMN)	{

				if ($key == 'personID') {$CLASS='class="personID-name"';} else {$CLASS='class="column-names"';}

				$this->TABLE .= "<td $CLASS height=\"35\">".mb_wrap($COLUMN, 7, '<br>')."</td>\n";

			}

			$this->TABLE	.=	'</tr>'."\n";

			$this->SQL->query("	SELECT 	orders_header.personID, orders_header.contactname, orders_header.city, 
							DATE_FORMAT(orders_header.date_of_creation, '$this->FORMAT') AS `date_of_creation`,
							DATE_FORMAT(orders_header.date_of_deadline, '$this->FORMAT') AS `date_of_deadline`,  
							orders_data.quantity, orders_data.unit
						FROM $this->BASE.orders_header 
						INNER JOIN $this->BASE.orders_data
						ON orders_header.personID=orders_data.orderID
						WHERE orders_header.personID IN (	SELECT `orderID`
											FROM $this->BASE.orders_data
							  				WHERE `code`='$this->CODE' AND `date_of_delivery` IS NULL AND `deleted` IS NOT NULL
										)
						AND orders_header.deleted IS NOT NULL
						AND orders_data.deleted IS NOT NULL	");

			$this->WHOLE = $this->SQL->calc_rows();

			if (! $this->WHOLE)	return 'noarticalusage';
	
			$CLASS		=	'list-dark';
			
			$SUM		=	0;

			while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{

				if ($CLASS=='list-dark')	{$CLASS = 'list-light';} else {$CLASS = 'list-dark';}

				$this->TABLE .= "<tr class=\"$CLASS\" onmouseover=\"Javascript: mark(this);\" onmouseout=\"Javascript: unmark(this);\">\n";

				foreach ($this->COLUMN_names as $COLUMN)	{

					$VALUE = $RESULT[$COLUMN];

					$this->TABLE .= "<td><input class=\"list-input\" style=\"width: ".$this->BOX->size($COLUMN)."px;\" readonly value=\"$VALUE\"></td>\n";
					
					if ($COLUMN == 'quantity') $SUM += $VALUE;
				}

				$this->TABLE .=	"</tr>\n";
			}

			$this->ARTICALDATA['sum'] = $SUM;			
			
			$this->SQL->free();

			$this->TABLE .= '</table>'."\n";

			$this->TABLE = "<div class=\"border\">\n<div class=\"padding-list\">\n$this->TABLE\n</div>\n</div>\n";

			return TRUE;
		}
	}
?>
