<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag create tables with service & orders with calculated bonus
	 */

	class BONUSLIST		{

		var $SERVICES_WITH_BONUS_TO_FINISHER		=	FALSE;

		var $PRODUCTION_ORDERS_WITH_BONUS_TO_FINISHER	=	FALSE;

		var $SERVICES_WITH_BONUS_TO_SELL		=	FALSE;

		var $DELIVERYS_WITH_BONUS_TO_SELL		=	FALSE;


		function __construct()	{

			global $__SQL, $__CONF, $__LANG;

			$this->SQL	=	&$__SQL;

			$this->FORMAT	=	$__CONF->get('date', 'sql_format');

			$this->NUMBER	=	$__LANG->get('personIDlong');

			$this->NAME	=	$__LANG->get('name');

			$this->CITY	=	$__LANG->get('city');

			$this->F_DATE	=	$__LANG->get('date_of_finishing');

			$this->D_DATE	=	$__LANG->get('date_of_delivery');
			
			$this->INTERNAL = 	$__LANG->get('customerstock');

			$this->BASE	=	$_SESSION['BASE'];
		}

		public function createlist($ID=FALSE)	{

			if (! $ID) return FALSE;

			$this->ID = $this->SQL->escape($ID);
			
			$this->SQL->query("	SELECT	salarys.bonus_config,
							salarys.month,
							salarys.month_part,
							salarys.employeename,
							salary_bonuses.bonus_to_services as bonus_to_services_linked,
							salary_bonuses.bonus_to_production as bonus_to_production_linked,
							salary_bonuses.bonus_to_service_sell as bonus_to_service_sell_linked,
							salary_bonuses.bonus_to_product_sell as bonus_to_product_sell_linked
						FROM $this->BASE.salarys 
						INNER JOIN $this->BASE.salary_bonuses
						ON salarys.personID = salary_bonuses.salaryID
						WHERE	salarys.deleted IS NOT NULL
						    AND salary_bonuses.deleted IS NOT NULL
						    AND salarys.personID='$this->ID' LIMIT 1	");

			if (! $this->SQL->num_rows()) return FALSE;
			
			$DATA = $this->SQL->RESULT->fetch_assoc();

			extract($DATA);

			if ($bonus_to_services_linked)	{

				$IDs = explode('-', $bonus_to_services_linked);

				$this->SERVICES_WITH_BONUS_TO_FINISHER	=	'<table class="bonusdetails">'
										."<tr class=\"bonusdeatilsheader\"><td class=\"bonus-number\">$this->NUMBER</td><td class=\"bonus-name\">$this->NAME</td><td class=\"bonus-city\">$this->CITY</td><td class=\"bonus-date\">$this->F_DATE</td></tr>\n";

				foreach ($IDs as $fullID)	{

					if (! $fullID) continue;
					
					list($year, $ID) = explode('_', $fullID);

					$this->SQL->query("	SELECT `contactname`, `city`,
								DATE_FORMAT(`date_of_finishing`, '$this->FORMAT') AS `date_of_finishing`
								FROM ebagdata$year.services_header
								WHERE `personID`='$ID' LIMIT 1	");

					if ($this->SQL->num_rows())	{

						extract($this->SQL->RESULT->fetch_assoc());

						$this->SERVICES_WITH_BONUS_TO_FINISHER .= "<tr><td>$year/$ID</td><td>$contactname</td><td>$city</td><td>$date_of_finishing</td></tr>\n";
					}
				}

				$this->SERVICES_WITH_BONUS_TO_FINISHER .= "</table>\n";
			}		

			if ($bonus_to_production_linked)	{

				$IDs = explode('-', $bonus_to_production_linked);

				$this->PRODUCTION_ORDERS_WITH_BONUS_TO_FINISHER	= 	'<table class="bonusdetails">'
											."<tr class=\"bonusdeatilsheader\"><td class=\"bonus-number\">$this->NUMBER</td><td class=\"bonus-name\">$this->NAME</td><td class=\"bonus-city\">$this->CITY</td><td class=\"bonus-date\">$this->F_DATE</td></tr>\n";

				foreach ($IDs as $fullID)	{

					if (! $fullID) continue;
			
					list($year, $ID) = explode('_', $fullID);
					
					$this->SQL->query("	SELECT `orderID`,
								DATE_FORMAT(date_of_finishing, '$this->FORMAT') AS `date_of_finishing`
								FROM ebagdata$year.production_orders_header
								WHERE `personID`='$ID' LIMIT 1 ");
								
					if (! $this->SQL->num_rows()) continue;
					
					extract($this->SQL->RESULT->fetch_assoc());
					
					$contactname = $this->INTERNAL; $city = '-';
					
					if ($orderID)	{
					
						$this->SQL->query("	SELECT `contactname`, `city`
									FROM ebagdata$year.orders_header
									WHERE 	`personID`='$orderID' 
									  AND 	`deleted` IS NOT NULL LIMIT 1	");
									  
						if ($this->SQL->num_rows()) extract($this->SQL->RESULT->fetch_assoc());
					}

					$this->PRODUCTION_ORDERS_WITH_BONUS_TO_FINISHER .= "<tr><td>$year/$ID</td><td>$contactname</td><td>$city</td><td>$date_of_finishing</td></tr>\n";

				}

				$this->PRODUCTION_ORDERS_WITH_BONUS_TO_FINISHER .= "</table>\n";
			}

			if ($bonus_to_service_sell_linked)	{

				$IDs = explode('-', $bonus_to_service_sell_linked);

				$this->SERVICES_WITH_BONUS_TO_SELL	=	'<table class="bonusdetails">'
										."<tr class=\"bonusdeatilsheader\"><td class=\"bonus-number\">$this->NUMBER</td><td class=\"bonus-name\">$this->NAME</td><td class=\"bonus-city\">$this->CITY</td><td class=\"bonus-date\">$this->F_DATE</td></tr>\n";

				foreach ($IDs as $fullID)	{

					if (! $fullID) continue;
					
					list($year, $ID) = explode('_', $fullID);

					$this->SQL->query("	SELECT `contactname`, `city`, 
								DATE_FORMAT(`date_of_finishing`, '$this->FORMAT') AS `date_of_finishing`
								FROM ebagdata$year.services_header
								WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

					if ($this->SQL->num_rows())	{

						extract($this->SQL->RESULT->fetch_assoc());

						$this->SERVICES_WITH_BONUS_TO_SELL .= "<tr><td>$year/$ID</td><td>$contactname</td><td>$city</td><td>$date_of_finishing</td></tr>\n";
					}
				}

				$this->SERVICES_WITH_BONUS_TO_SELL .= "</table>\n";
			}

			if ($bonus_to_product_sell_linked)	{

				$IDs = explode('-', $bonus_to_product_sell_linked);

				$this->DELIVERYS_WITH_BONUS_TO_SELL	=	'<table class="bonusdetails">'
										."<tr class=\"bonusdeatilsheader\"><td class=\"bonus-number\">$this->NUMBER</td><td class=\"bonus-name\">$this->NAME</td><td class=\"bonus-city\">$this->CITY</td><td class=\"bonus-date\">$this->D_DATE</td></tr>\n";

				foreach ($IDs as $fullID)	{

					if (! $fullID) continue;
					
					list($year, $ID) = explode('_', $fullID);

					$this->SQL->query("	SELECT `contactname`, `city`,
								DATE_FORMAT(`date_of_creation`, '$this->FORMAT') AS `date_of_creation`
								FROM ebagdata$year.deliverys_header
								WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

					if ($this->SQL->num_rows())	{

						extract($this->SQL->RESULT->fetch_assoc());

						$this->DELIVERYS_WITH_BONUS_TO_SELL .= "<tr><td>$year/$ID</td><td>$contactname</td><td>$city</td><td>$date_of_creation</td></tr>\n";
					}
				}

				$this->DELIVERYS_WITH_BONUS_TO_SELL .= "</table>\n";
			}

			return $DATA;
		}
	}

?>
