<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag create table with command from command line;
	 */

	load_f('mb_wrap');
	
	load_f('mb_ereg_match_str');

	load_f('pagination');

	class COMMANDLINE	{

		var $TABLE	=	'';

		var $PAGNATION	=	'';

		function __construct($INC)	{

			global $__SQL, $__LANG, $__CONF;

			$this->SQL 	=	&$__SQL;

			$this->LANG	=	&$__LANG;

			$this->BASE	=	$_SESSION['BASE'];

			$this->INC	=	$INC;
			
			$this->APC 	=	$__CONF->get('cache', 'use_apc_cache');
		}

		private function localize($VALUE, $COLUMN)	{

			switch($COLUMN)		{

				case('contacttype')		:	$TXT = $this->LANG->get("type$VALUE");
									break;

				case('delivery_day_of_week')	:	$TXT = $this->LANG->get("day$VALUE");
									break;

				case('critic')			:	$TXT = $this->LANG->get("critic$VALUE");
									break;

				case('origin')			:	$TXT = $this->LANG->get("origin$VALUE");
									break;

				case('delivered')		:	$TXT = $this->LANG->get("deliverystate$VALUE");
									break;

				case('ordered')			:
				case('billed')			:
				case('finished')		:	$TXT = $this->LANG->get("yesno$VALUE");
									break;

				case ('connected_with_deliverys'):
				case ('connected_with_reverses'):
				case ('connected_with_orders')	:	if (! $VALUE)	{

										$TXT = $VALUE;
										break;
									}

									$LIST	=	explode('-', $VALUE);

									unset($LIST[count($LIST)-1], $LIST[0]);

									$TXT	=	wordwrap(implode(', ', $LIST), 20, "<br>");

									break;

				case ('delivery_form')		:	$TXT		=	'';

									if (isset($this->DELIVERY_TYPES[$VALUE])) $TXT = $this->DELIVERY_TYPES[$VALUE];
							
									break;

				case ('payment_form')		:	$TXT		=	'';

									if (isset($this->PAYMENT_TYPES[$VALUE])) $TXT= $this->PAYMENT_TYPES[$VALUE];
				
									break;

				case ('production_phase')	:	$TXT	=	'';

									if (isset($this->PHASES[$VALUE]))	$TXT = $this->PHASES[$VALUE];
							
									break;

				case('finisher')		:	if (! $VALUE)	{

										$TXT = $VALUE;
										break;
									}

									list($TYPE, $FINISHERID)	=	explode('_', $VALUE);

									if ($TYPE == 'employee')	{

										$COMMAND = "SELECT `employeename` FROM $this->BASE.employees WHERE `personID`='$FINISHERID' AND `deleted` IS NOT NULL LIMIT 1";

									}	else	   {

										$COMMAND = "SELECT `contactname` FROM $this->BASE.addressbook WHERE `personID`='$FINISHERID' AND `deleted` IS NOT NULL LIMIT 1";
									}

									$this->SQL->query($COMMAND);

									if ($this->SQL->num_rows())	{

										$RESULT	= $this->SQL->RESULT->fetch_row();
										$TXT = $RESULT[0];

									}	else	  {

										$TXT = $this->LANG->get('finisherwasdeleted');
									}

									break;

				case('month')			:	$TXT = $this->LANG->get("monthname$VALUE");
									break;

				case('seller')			:	if ($VALUE)	{

										$this->SQL->query("	SELECT `employeename` 
													FROM $this->BASE.employees
													WHERE `personID`='$VALUE' LIMIT 1	");

										if ($this->SQL->num_rows())	{
				
											$RESULT =	$this->SQL->RESULT->fetch_row();
											$TXT	=	$RESULT[0];
										}
									}

									if (! isset($TXT)) $TXT =	$this->LANG->get('notset');

									break;

				default				:	$TXT = $VALUE;
			}

			return $TXT;
		}

		private function PAGECOUNT()	{

			if (! $this->WHOLE) return;

			if ($this->WHOLE < $this->INC)	{

				$this->PAGENUM	=	0;

			}	else 	{ 

				if ($this->WHOLE % $this->INC==0) {$correct=1;} else {$correct=0;}

				$this->PAGENUM = floor($this->WHOLE / $this->INC)-$correct;
			}

			unset($this->WHOLE);
		}

		private function remove_limit ()	{
		
			# not real limit
		
			if (mb_ereg_match_str('\s+LIMIT\s*$', $this->COMMAND, $limit, 'i')) return;
			
			# split

			if (mb_ereg_match_str('\s+LIMIT', $this->COMMAND, $limit, 'i'))	{

				$parts = mb_split($limit, $this->COMMAND);
				
				if (($count = count($parts)) > 1)	{
				
					$str = mb_eregi_replace('^\s*|\s*$', '', $parts[$count-1]);
					    
					# limit 1 && 1,2
					
					if (	(mb_ereg_match_str('^\d+$', $str, $m, 'i')) or 
						(mb_ereg_match_str('^\d+\s*\,\s*\d+$', $str, $m, 'i')) or
						(mb_ereg_match_str('^\d+\s*offset\s*\d+$', $str, $m, 'i'))	)	{
					
							unset($parts[$count-1]);
						
							$this->COMMAND = implode($limit, $parts);
					}
				}
			}
		}
	
		private function readarrays()	{
		 
			$__DELIVERYS		=	new DELIVERYloader($this->APC);

			$this->DELIVERY_TYPES	=	$__DELIVERYS->gettypes();
			
			$__PAYMENTS		=	new PAYMENTloader($this->APC);

			$this->PAYMENT_TYPES	=	$__PAYMENTS->getnames();
										
			$__PHASES		=	new PHASEloader($this->APC);

			$this->PHASES		=	$__PHASES->getall();
		 }


		public function create()	{
		
			$this->readarrays();

			$this->COMMAND = $_SESSION['COMMAND'];

			$this->remove_limit();

			if (isset($_GET['new'])) $_SESSION['LISTPAGE'] = 0;

			if (isset($_GET['page']))	{

				$this->PAGE = $_SESSION['LISTPAGE'] = (integer)$_GET['page'];

			}	else	  {

				$this->PAGE = $_SESSION['LISTPAGE'];
			}

			$LIMIT			=	' LIMIT '.($this->PAGE * $this->INC).', '.$this->INC;

			$_SESSION['LIMIT']	=	$LIMIT;

			$this->COMMAND		.=	$LIMIT;

			# select the base

			$this->SQL->mysqli->select_db($this->BASE);

			# first only check to command syntax;
	
			$RESULT = $this->SQL->mysqli->query($this->COMMAND);

			if ($RESULT === FALSE)	return 'mysqlerror';

			$this->SQL->mysqli->select_db($this->BASE);

			$this->SQL->query($this->COMMAND);

			$this->WHOLE = $this->SQL->calc_rows();

			if (! $this->WHOLE) return 'norows';

			$this->PAGECOUNT();

			$TO_LOCALIZE	=	array(	'contacttype', 'delivery_day_of_week', 'critic', 'origin', 'ordered', 'finished', 'finisher', 'delivered', 
							'delivery_form', 'payment_form', 'connected_with_orders', 'connected_with_deliverys', 'month',
							'connected_with_reverses', 'production_phase', 'billed', 'seller' );

			$COLUMNS	=	array();

			while ($FINFO = $this->SQL->RESULT->fetch_field()) $COLUMNS[] = $FINFO->name;

			if (! count($COLUMNS)) return FALSE;

			$this->TABLE	=	"<table id=\"data\" class=\"list\">\n<tr class=\"list-column-names\">\n";

			foreach ($COLUMNS as $COLUMN)	{

				if ($COLUMN == 'personID') {$CLASS='class="personID-name"';} else {$CLASS='class="column-names"';}

				$this->TABLE .= "<td $CLASS>".mb_wrap(str_replace('_', ' ', $COLUMN), 7, '<br>')."</td>\n";
			}

			$this->TABLE .= '</tr>';

			$this->SQL->IT1_RESULT = $this->SQL->RESULT;

			$CLASS	= 'list-dark';

			while ($ROW = $this->SQL->IT1_RESULT->fetch_assoc())	{

				if ($CLASS=='list-dark')	{$CLASS = 'list-light';} else {$CLASS = 'list-dark';}

				$this->TABLE .= "<tr class=\"$CLASS\" onmouseover=\"Javascript: mark(this);\" onmouseout=\"Javascript: unmark(this);\" >\n";

				foreach ($COLUMNS as $COLUMN)	{

					$VALUE	= $ROW[$COLUMN];

					if (in_array($COLUMN, $TO_LOCALIZE)) $VALUE = $this->localize($VALUE, $COLUMN);

					$this->TABLE .= "<td height=\"25\">$VALUE</td>\n";
				}

				$this->TABLE .=  "</tr>\n";
			}

			unset($this->SQL->IT1_RESULT);

			$this->TABLE .= '</table>';

			$this->TABLE = "<div class=\"border\">\n<div class=\"padding-list\">\n$this->TABLE\n</div>\n</div>\n";

			# remove float: right from pagination to show it from left

			if (isset($this->PAGENUM)) $this->PAGINATION = str_replace('class="pagination"', '', pagination($this->PAGE, $this->PAGENUM, $this->INC, backward()));

			return TRUE;
		}
	}

?>
