<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag contact quicksearch
	 * Usage new CONTACTQUICKSEARCH('jscopyfuncionname');
	 */

	class CONTACTQUICKSEARCH	{

		var $TABLE	=	'';
		var $PAGINATION	=	'';
		var $COMMAND	=	'';
		var $WHOLE	=	FALSE;
		var $PAGE	=	0;
		var $NEWSEARCH	=	FALSE;
		var $INC	=	12;

		function __construct($COPYFUNC, $TYPESQL)	{

			global $__SQL, $__LANG;

			$this->SQL	=	&$__SQL;
			$this->BASE	=	$_SESSION['BASE'];
			$this->LANG	=	&$__LANG;
			$this->JSFUNC	=	$COPYFUNC;
			$this->TYPESQL	=	$TYPESQL;

			if (isset($_GET['page'])) 	{

				$this->PAGE	= (integer)$_GET['page'];
				$this->COMMAND	= $_SESSION['QUICKSEARCH'];
			}

			if ((isset($_POST['submit_search'])) or (isset($_POST['submit_all'])))	$this->COMMAND	= '';

			$this->FORMCOMMAND();

			$this->DRAWTABLE();

			if (isset($this->PAGENUM)) $this->PAGINATE();
		}
		

		/**
		 * Form the query
		 */

		private function FORMCOMMAND()	{

			$SEARCH		=	'';

			if (! $this->COMMAND)	{

				if ((isset($_POST['contactname'])) && (! is_empty($_POST['contactname']))) $SEARCH .= 'AND `contactname` REGEXP \''.$this->SQL->s_escape($_POST['contactname'], 'REGEXP').'\'';

				if ((isset($_POST['city'])) &&  (! is_empty($_POST['city']))) $SEARCH .= 'AND `city` REGEXP \''.$this->SQL->s_escape($_POST['city'], 'REGEXP').'\'';

				$this->COMMAND = "SELECT SQL_CALC_FOUND_ROWS `personID`, `contactname`, `city`, `contacttype`, `service_discount`, `article_discount` 
						  FROM $this->BASE.addressbook WHERE $this->TYPESQL AND `deleted` IS NOT NULL ".$SEARCH;

				$_SESSION['QUICKSEARCH'] = $this->COMMAND;
			}

			$this->COMMAND .= ' ORDER BY `personID`  LIMIT '.($this->PAGE * $this->INC).', '.$this->INC;
		}

		/**
		 * Count the pages
		 */

		private function PAGECOUNT()	{

			if (! $this->WHOLE) return;

			if ($this->WHOLE < $this->INC)	{

				$this->PAGENUM	=	0;

			}	else 	{ 

				if ($this->WHOLE % $this->INC==0) {$correct=1;} else {$correct=0;}

				$this->PAGENUM = floor($this->WHOLE / $this->INC)-$correct;
			}
			
			unset($this->WHOLE);

			$this->NUMROWS = $this->SQL->RESULT->num_rows;
		}

		/**
		 * Execute query
		 */

		private function DRAWTABLE()	{

				$this->SQL->query($this->COMMAND);

				$this->WHOLE = $this->SQL->num_rows();

				if (! $this->WHOLE)	{

					$ERRTXT	=	$this->LANG->get('noresult');	

					$this->TABLE .= "<table>\n<tr><td class=\"link\" colspan=\"2\">$ERRTXT</td></tr>\n</table>";

					return;
				}
	
				$this->PAGECOUNT();

				$INC = 0;
				$this->TAB = 5;

				while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{

					$personID	=	$RESULT['personID'];
					$companyname	=	$RESULT['contactname'];
					$city		=	$RESULT['city'];
					$type		=	$RESULT['contacttype'];
					$s_discount	=	$RESULT['service_discount'];
					$a_discount	=	$RESULT['article_discount'];

					if ($this->NUMROWS == ($INC+1))	{

						$NEXTFIELD='onkeypress="return nextfield(this, event, \'check_0\')"';

					}	else	{

						$next = $INC+1;

						$NEXTFIELD="onkeypress=\"return nextfield(this, event, 'check_$next')\"";
					}

					$JSFUNCTION = "$this->JSFUNC(this, '$INC');";

					$this->TABLE	.=	<<<"EOT"
								<tr>
									<td><input type="checkbox" name="check_$INC" value="$personID" tabindex=$this->TAB onfocus="$JSFUNCTION" onclick="$JSFUNCTION" $NEXTFIELD></td>
									<td><input readonly style="width: 150px" name="name_$INC" value="$companyname"></td>
									<td><input readonly style="width: 100px" name="city_$INC" value="$city">
									<input class="textbox" type="hidden" name="type_$INC" value="$type">
									<input class="textbox" type="hidden" name="service_discount_$INC" value="$s_discount">
									<input class="textbox" type="hidden" name="article_discount_$INC" value="$a_discount"></td>
								</tr>
EOT;
					$INC++;
					$this->TAB++;
				}

				$this->TABLE	=	"<table class=\"searchresult\">\n"
							.'<tr><td></td><td class="label">'.$this->LANG->get('contactname').'</td><td class="label">'.$this->LANG->get('city')."</td></tr>\n"
							.$this->TABLE
							.'</table>';

				$this->SQL->free();
		}

		private function PAGINATE()	{

			$SELF	= backward();

			$BACKWARD = $FORWARD = 0;

			if ((! $this->PAGE) && ($this->PAGENUM))	{

				$FORWARD	=	$this->PAGE+1;
			}

			if (($this->PAGE==$this->PAGENUM) && ($this->PAGE))	{

				$BACKWARD 	=	$this->PAGE-1; 
				$FORWARD	=	$this->PAGE;
			}

			if (($this->PAGE) && ($this->PAGE!=$this->PAGENUM))	{

				$BACKWARD	=	$this->PAGE-1; 
				$FORWARD	=	$this->PAGE+1;
			}

			$tab1 = $this->TAB++;
			$tab2 = $this->TAB++;
			$tab3 = $this->TAB++;
			$tab4 = $this->TAB++;
			
			$this->PAGINATION	=	<<<"EOT"
					<table class="pagination">
						<tr>
							<td><a href="$SELF&amp;page=0" tabindex=$tab1><img src="../images/tstart.png" width="9" height="9" border="0" alt="start"></a></td>
							<td><a href="$SELF&amp;page=$BACKWARD" tabindex=$tab2><img src="../images/tbackward.png" width="9" height="9" border="0" alt="backward"></a></td>
							<td><a href="$SELF&amp;page=$FORWARD" tabindex=$tab3><img src="../images/tforward.png" width="9" height="9" border="0" alt="forward"></a></td>
							<td><a href="$SELF&amp;page=$this->PAGENUM" tabindex=$tab4><img src="../images/tend.png" width="9" height="9" border="0" alt="end"></a></td>
						</tr>
					</table>
EOT;
		}
	}

?>
