<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag CRITICS TABLE with FILTERS class
	 */

	# note: works only with contacts table & lists only buyers and companies

	load_f('pagination');
	load_f('mb_wrap');

	class TABLE	{

		var $COLUMN_names	=	array();
		var $COLUMN_names_AS	=	array();
		var $FILTER_type	=	array();
		var $FILTER_state	=	array();
		var $TABLE		=	'';
		var $ROW_FILTER		=	'';
		var $ROW_LABEL		=	'';
		var $TABLE_BODY		=	'';
		var $COLUMNS		=	FALSE;
		var $PAGE		=	0;
		var $WHOLE		=	FALSE;
		var $SORT		=	'cadc8c8db42409733582cb3e2298ef87';
		var $COMMAND		=	'';

		/**
		 * Sets the table
		 */

		function __construct($TABLE, $INCREMENT, $LIMIT)	{

			$this->SQLTABLE	=	$TABLE;
			$this->INC	=	$INCREMENT;
			$this->LIMIT	=	$LIMIT;

			global $__CONF, $__SQL, $__LANG, $__BOX;
			
			$this->CHARS_FLAG = 	$__CONF->get('specialchars','flag');

			$this->SQL	=	&$__SQL;
			$this->LANG	=	&$__LANG;
			$this->BOX	=	&$__BOX;

			unset($_SESSION['ID']);
		}

		/**
		 * Sets the columns to display basename, displayname, filter type
		 * (Filter types : none, box, listbox)
		 */
		
		public function column($COLUMN, $FILTER='none')	  {

			array_push($this->COLUMN_names, $COLUMN);
			
			$this->FILTER_type[$COLUMN]	=	$FILTER;

			$this->COLUMN_names_AS[$COLUMN] =	$this->LANG->get($COLUMN);

			if ($FILTER != 'none') $this->FILTER_state[$COLUMN] = FALSE;
		}

		/**
		 * Adds filter to where clausule
		 */

		private function addwhere($FILTER)	{

			if (! $this->WHERE) {$AND = ' WHERE ';} else {$AND = ' AND ';}

			$this->WHERE .= " $AND $FILTER ";
		}

		/**
		 * Adds filter to order by clausule
		 */

		private function addorderby($FILTER)	{

			if (! $this->ORDERBY)	{$AND =	' ORDER BY ';} else {$AND = ' AND ';}

			$this->ORDERBY .= " $AND $FILTER ";
		}

		/**
		 * Adds columns to search
		 */

		private function addcolumn($COLUMN)	{

			if (! $this->COLUMNS) {$this->COLUMNS = "`$COLUMN`";} else {$this->COLUMNS .= ", `$COLUMN`";}
		}
		
		/**
		 * Forms command with where and order by clausules
		 */

		private function FORMCOMMAND()	{

			if (! $this->COMMAND)	{

				$COLUMNS	=	'';

				foreach ($this->COLUMN_names as $COLUMN) $this->addcolumn($COLUMN);
			
				$this->COMMAND	=	"SELECT SQL_CALC_FOUND_ROWS $this->COLUMNS FROM $this->SQLTABLE";

				unset($this->COLUMNS);

				$this->WHERE	=	'';
				$this->ORDERBY	=	'';

				foreach ($this->COLUMN_names as $COLUMN)	{

					if ((! isset($this->FILTER_state[$COLUMN])) or ((! $this->FILTER_state[$COLUMN]) && (! is_numeric($this->FILTER_state[$COLUMN])))) continue;

					switch($this->FILTER_type[$COLUMN])		{

						case 'box'	:	$this->addwhere("`$COLUMN` REGEXP '".($this->SQL->s_escape($this->FILTER_state[$COLUMN], 'REGEXP'))."'");
									break;

						case 'static'	:	if ($this->FILTER_state[$COLUMN] == $this->SORT)	{

										$this->addorderby("`$COLUMN`");
										break;
									}

									$this->addwhere("`$COLUMN`='".($this->SQL->escape($this->FILTER_state[$COLUMN]))."'");
									break;
					}
				}

				$PREFIX	= 'AND';

				if (! $this->WHERE)	$PREFIX = 'WHERE';

				$this->COMMAND .= $this->WHERE." $PREFIX `deleted` IS NOT NULL AND (`contacttype`='0' OR `contacttype`='1') ";
				
				if ((! $this->ORDERBY) && (in_array('personID', $this->COLUMN_names))) $this->addorderby("`personID`");

				if ($this->ORDERBY)	$this->COMMAND .= $this->ORDERBY;

				$_SESSION['COMMAND'] 	=	$this->COMMAND;
			}

			$LIMIT			=	' LIMIT '.($this->PAGE * $this->INC).', '.$this->INC;

			$_SESSION['LIMIT']	=	$LIMIT;

			$this->COMMAND		.=	$LIMIT;
		}

		/**
		 * Localize the data readed from base
		 */

		private function localize($VALUE, $COLUMN)	{

			switch($COLUMN)		{

				case 'contacttype'		:	$TXT = $this->LANG->get("type$VALUE");
									break;

				case 'critic'			:	$TXT = $this->LANG->get("critic$VALUE");
									break;

				default				:	$TXT = $VALUE;
			}

			return $TXT;
		}

		/**
		 * Create table row with column names
		 */

		private function TABLEHEADER()	{

			$this->ROW_LABEL	.=	'<tr class="list-column-names">'."\n";

			foreach ($this->COLUMN_names_AS as $key=>$COLUMN)	{

				if ($key == 'personID') {$CLASS='class="personID-name"';} else {$CLASS='class="column-names"';}

				$this->ROW_LABEL .= "<td $CLASS>".mb_wrap($COLUMN, 7, '<br>')."</td>\n";

			}

			$this->ROW_LABEL	.=	'<td class="filters" rowspan="2">'."\n"
						 	.'<input class="button-list" type="submit" name="FILTER" value="'.$this->LANG->get('filter').'">'."\n"
							.'</td><td class="filters" rowspan="2">'."\n"
							.'<div id="print" class="list-print-div-hide">'."\n"
							.'<a class="print-link" target="_blank" href="../controllers/print.php?id=view" onclick="Javascript: printhide()">'.$this->LANG->get('printview').'</a>&nbsp;&nbsp;&nbsp;'
							.'<a class="print-link" target="_blank" href="../controllers/print.php?id=all" onclick="Javascript: printhide()">'.$this->LANG->get('printall').'</a></div>'
						 	.'<input class="button-print" type="button" value="'.$this->LANG->get('PRINT_B').'" onclick="Javascript: printmenu();">'."\n"
							.'</td>'."\n";

			$this->ROW_LABEL	.=	'</tr>'."\n";
		}

		/**
		 * Create tabe row with filters
		 */
		 
		private function is_selected($COLUMN, $VALUE)	{
		
			if (($this->FILTER_state[$COLUMN]!==FALSE) && ($this->FILTER_state[$COLUMN]==$VALUE)) return 'selected';
			
			return '';
		}

		private function TABLEFILTERS()	{

			$this->ROW_FILTER	.=	'<tr class="list-filters">'."\n";

			foreach ($this->COLUMN_names as $COLUMN)	{

				if ($this->FILTER_type[$COLUMN]=='none') $this->ROW_FILTER .= '<td></td>'."\n";

				/**
				 * Adds static list
				 */
				 
				if ($this->FILTER_type[$COLUMN] == 'static')	{
								
					$this->ROW_FILTER .= "<td>\n<select style=\"width: ".$this->BOX->size($COLUMN)."px;\" name=\"$COLUMN\">\n";

					// the all will be empty=>false

					if ($this->FILTER_state[$COLUMN]===FALSE) {$selected='selected';} else {$selected='';}

					$this->ROW_FILTER .= "<option $selected value=\"\">".$this->LANG->get('all')."</option>\n";

					if ($this->FILTER_state[$COLUMN] == $this->SORT)  {$selected='selected';} else {$selected='';}

					$this->ROW_FILTER .= "<option $selected value=\"$this->SORT\">".$this->LANG->get('sort')."</option>\n";
					
					# Note: contacttype: 0=Company,1=Buyer 
					
					foreach (array(0,1) as $VALUE)	{

						$VALUE = "$VALUE";

						$TXT = $this->localize($VALUE, $COLUMN);

						$this->ROW_FILTER .= '<option '.$this->is_selected($COLUMN, $VALUE)." value=\"$VALUE\">$TXT</option>\n";
					}

					$this->ROW_FILTER .=  "</select>\n</td>\n";
				}
				
				/**
				 * Adds box 
				 */

				if ($this->FILTER_type[$COLUMN] == 'box')	{

					$VALUE	= $this->FILTER_state[$COLUMN];

					$this->ROW_FILTER .= "<td>\n<input class=\"filter-input\" maxlength=\"40\" name=\"$COLUMN\" value=\"$VALUE\" onkeypress=\"return nextfield(this,event, 'FILTER');\">\n</td>\n";

					unset($DATE);
				}
			}
		
			$this->ROW_FILTER .= "</tr>\n";
		}

		/**
		 * Count the pages
		 */

		private function PAGECOUNT()	{

			if (! $this->WHOLE) return;

			if ($this->WHOLE < $this->INC)	{

				$this->PAGENUM	=	0;

			}	else 	{ 

				if ($this->WHOLE % $this->INC==0) {$correct=1;} else {$correct=0;}

				$this->PAGENUM = floor($this->WHOLE / $this->INC)-$correct;
			}

			unset($this->WHOLE);
		}

		/**
		 * Fetch query result to table
		 */

		private function TABLEBODY()	{

			$this->SQL->query($this->COMMAND);

			$this->WHOLE = $this->SQL->calc_rows();

			if (! $this->WHOLE)	{

				$SPAN	=	count($this->COLUMN_names) + 2;
				$ERRTXT	=	$this->LANG->get('noresult');	

				$this->TABLE_BODY .= "<tr><td class=\"link\" colspan=\"$SPAN\">$ERRTXT</td></tr>\n";

				return;
			}
	
			$this->PAGECOUNT();

			$CLASS		=	'list-dark';

			$MARKTEXT	=	$this->LANG->get('markascritical');

			while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{

				if ($CLASS=='list-dark')	{$CLASS = 'list-light';} else {$CLASS = 'list-dark';}

				$this->TABLE_BODY .= "<tr class=\"$CLASS\" onmouseover=\"Javascript: mark(this);\" onmouseout=\"Javascript: unmark(this);\">\n";

				foreach ($this->COLUMN_names as $COLUMN)	{

					$VALUE = $RESULT[$COLUMN];

					switch ($COLUMN)	{

						case 'personID'			:	$ID	=	$VALUE;
											break;

						case 'contacttype'		:	$VALUE	=	$this->localize($VALUE, $COLUMN);
											break;

						case 'critic'			:	$VALUE	=	$this->localize($VALUE, $COLUMN);
											break;
					}

					switch($COLUMN)	{

						case 'personID'			:	$this->TABLE_BODY .= "<td class=\"personID\">$VALUE&nbsp;&nbsp;</td>\n";
											break;

						case 'critic'			:	$this->TABLE_BODY .= "<td><input name=\"critic_".$ID."\" class=\"list-input\" style=\"width: ".$this->BOX->size($COLUMN)."px;\" readonly value=\"$VALUE\"></td>\n";
											break;

						default				:	$this->TABLE_BODY .= "<td><input class=\"list-input\" style=\"width: ".$this->BOX->size($COLUMN)."px;\" readonly value=\"$VALUE\"></td>\n";

					}

				}

				$BASE	=	$_SESSION['BASE'];

				$this->TABLE_BODY .= 	"<td class=\"link\" colspan=\"2\">\n"
							."<input name=\"markbutton\" class=\"add-remove-button\" value=\"+\" type=\"button\" onclick=\"mark_as_critic('$ID', '$BASE')\">&nbsp;&nbsp;&nbsp;$MARKTEXT\n"
							."</td>\n";

				$this->TABLE_BODY .=	"</tr>\n";
			}

			$this->SQL->free();
		}

		/**
		 * Read posts and set filter states
		 */
	
		private function GETPOST()	{

			if (isset($_GET['new']))	{

				$_SESSION['LISTPAGE']	=	0;

				if (isset($_SESSION['FILTERS'])) unset($_SESSION['FILTERS'], $_SESSION['COMMAND'], $_SESSION['LIMIT']);

				return;
			}

			if (isset($_GET['page']))	{

				$this->PAGE = $_SESSION['LISTPAGE'] = (integer)$_GET['page'];

			}	else	  {

				$this->PAGE = $_SESSION['LISTPAGE'];
			}
		

			if (isset($_POST['FILTER']))	{

				foreach ($this->COLUMN_names as $COLUMN)	{

					if (isset($_POST[$COLUMN]))	$this->FILTER_state[$COLUMN] = $_POST[$COLUMN];
				}

				$_SESSION['FILTERS'] = $this->FILTER_state;

			}	else	 {

				if (isset($_SESSION['FILTERS'])) $this->FILTER_state 	=	$_SESSION['FILTERS'];
				if (isset($_SESSION['COMMAND'])) $this->COMMAND		=	$_SESSION['COMMAND'];
			}
		}

		/**
		 * Displays the table;
		 */

		public function create()	{

			$this->GETPOST();

			$this->TABLEHEADER();

			$this->TABLEFILTERS();

			$this->FORMCOMMAND();

			$this->TABLEBODY();
			
			$this->TABLE = "<div class=\"border\">\n<div class=\"padding-list\">\n<table id=\"data\" class=\"list\">\n$this->ROW_LABEL $this->ROW_FILTER $this->TABLE_BODY\n</table>\n</div>\n</div>\n";

			if (isset($this->PAGENUM)) $this->TABLE = $this->TABLE.pagination($this->PAGE, $this->PAGENUM, $this->INC, backward());

			unset($this->ROW_LABEL, $this->ROW_FILTER, $this->TABLE_BODY);
		}
	}

?>
