<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag base defragmentation 
	 */

	load_c('BACKUP');

	class DEFRAGMENT	{

		function __construct()	{

			global $__SQL, $__CONF, $__SESS;

			$this->SQL		=	&$__SQL;

			$this->SESS		=	&$__SESS;

			$this->BACKUPDIR	=	$__CONF->get('backup', 'directory');

			$this->BACKUP		=	new BACKUP();
			
			$this->FILEMARK		=	BASEDIR.'tmp/maintenance.conf';
		}

		public function base($BASE=FALSE)	{

			if ($BASE) $this->BASE = $BASE;
		}

		private function loggeds_count()	{

			$COUNT = 0;

			$this->SQL->query("	SELECT `personID`
						FROM ebag.users
						WHERE `deleted` IS NOT NULL	");

			while ($RESULT = $this->SQL->RESULT->fetch_row())	{

				if ($this->SESS->is_logged($this->SQL->r_escape($RESULT[0]))) $COUNT++;
			}

			return $COUNT;
		}

		public function start()	{

			if (! $this->BASE) return 'nobasesfound';
			
			# check for other process
			
			if (is_file($this->FILEMARK)) return 'maintenanceinprogress';

			# verify the base exists

			$this->SQL->query("	SELECT SCHEMA_NAME 
						FROM INFORMATION_SCHEMA.SCHEMATA 
						WHERE SCHEMA_NAME = '$this->BASE'	");

			if (! $this->SQL->num_rows()) return 'nodefinedbasefound';

			# check that is no more logges users

			if ($this->loggeds_count() != 1) return 'moreofoneloggeds';

			# set time limit

			$time_limit	=	ini_get('max_execution_time');

			set_time_limit(0);

			# create backup copy at this point

			if ($this->BACKUPDIR)	{

				$this->BACKUP -> backup_directory($this->BACKUPDIR);

				$RESULT = $this->BACKUP->create();

				unset($this->BACKUP);

				if ($RESULT == 0) return 'backuperror';
				
				# do not start defragmenting with backup process in background
				
				if ($RESULT == 3) return 'backupinprogress';
			}
			
			# sets file mark for maintenance which will
			# redirect the users temporary from login

			@file_put_contents($this->FILEMARK, 'eBag_maintenance_in_progress');

			$this->SQL->query("	SHOW TABLES 
						FROM $this->BASE	");

			if ($this->SQL->num_rows())	{

				$this->SQL->IT1_RESULT = $this->SQL->RESULT;

				while ($IT1_RESULT = $this->SQL->IT1_RESULT->fetch_row())	{

					$TABLE	=	$IT1_RESULT[0];

					$this->SQL->query("	ALTER TABLE $this->BASE.$TABLE ENGINE = InnoDB	");
				}
			}

			# delete maintenance mark

			@unlink($this->FILEMARK);
			
			# restore time limit

			set_time_limit($time_limit);

			return TRUE;
		}
	}
?>
