<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag class to change ini values
	 */
	 
	load_f('mb_ereg_match_str'); 

	class INICHANGE		{

		public function open($file)	{

			$this->file	=	$file;

			$this->lines 	=	file($file);

			if (($this->lines === FALSE) or (! count ($this->lines))) trigger_error("file not found $file .", E_USER_ERROR);
		}

		# usage: change('tax', 'sales_tax', '19%');

		public function change($section, $key, $val)	{

			$SECTION	=	FALSE;
			$SUCCESS	=	FALSE;
			$i		=	-1;

			foreach ($this->lines as $line)		{

				$i++;

				# step over comments

				if (mb_eregi('^\s*\;', $line)) continue;

				# step over empty lines
			
				if (! mb_eregi_replace('\s|\n', '', $line)) continue;

				# find section

				if (! $SECTION)	{

					if (mb_ereg_match_str('\[(.*?)\]', $line, $found, 'i'))	{

						$SECTION = mb_eregi_replace('^\[|\]$|\s|\n', '', $found); 

						if ($SECTION != $section) $SECTION = FALSE;
					}

					continue;
				}

				# if second section begins break

				if (mb_ereg_match_str('\[(.*?)\]', $line, $found, 'i')) break;

				# find key

				list($inikey, $inival) = mb_split('=', $line);

				$inikey = mb_eregi_replace('\s|\n', '', $inikey);

				$inival = mb_eregi_replace('^\s*|\s*$', '', $inival);

				if ($inikey == $key)	{

					list($rawkey, $rawval) = mb_split('=', $this->lines[$i]);
					
					mb_ereg_match_str('^\s+', $rawval, $empty, 'i');

					$this->lines[$i]=$rawkey.'='.mb_eregi_replace('\r|\n','', $empty).$val.PHP_EOL;

					$SUCCESS = TRUE;

					break;
				}
			}

			return $SUCCESS;
		}

		public function save()	{

			$HANDLER = fopen($this->file, 'w');

			if ($HANDLER === FALSE) return FALSE;

			$inc = 0;

			while (! flock($HANDLER, LOCK_EX))	{

				$inc++; usleep(500);

				if ($inc > 1000)	{

					fclose($HANDLER); 

					$error = TRUE;

					break;
				}
			}

			if (isset($error)) return FALSE;

			foreach ($this->lines as $line)	{

				fwrite($HANDLER, $line);
			}

			flock($HANDLER, LOCK_UN);

			fclose ($HANDLER);

			return TRUE;
		}
	}
?>
