<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag lists changes maded by inventory
	 */

	load_f('pagination');

	load_f('mb_wrap');

	class INVENTORYLIST	{

		var $TABLE	=	'';
		var $ROW_LABEL	=	'';
		var $ROW_FILTER	=	'';
		var $TABLE_BODY = 	'';
		var $PAGINATION	=	'';
		var $PAGE	=	0;
		var $WHOLE	=	FALSE;
		var $COMMAND	=	'';

		var $COLUMN_names	=	array(	'inventoryID', 'date_of_creation', 'employeename', 'code', 'quantity_before', 'quantity_after' );

		var $COLUMN_names_AS	=	array();

		var $FILTER_type	=	array(	'inventoryID'=>'box', 'date_of_creation'=>'date', 'employeename'=>'box', 'code'=>'box', 'quantity_before'=>'none', 'quantity_after'=>'none' );

		function __construct($STOCKTABLE, $INC)	{

			$this->INC		=	$INC;

			global $__SQL, $__CONF, $__LANG, $__BOX;
	
			$this->SQL		=	&$__SQL;

			$this->LANG		=	&$__LANG;

			$this->BOX		=	&$__BOX;

			$this->STOCKTABLE	=	$STOCKTABLE;

			$this->BASE		=	$_SESSION['BASE'];
	
			$this->STOCKBASE	=	'ebagstock';

			$this->FORMAT		=	$__CONF->get('date', 'sql_format');

			unset($_SESSION['ID']);

			foreach ($this->COLUMN_names as $COLUMN) 	{

				$this->FILTER_state[$COLUMN]	=	FALSE;

				$this->COLUMN_names_AS[$COLUMN] = 	$this->LANG->get($COLUMN);
			}
		}

		/**
		 * Create table row with column names
		 */

		private function TABLEHEADER()	{

			$this->ROW_LABEL	.=	'<tr class="list-column-names">'."\n";

			foreach ($this->COLUMN_names_AS as $key=>$COLUMN)	{

				$this->ROW_LABEL .= '<td class="column-names">'.mb_wrap($COLUMN, 7, '<br>')."</td>\n";

			}

			$this->ROW_LABEL	.=	'<td class="filters" rowspan="2">'."\n"
						 	.'<input class="button-list" type="submit" name="FILTER" value="'.$this->LANG->get('filter').'">'."\n"
							.'</td><td class="filters" rowspan="2">'."\n"
							.'<div id="print" class="list-print-div-hide">'."\n"
							.'<a class="print-link" target="_blank" href="../controllers/print.php?id=view" onclick="Javascript: printhide()">'.$this->LANG->get('printview').'</a>&nbsp;&nbsp;&nbsp;'
							.'<a class="print-link" target="_blank" href="../controllers/print.php?id=all" onclick="Javascript: printhide()">'.$this->LANG->get('printall').'</a></div>'
						 	.'<input class="button-print" type="button" value="'.$this->LANG->get('PRINT_B').'" onclick="Javascript: printmenu();">'."\n"
							.'</td>'."\n";

			$this->ROW_LABEL	.=	'</tr>'."\n";
		}

		/**
		 * Create tabe row with filters
		 */

		private function TABLEFILTERS()	{

			$this->ROW_FILTER	.=	'<tr class="list-filters">'."\n";

			foreach ($this->COLUMN_names as $COLUMN)	{

				$VALUE	=	'';

				if ($this->FILTER_type[$COLUMN]=='none') $this->ROW_FILTER .= '<td></td>'."\n";

				if (($this->FILTER_type[$COLUMN] == 'box') or ($this->FILTER_type[$COLUMN] == 'date'))	{

					if ($this->FILTER_type[$COLUMN] == 'date')	{

						if ($this->FILTER_state[$COLUMN])	{

							$DATE	=	explode('/', $this->FILTER_state[$COLUMN]);

							if ($DATE[0] != '-') {$DATE[0]='d'.$DATE[0];} else {$DATE[0]='';}
							if ($DATE[1] != '-') {$DATE[1]='m'.$DATE[1];} else {$DATE[1]='';}
							if ($DATE[2] != '-') {$DATE[2]='y'.$DATE[2];} else {$DATE[2]='';}

							$VALUE	= $DATE[0].$DATE[1].$DATE[2];
						}

					}	else	{

						$VALUE	= $this->FILTER_state[$COLUMN];
					}
						
					$this->ROW_FILTER .= "<td>\n<input class=\"filter-input\" maxlength=\"40\" name=\"$COLUMN\" value=\"$VALUE\" onkeypress=\"return nextfield(this,event, 'FILTER');\">\n</td>\n";

					unset($DATE);
				}
			}
		
			$this->ROW_FILTER .= "</tr>\n";
		}

		public function FORMCOMMAND()	{

			if (! $this->COMMAND)	{

				$SEARCH	=	'';

				if ($this->FILTER_state['employeename'] !== FALSE) 	$SEARCH .= " AND inventory_header.employeeID IN (SELECT `employeeID` FROM $this->BASE.employees WHERE `employeename` REGEXP '".$this->SQL->s_escape($this->FILTER_state['employeename'], 'REGEXP')."') ";
	
				if ($this->FILTER_state['code'] !== FALSE) 		$SEARCH	.= " AND inventory_data.stockID IN (SELECT `personID` FROM $this->STOCKBASE.$this->STOCKTABLE WHERE `code` REGEXP '".$this->SQL->s_escape($this->FILTER_state['code'], 'REGEXP')."') ";

				if ($this->FILTER_state['inventoryID'] !== FALSE) 	$SEARCH	.= " AND inventory_data.inventoryID='".$this->SQL->escape($this->FILTER_state['inventoryID'])."' ";

				if ($this->FILTER_state['date_of_creation'] !== FALSE)	{

					$DATE	= 	explode('/', $this->FILTER_state['date_of_creation']);

					$DATESEARCH	=	'';

					if ($DATE[0]!='-') $DATESEARCH	.=	" AND DAY(date_of_creation)=".$DATE[0].' ';

					if ($DATE[1]!='-') $DATESEARCH	.=	" AND MONTH(date_of_creation)=".$DATE[1].' ';

					if ($DATE[2]!='-') $DATESEARCH	.=	" AND YEAR(date_of_creation)=".$DATE[2].' ';

					unset($DATE);

					$SEARCH .= " AND inventory_data.inventoryID IN (SELECT `personID` FROM $this->BASE.inventory_header WHERE `deleted` IS NOT NULL $DATESEARCH )";
				}

				$this->COMMAND = "	SELECT SQL_CALC_FOUND_ROWS 	inventory_data.inventoryID, 
											DATE_FORMAT(inventory_header.date_of_creation, '$this->FORMAT') AS `date_of_creation`,
											employees.employeename, 
											$this->STOCKTABLE.code,
											inventory_data.quantity_before, 
											inventory_data.quantity_after
							FROM $this->BASE.inventory_data 
							INNER JOIN $this->BASE.inventory_header
							ON $this->BASE.inventory_data.inventoryID=$this->BASE.inventory_header.personID
							INNER JOIN $this->STOCKBASE.$this->STOCKTABLE
							ON inventory_data.stockID=$this->STOCKTABLE.personID
							INNER JOIN $this->BASE.employees
							ON $this->BASE.inventory_header.employeeID=$this->BASE.employees.personID
							WHERE 	inventory_data.inventoryID IN (	SELECT `personID` 
												FROM $this->BASE.inventory_header
												WHERE `stock`='$this->STOCKTABLE' AND `deleted` IS NOT NULL )
								AND inventory_header.deleted IS NOT NULL
								AND inventory_data.deleted IS NOT NULL 
								AND employees.deleted is NOT NULL
								AND $this->STOCKTABLE.deleted IS NOT NULL ".$SEARCH.' ORDER BY inventory_data.inventoryID, inventory_data.personID ';

				$_SESSION['COMMAND'] = $this->COMMAND;
			}

			$LIMIT			=	' LIMIT '.($this->PAGE * $this->INC).', '.$this->INC;

			$_SESSION['LIMIT']	=	$LIMIT;

			$this->COMMAND		.=	$LIMIT;
		}

		/**
		 * Count the pages
		 */

		private function PAGECOUNT()	{

			if (! $this->WHOLE) return;

			if ($this->WHOLE < $this->INC)	{

				$this->PAGENUM	=	0;

			}	else 	{ 

				if ($this->WHOLE % $this->INC==0) {$correct=1;} else {$correct=0;}

				$this->PAGENUM = floor($this->WHOLE / $this->INC)-$correct;
			}

			unset($this->WHOLE);
		}

		/**
		 * Fetch query result to table
		 */

		private function TABLEBODY()	{

			$this->SQL->query($this->COMMAND);

			$this->WHOLE = $this->SQL->calc_rows();

			if (! $this->WHOLE)	{

				$SPAN	=	count($this->COLUMN_names) + 2;
				$ERRTXT	=	$this->LANG->get('noresult');	

				$this->TABLE_BODY .= "<tr><td class=\"link\" colspan=\"$SPAN\">$ERRTXT</td></tr>\n";

				return;
			}
	
			$this->PAGECOUNT();

			$CLASS		=	'list-dark';


			$this->SQL->IT1_RESULT = $this->SQL->RESULT;

			while ($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

				if ($CLASS=='list-dark')	{$CLASS = 'list-light';} else {$CLASS = 'list-dark';}

				$this->TABLE_BODY .= "<tr class=\"$CLASS\" onmouseover=\"Javascript: mark(this);\" onmouseout=\"Javascript: unmark(this);\">\n";

				foreach ($this->COLUMN_names as $COLUMN)	{

					$VALUE = $RESULT[$COLUMN];

					$this->TABLE_BODY .= "<td><input class=\"list-input\" style=\"width: ".$this->BOX->size($COLUMN)."px;\" readonly value=\"$VALUE\"></td>\n";
				}

				$this->TABLE_BODY .= 	"<td class=\"link\" colspan=\"2\">\n";


				$this->TABLE_BODY .= "</td>\n</tr>\n";
			}

			unset($this->SQL->IT1_RESULT);

			$this->SQL->free();
		}

		/**
		 * Read posts and set filter states
		 */

		private function GETPOST()	{

			if (isset($_GET['new']))	{

				$_SESSION['LISTPAGE']	=	0;

				if (isset($_SESSION['FILTERS'])) unset($_SESSION['FILTERS'], $_SESSION['COMMAND'], $_SESSION['LIMIT']);

				return;
			}

			if (isset($_GET['page']))	{

				$this->PAGE = $_SESSION['LISTPAGE'] = (integer)$_GET['page'];

			}	else	  {

				$this->PAGE = $_SESSION['LISTPAGE'];
			}

			if (isset($_POST['FILTER']))	{

				$this->PAGE = $_SESSION['LISTPAGE'] = 0;

				foreach ($this->COLUMN_names as $COLUMN)	{

					if ((isset($_POST[$COLUMN])) && (! is_empty($_POST[$COLUMN])))	{

						if ($this->FILTER_type[$COLUMN]=='date')	{

							if (! function_exists('date2search')) load_f('date2search');

							$this->FILTER_state[$COLUMN] = date2search($_POST[$COLUMN], $this->LANG->get('datesearchdaysign'), $this->LANG->get('datesearchmonthsign'), $this->LANG->get('datesearchyearsign'));

						}	else	  {

							$this->FILTER_state[$COLUMN] = $_POST[$COLUMN];
						}
					}
				}

				$_SESSION['FILTERS'] = $this->FILTER_state;

			}	else	 {

				if (isset($_SESSION['FILTERS'])) $this->FILTER_state 	=	$_SESSION['FILTERS'];
			}
		}

		/**
		 * Displays the table;
		 */

		public function create()	{

			$this->GETPOST();

			$this->TABLEHEADER();

			$this->TABLEFILTERS();

			$this->FORMCOMMAND();

			$this->TABLEBODY();
			
			$this->TABLE = "<div class=\"border\">\n<div class=\"padding-list\">\n<table id=\"data\" class=\"list\">\n$this->ROW_LABEL $this->ROW_FILTER $this->TABLE_BODY\n</table>\n</div>\n</div>\n";

			if (isset($this->PAGENUM)) $this->TABLE = $this->TABLE.pagination($this->PAGE, $this->PAGENUM, $this->INC, backward());

			unset($this->ROW_LABEL, $this->ROW_FILTER, $this->TABLE_BODY);
		}
	}
?>
