<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag create table of not billed services lists and deliverys
	 */

	load_f('pagination');
	load_f('mb_wrap');

	class NOTBILLEDLIST	{

		var $COLUMN_names	=	array(	'personID', 'datatype', 'contactname', 'city', 'contacttype', 'date_of_creation', 'payment_form' );

		var $COLUMN_names_AS	=	array();

		var $FILTER_type	=	array(	'personID'=>'box', 'datatype'=>'listbox', 'contactname'=>'box', 'city'=>'none', 'contacttype'=>'listbox', 'date_of_creation'=>'date', 'payment_form'=>'listbox' );

		var $TABLE		=	'';
		var $ROW_FILTER		=	'';
		var $ROW_LABEL		=	'';
		var $TABLE_BODY		=	'';
		var $COLUMNS		=	FALSE;
		var $PAGE		=	0;
		var $WHOLE		=	FALSE;
		var $SORT		=	'cadc8c8db42409733582cb3e2298ef87';
		var $COMMAND		=	'';

		function __construct($INCREMENT)	{

			$this->INC		=	$INCREMENT;
			$this->BASE		=	$_SESSION['BASE'];
			$this->STOCKBASE	=	'ebagstock';

			global $__SQL, $__LANG, $__CONF, $__BOX;

			$this->SQL		=	&$__SQL;
			$this->LANG		=	&$__LANG;
			$this->BOX		=	&$__BOX;
			$this->FORMAT		=	$__CONF->get('date', 'sql_format');
			$this->APC		=	$__CONF->get('cache', 'use_apc_cache');
			$this->ORDERBY		=	'';
			$this->CONTACT_TYPES	=	array($this->LANG->get("type0"), $this->LANG->get("type1"));
			
			$this->DATA_TYPES	=	array('servicelist'=>$this->LANG->get('servicelist'), 'delivery'=>$this->LANG->get('deliverynote'));

			unset($_SESSION['ID']);

			foreach ($this->COLUMN_names as $COLUMN) 	{

				$this->FILTER_state[$COLUMN]	=	FALSE;
				$this->COLUMN_names_AS[$COLUMN] = 	$this->LANG->get($COLUMN);
			}
		}

		/**
		 * Create table row with column names
		 */

		private function TABLEHEADER()	{

			$this->ROW_LABEL	.=	'<tr class="list-column-names">'."\n";

			foreach ($this->COLUMN_names_AS as $key=>$COLUMN)	{

				if ($key == 'personID') {$CLASS='class="personID-name"';} else {$CLASS='class="column-names"';}

				$this->ROW_LABEL .= "<td $CLASS>".mb_wrap($COLUMN, 7, '<br>')."</td>\n";

			}

			$this->ROW_LABEL	.=	'<td class="filters" rowspan="2">'."\n"
						 	.'<input class="button-list" type="submit" name="FILTER" value="'.$this->LANG->get('filter').'">'."\n"
							.'</td><td class="filters" rowspan="2">'."\n"
							.'<div id="print" class="list-print-div-hide">'."\n"
							.'<a class="print-link" target="_blank" href="../controllers/print.php?id=view" onclick="Javascript: printhide()">'.$this->LANG->get('printview').'</a>&nbsp;&nbsp;&nbsp;'
							.'<a class="print-link" target="_blank" href="../controllers/print.php?id=all" onclick="Javascript: printhide()">'.$this->LANG->get('printall').'</a></div>'
						 	.'<input class="button-print" type="button" value="'.$this->LANG->get('PRINT_B').'" onclick="Javascript: printmenu();">'."\n"
							.'</td>'."\n";

			$this->ROW_LABEL	.=	'</tr>'."\n";
		}
		
		/**
		 * Adds filter to order by clausule
		 */

		private function addorderby($FILTER)	{

			if (! $this->ORDERBY)	{$AND =	' ORDER BY ';} else {$AND = ' , ';}

			$this->ORDERBY .= "$AND $FILTER";
		}

		/**
		 * Create tabe row with filters
		 */

		private function TABLEFILTERS()	{

			$this->ROW_FILTER	.=	'<tr class="list-filters">'."\n";

			foreach ($this->COLUMN_names as $COLUMN)	{

				$VALUE	=	'';

				if ($this->FILTER_type[$COLUMN]=='none') $this->ROW_FILTER .= '<td></td>'."\n";

				# Adds listbox (note: simplies version only to use in this class)

				if ($this->FILTER_type[$COLUMN]=='listbox')	{

						$STYLE = 'style="width : '.$this->BOX->size($COLUMN).'px;"';

						$this->ROW_FILTER .=	"<td>\n<select $STYLE name=\"$COLUMN\">\n";

						# the all will be empty=>false

						if ($this->FILTER_state[$COLUMN]===FALSE)	{$selected='selected';}	else {$selected='';}

						$this->ROW_FILTER .= "<option $selected value=\"\">".$this->LANG->get('all')."</option>\n";

						if ($this->FILTER_state[$COLUMN] == $this->SORT)  {$selected='selected';} else {$selected='';}

						$this->ROW_FILTER .= "<option $selected value=\"$this->SORT\">".$this->LANG->get('sort')."</option>\n";

						if ($COLUMN == 'payment_form')	{

							$TYPES	= $this->PAYMENT_TYPES;

						} elseif($COLUMN == 'datatype')	   {

							$TYPES	= $this->DATA_TYPES;
							
						}	else 	{
												
							$TYPES	= $this->CONTACT_TYPES;	
						}

						foreach ($TYPES as $VALUE=>$TXT)	{

							if (($this->FILTER_state[$COLUMN]!==FALSE) && ($this->FILTER_state[$COLUMN]=="$VALUE")) {$selected='selected';} else {$selected = '';}

							$this->ROW_FILTER .= "<option $selected value=\"$VALUE\">$TXT</option>\n";
						}

						$this->ROW_FILTER .=  "</select>\n</td>\n";
				}

				# Adds box or date box

				if (($this->FILTER_type[$COLUMN] == 'box') or ($this->FILTER_type[$COLUMN] == 'date'))	{

					if ($this->FILTER_type[$COLUMN] == 'date')	{

						if ($this->FILTER_state[$COLUMN])	{

							$DATE	=	explode('/', $this->FILTER_state[$COLUMN]);

							if ($DATE[0] != '-') {$DATE[0]='d'.$DATE[0];} else {$DATE[0]='';}
							if ($DATE[1] != '-') {$DATE[1]='m'.$DATE[1];} else {$DATE[1]='';}
							if ($DATE[2] != '-') {$DATE[2]='y'.$DATE[2];} else {$DATE[2]='';}

							$VALUE	= $DATE[0].$DATE[1].$DATE[2];
						}

					}	else	{

						$VALUE	= $this->FILTER_state[$COLUMN];

					}
						
					if ($COLUMN == 'orderID') {$CLASS = 'filter-input-mini';} else {$CLASS = 'filter-input';}

					$this->ROW_FILTER .= "<td>\n<input class=\"$CLASS\" maxlength=\"40\" name=\"$COLUMN\" value=\"$VALUE\" onkeypress=\"return nextfield(this,event, 'FILTER');\">\n</td>\n";

					unset($DATE);
				}
			}
		
			$this->ROW_FILTER .= "</tr>\n";
		}

		private function FORMCOMMAND()	{

			# note: because of temporary tables the command must be form always

			# create temporary tables

			$_SESSION['TEMPTABLE1'] ="	(	SELECT 	('delivery') AS `datatype`, `personID`, `contactname`, `city`, `contacttype`, `date_of_creation`, `payment_form` 
								FROM $this->BASE.deliverys_header
								WHERE `billID` IS NULL AND `deleted` IS NOT NULL
							)
							UNION ALL
							(
								SELECT 	('servicelist') AS `datatype`, `personID`, `contactname`, `city`, `contacttype`, `date_of_creation`, `payment_form`
								FROM $this->BASE.services_header
								WHERE `billID` IS NULL AND `date_of_finishing` IS NOT NULL AND `deleted` IS NOT NULL
							) 
							ORDER BY `contactname`, `personID`	";

			$_SESSION['TEMPTABLE1']	=	"CREATE TEMPORARY TABLE $this->BASE.temptable ".$_SESSION['TEMPTABLE1'];

			$this->SQL->query($_SESSION['TEMPTABLE1']);

			# form search

			$SEARCH		=	'';

			if ($this->FILTER_state['personID']!==FALSE)  	$SEARCH .= " AND personID='".($this->SQL->s_escape($this->FILTER_state['personID']))."' ";
			
			if ($this->FILTER_state['contactname']!==FALSE) $SEARCH .= " AND contactname REGEXP '".($this->SQL->s_escape($this->FILTER_state['contactname'], 'REGEXP'))."' ";

			if ($this->FILTER_state['date_of_creation']!==FALSE)	{

				$DATE	= 	explode('/', $this->FILTER_state['date_of_creation']);

				if ($DATE[0]!='-') $SEARCH	.=	" AND DAY(date_of_creation)=".$DATE[0].' ';

				if ($DATE[1]!='-') $SEARCH	.=	" AND MONTH(date_of_creation)=".$DATE[1].' ';

				if ($DATE[2]!='-') $SEARCH	.=	" AND YEAR(date_of_creation)=".$DATE[2].' ';

				unset($DATE);
			}
			
			foreach (array('datatype', 'contacttype', 'payment_form') as $COLUMN)	{
			
				if ($this->FILTER_state[$COLUMN]!==FALSE) {
			
					if ($this->FILTER_state[$COLUMN] == $this->SORT)	{

						$this->addorderby($COLUMN);
					
					}	else	  {
				
						$SEARCH .= " AND `$COLUMN`='".($this->SQL->s_escape($this->FILTER_state[$COLUMN]))."' ";
					}
				}
			}

			# final query
			
			if (! $this->ORDERBY) $this->addorderby('date_of_creation');

			$_SESSION['COMMAND']	=	$this->COMMAND	= "	SELECT SQL_CALC_FOUND_ROWS 
											`personID`, `datatype`, `contactname`, `city`, `contacttype`,
											DATE_FORMAT(`date_of_creation`, '$this->FORMAT') AS `date_of_creation`,
											`payment_form`
										FROM $this->BASE.temptable 
										WHERE `personID` IS NOT NULL ".$SEARCH.$this->ORDERBY;
										

			$LIMIT			=	' LIMIT '.($this->PAGE * $this->INC).', '.$this->INC;

			$_SESSION['LIMIT']	=	$LIMIT;

			$this->COMMAND		.=	$LIMIT;
		}

		/**
		 * Count the pages
		 */

		private function PAGECOUNT()	{

			if (! $this->WHOLE) return;

			if ($this->WHOLE < $this->INC)	{

				$this->PAGENUM	=	0;

			}	else 	{ 

				if ($this->WHOLE % $this->INC==0) {$correct=1;} else {$correct=0;}

				$this->PAGENUM = floor($this->WHOLE / $this->INC)-$correct;
			}

			unset($this->WHOLE);
		}

		/**
		 * Fetch query result to table
		 */

		private function TABLEBODY()	{

			$this->SQL->query($this->COMMAND);

			$this->WHOLE = $this->SQL->calc_rows();

			if (! $this->WHOLE)	{

				$SPAN	=	count($this->COLUMN_names) + 2;
				$ERRTXT	=	$this->LANG->get('noresult');	

				$this->TABLE_BODY .= "<tr><td class=\"link\" colspan=\"$SPAN\">$ERRTXT</td></tr>\n";

				return;
			}
	
			$this->PAGECOUNT();

			$CLASS		=	'list-dark';
			$DETAILS	=	$this->LANG->get('details');
			$BILL		=	$this->LANG->get('bill');

			while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{

				if ($CLASS=='list-dark')	{$CLASS = 'list-light';} else {$CLASS = 'list-dark';}

				$this->TABLE_BODY .= "<tr class=\"$CLASS\" onmouseover=\"Javascript: mark(this);\" onmouseout=\"Javascript: unmark(this);\">\n";

				foreach ($this->COLUMN_names as $COLUMN)	{

					$VALUE = $RESULT[$COLUMN];

					switch ($COLUMN)	{

						case('personID')		:	$personID	=	$VALUE;

											break;

						case('datatype')		:	$DETAILSLINK	=	$VALUE."details&amp;id=$personID";
											$BILL_LINK	=	"bill_by_id&amp;id=$personID&amp;type=$VALUE";

											$VALUE		=	$this->DATA_TYPES[$VALUE];

											break;

						case ('payment_form')		:	if (isset($this->PAYMENT_TYPES[$VALUE])) $VALUE = $this->PAYMENT_TYPES[$VALUE];
							
											break;
											
						case ('contacttype')		:	if (isset($this->CONTACT_TYPES[$VALUE])) $VALUE = $this->CONTACT_TYPES[$VALUE];
							
											break;


					}

					$this->TABLE_BODY .= "<td><input class=\"list-input\" style=\"width: ".$this->BOX->size($COLUMN)."px;\" readonly value=\"$VALUE\"></td>\n";
				}

				$this->TABLE_BODY .= 	"<td class=\"link\" colspan=\"3\">\n"
							."<a class=\"list-link\" href=\"loader.php?cat=$DETAILSLINK\">$DETAILS</a>&nbsp;&nbsp;&nbsp;\n"
							."<a class=\"list-link\" href=\"loader.php?cat=$BILL_LINK\">$BILL</a>&nbsp;&nbsp;&nbsp;\n"
							."</td>\n";
				$this->TABLE_BODY .= "</tr>\n";
			}

			$this->SQL->free();
		}


		private function GETPOST()	{

			if (isset($_GET['new']))	{

				$_SESSION['LISTPAGE']	=	0;

				if (isset($_SESSION['FILTERS'])) unset($_SESSION['FILTERS'], $_SESSION['COMMAND'], $_SESSION['LIMIT']);

				return;
			}

			if (isset($_GET['page']))	{

				$this->PAGE = $_SESSION['LISTPAGE'] = (integer)$_GET['page'];

			}	else	  {

				$this->PAGE = $_SESSION['LISTPAGE'];
			}

			if (isset($_POST['FILTER']))	{

				$this->PAGE = $_SESSION['LISTPAGE'] = 0;

				foreach ($this->COLUMN_names as $COLUMN)	{

					if ((isset($_POST[$COLUMN])) && (! is_empty($_POST[$COLUMN])))	{

						if ($this->FILTER_type[$COLUMN]=='date')	{

							if (! function_exists('date2search')) load_f('date2search');

							$this->FILTER_state[$COLUMN] = date2search($_POST[$COLUMN], $this->LANG->get('datesearchdaysign'), $this->LANG->get('datesearchmonthsign'), $this->LANG->get('datesearchyearsign'));

						}	else	  {

							$this->FILTER_state[$COLUMN] = $_POST[$COLUMN];
						}
					}
				}

				$_SESSION['FILTERS'] = $this->FILTER_state;

			}	else	 {

				if (isset($_SESSION['FILTERS'])) $this->FILTER_state 	=	$_SESSION['FILTERS'];
			}
		}
		
		/**
		 * Read additional array from base
		 */
		
		private function READARRAYS()	{
		
			$__PAYMENTS = new PAYMENTloader($this->APC);

			$this->PAYMENT_TYPES = $__PAYMENTS->getnames();
		}

		/**
		 * Displays the table;
		 */

		public function create()	{

			$_SESSION['DROPTABLE1']	= "DROP TEMPORARY TABLE IF EXISTS $this->BASE.temptable";

			$this->SQL->query($_SESSION['DROPTABLE1']);
			
			$this->READARRAYS();

			$this->GETPOST();

			$this->TABLEHEADER();

			$this->TABLEFILTERS();

			$this->FORMCOMMAND();

			$this->TABLEBODY();
			
			$this->TABLE = "<div class=\"border\">\n<div class=\"padding-list\">\n<table id=\"data\" class=\"list\">\n$this->ROW_LABEL $this->ROW_FILTER $this->TABLE_BODY\n</table>\n</div>\n</div>\n";

			if (isset($this->PAGENUM)) $this->TABLE = $this->TABLE.pagination($this->PAGE, $this->PAGENUM, $this->INC, backward());

			unset($this->ROW_LABEL, $this->ROW_FILTER, $this->TABLE_BODY);

			$this->SQL->query($_SESSION['DROPTABLE1']);
		}
	}
?>
