<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag suplie usage (list of connected request)
	 */

	load_f('mb_wrap');
	
	load_f('pagination');

	class SUPLIEUSAGE	{

		var $COLUMN_names	=	array( 'personID', 'date_of_creation', 'employeeID', 'quantity', 'unit' );

		var $COLUMN_names_AS	=	array();

		var $TABLE		=	'';
		
		var $COMMAND		=	'';
		
		var $PAGE		=	0;

		function __construct($INCREMENT, $LIMIT, $ID)	{

			global $__SQL, $__CONF, $__LANG, $__BOX;
			
			$this->INC	=	$INCREMENT;

			$this->LIMIT	=	$LIMIT;

			$this->ID	=	$ID;
			
			$this->SQL	=	&$__SQL;

			$this->FORMAT	=	$__CONF->get('date', 'sql_format');

			$this->LANG	=	&$__LANG;

			$this->BOX	=	&$__BOX;

			$this->BASE	=	$_SESSION['BASE'];


			if (isset($_SESSION['year_is_closed']))	{

				$this->STOCKBASE = $_SESSION['BASE'];

			}	else	  {

				$this->STOCKBASE = 'ebagstock';
			}

			foreach ($this->COLUMN_names as $COLUMN) 	{
			
				if ($COLUMN == 'employeeID')	{
				
				      $this->COLUMN_names_AS[$COLUMN] = $this->LANG->get('creator');
				
				      continue;
				}

				$this->COLUMN_names_AS[$COLUMN] = $this->LANG->get($COLUMN);
			}
		}

		/**
		 * Read supply data for print
	 	 */

		private function readsuplie($ID)	{

			$this->SQL->query("	SELECT `code`, `supliename` as `name`, `unit`
						FROM $this->STOCKBASE.operating_suplies
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows()) return FALSE;

			$this->SUPLIEDATA	=	$this->SQL->RESULT->fetch_assoc();

			$this->CODE		=	$this->SQL->r_escape($this->SUPLIEDATA['code']);

			return TRUE;
		}
		
		/**
		 * Adds limit to command
	 	 */

		public function FORMCOMMAND()	{
		
			# this command is not set as session
			# to not overwrite previous list

			$this->COMMAND 	= "	SELECT	suplie_request_header.personID, 
						      DATE_FORMAT(suplie_request_header.date_of_creation, '$this->FORMAT') AS `date_of_creation`,
						      suplie_request_header.employeeID,
						      suplie_request_data.quantity, suplie_request_data.unit
						FROM $this->BASE.suplie_request_header 
						      INNER JOIN $this->BASE.suplie_request_data
						      ON suplie_request_header.personID = suplie_request_data.requestID
						WHERE suplie_request_data.code='$this->CODE' 
						      AND suplie_request_header.deleted IS NOT NULL 
						      AND suplie_request_data.deleted IS NOT NULL	
						ORDER BY suplie_request_header.personID 	"
					.'	LIMIT '.($this->PAGE * $this->INC).', '.$this->INC;
		}
		
		/**
		 * Create table header row
		 */
		 
		private function TABLEHEADER()	{
		
			$this->ROW_LABEL = '<tr class="list-column-names">'."\n";

			foreach ($this->COLUMN_names_AS as $key=>$COLUMN)	{

				if ($key == 'personID') {$CLASS='class="personID-name"';} else {$CLASS='class="column-names"';}

				$this->ROW_LABEL .= "<td $CLASS height=\"35\">".mb_wrap($COLUMN, 7, '<br>')."</td>\n";

			}
			
			$this->ROW_LABEL .= "</tr>\n";
		}

		/**
		 * Count the pages
		 */

		private function PAGECOUNT()	{

			if (! $this->WHOLE) return;

			if ($this->WHOLE < $this->INC)	{

				$this->PAGENUM	=	0;

			}	else	  { 

				if ($this->WHOLE % $this->INC==0) {$correct=1;} else {$correct=0;}

				$this->PAGENUM	=	floor($this->WHOLE / $this->INC)-$correct;
			}

			unset($this->WHOLE);
		}

		/**
		 * Fetch query result to table
		 */

		private function TABLEBODY()	{
		
			$this->SQL->query($this->COMMAND);

			$this->WHOLE = $this->SQL->calc_rows();

			if (! $this->WHOLE) return FALSE;
			
			$this->PAGECOUNT();

			$CLASS	= 'list-dark';
			
			$this->SQL->IT1_RESULT = $this->SQL->RESULT;
			
			$SUM = 0;

			while ($IT1_RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

				if ($CLASS=='list-dark') {$CLASS = 'list-light';} else {$CLASS = 'list-dark';}

				$this->TABLE_BODY .= "<tr class=\"$CLASS\" onmouseover=\"Javascript: mark(this);\" onmouseout=\"Javascript: unmark(this);\">\n";

				foreach ($this->COLUMN_names as $COLUMN)	{

					$VALUE = $IT1_RESULT[$COLUMN];

					if ($COLUMN == 'employeeID')	{
					
						$this->SQL->query("	SELECT `employeename` 
									FROM $this->BASE.employees
									WHERE `personID`='$VALUE' LIMIT 1	");
									
						if ($this->SQL->num_rows())	{
						
							$RESULT = $this->SQL->RESULT->fetch_row();
							
							$VALUE = $RESULT[0];
							
							# change columname to get correct box width
							
							$COLUMN = 'employeename';
						}
					}
					
					if ($COLUMN == 'quantity') $SUM += $VALUE;

					$this->TABLE_BODY .= "<td><input class=\"list-input\" style=\"width: ".$this->BOX->size($COLUMN)."px;\" readonly value=\"$VALUE\"></td>\n";
				}

				$this->TABLE_BODY .=	"</tr>\n";
			}
			
			$this->SUPLIEDATA['sum'] = $SUM;

			unset($this->SQL->IT1_RESULT);

			$this->SQL->free();
			
			return TRUE;
		}
		
		/**
		 * Displays the table;
		 */

		public function create()	{
		
			if (! $this->readsuplie($this->ID)) return 'unexistentfeedstock';

			if (isset($_GET['page'])) $this->PAGE = (integer)$_GET['page'];

			$this->FORMCOMMAND();

			$this->TABLEHEADER();
			
			if (! $this->TABLEBODY()) return 'nosuplieusage';
			
			$this->TABLE = "<div class=\"border\">\n<div class=\"padding-list\">\n<table id=\"data\" class=\"list\">\n$this->ROW_LABEL $this->TABLE_BODY\n</table>\n</div>\n</div>\n";

			if (isset($this->PAGENUM)) $this->TABLE .= pagination($this->PAGE, $this->PAGENUM, $this->INC, backward().'&amp;id='.$this->ID);

			unset($this->ROW_LABEL, $this->TABLE_BODY);
			
			return TRUE;
		}
	}
?>
