<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag suplie request print
	 */

	load_f('id_explode');

	class SUPLIE_REQUESTPRINT	{

		function __construct()	{

			global $__SQL, $__LANG, $__CONF;

			$this->SQL	=	&$__SQL;

			$this->LANG	=	&$__LANG;

			$this->BASE	=	$_SESSION['BASE'];

			$this->FORMAT	=	$__CONF->get('date', 'sql_format');
			
			$this->FONT_FAMILY = 	$__CONF->get('font', 'family');
			
			$this->FONT_N_FILE = 	$__CONF->get('font', 'normal_font_file');
			
			$this->FONT_B_FILE = 	$__CONF->get('font', 'bold_font_file');
			
			if ($this->FONT_B_FILE) {$this->BOLD = 'B';} else {$this->BOLD = '';}
		}

		public function year($YEAR=FALSE)	{

			if ($YEAR) $this->BASE = "ebagdata$YEAR";
		}

		private function lock()	{

			$this->SQL->query(" LOCK TABLES	$this->BASE.suplie_request_header WRITE, 
						        $this->BASE.suplie_request_data WRITE,
							$this->BASE.employees WRITE ");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		private function setpage()	{

			if ($this->FONT_N_FILE) $this->PDF->AddFont($this->FONT_FAMILY,'',$this->FONT_N_FILE,true);
			if ($this->FONT_B_FILE) $this->PDF->AddFont($this->FONT_FAMILY,$this->BOLD,$this->FONT_B_FILE,true);

			$this->PDF->AliasNbPages();

			$this->PDF->SetCreator('eBag-TFPDF');
			$this->PDF->SetSubject($this->LANG->get('suplie_request'));
			$this->PDF->SetTitle($this->LANG->get('suplie_request'));

			$this->PDF->SetTextColor(0);
			$this->PDF->SetDrawColor(0);
			$this->PDF->SetFillColor(255);
			$this->PDF->SetMargins(12, 10, 10, 10);
		}

		private function tableheader()	{

			$this->PDF->SetFillColor(204, 204, 204);
		
			$this->PDF->SetFont($this->FONT_FAMILY, $this->BOLD, 7);
		
			$this->PDF->eCell(10, 6, $this->LANG->get('personID'), 1, 0, 'C', 1);
			$this->PDF->eCell(39, 6, $this->LANG->get('code'), 1, 0, 'C', 1);
			$this->PDF->eCell(92, 6, $this->LANG->get('feedstockname'), 1, 0, 'C', 1);
			$this->PDF->eCell(22, 6, $this->LANG->get('quantity_short'), 1, 0, 'C', 1);
			$this->PDF->eCell(22, 6, $this->LANG->get('unit_short'), 1, 0, 'C', 1);
			$this->PDF->Ln(6);	
			
			$this->PDF->SetFont($this->FONT_FAMILY, '', 7);
		}

		private function createpage($ID)	{

			$this->PDF->AddPage();

			$this->PDF->PAGE_NUMBER = 1;

			$this->SQL->query("	SELECT DATE_FORMAT(`date_of_creation`, '$this->FORMAT') AS `date_of_creation`, `employeeID`
						FROM $this->BASE.suplie_request_header
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1"	);
						
			if (! $this->SQL->num_rows()) return 0;

			$HEADER = $this->SQL->RESULT->fetch_assoc();
			
			$employeeID = $HEADER['employeeID'];
			
			$this->SQL->query("	SELECT `employeename`
						FROM $this->BASE.employees
						WHERE `personID`='$employeeID' AND `deleted` IS NOT NULL LIMIT 1"	);
						
			if ($this->SQL->num_rows())	{
			
				$RESULT = $this->SQL->RESULT->fetch_row();
				
				$HEADER['employeename'] = $RESULT[0];
				
			}	else	  {
			
				$HEADER['employeename'] = '';
			}
			
			unset($HEADER['employeeID'], $employeeID);

			$this->PDF->PAGE_TITLE = $this->LANG->get('suplierequestnumber_pdf', "$ID/".str_replace('ebagdata', '', $this->BASE));

			$this->PDF->Ln(6);
			$this->PDF->SetFont($this->FONT_FAMILY,$this->BOLD,10);
			$this->PDF->eCell(0, 0, $this->PDF->PAGE_TITLE, 0, 0, 'L', 0);
			$this->PDF->Ln(10);
			$this->PDF->SetFont($this->FONT_FAMILY,'',9);
			$this->PDF->eCell(0, 0, $this->LANG->get('date_of_creation').': '.$HEADER['date_of_creation'], 0, 0, 'L', 0);
			$this->PDF->Ln(6);
			$this->PDF->eCell(0, 0, $this->LANG->get('creator').': '.$HEADER['employeename'], 0, 0, 'L', 0);
			$this->PDF->Ln(10);

			$this->PDF->SetFont($this->FONT_FAMILY,'',7);

			$this->SQL->query("	SELECT `code`, `name`, `quantity`, `unit`
						FROM $this->BASE.suplie_request_data
						WHERE `requestID`='$ID' AND `deleted` IS NOT NULL ORDER BY `personID` ");

			$NUM_ROWS	=	$this->SQL->num_rows();
			
			if (! $NUM_ROWS) return FALSE;

			$LINE_NO = 0;
	
			while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{

				# convert

				$CODE		=	htmlspecialchars_decode($RESULT['code'], ENT_COMPAT);
				$NAME		=	htmlspecialchars_decode($RESULT['name'], ENT_COMPAT);
				$UNIT		=	htmlspecialchars_decode($RESULT['unit'], ENT_COMPAT);

				$QUANTITY	=	$RESULT['quantity'];

				if (! $LINE_NO) $this->tableheader();

				$this->PDF->eCell(10, 6, ' '.($LINE_NO+1), 'LR', 0, 'L', 0);	
				$this->PDF->eCell(39, 6, " $CODE", 'LR', 0, 'L', 0);
				$this->PDF->eCell(92, 6, " $NAME", 'LR', 0, 'L', 0);
				$this->PDF->eCell(22, 6, " $QUANTITY", 'LR', 0, 'L', 0);
				$this->PDF->eCell(22, 6, " $UNIT",'LR', 0, 'L', 0);
				$this->PDF->Ln(6);

				$LINE_NO++;

				$Y_COORD = $this->PDF->GetY();

				if (($this->PDF->h-$Y_COORD <= 30) && ($NUM_ROWS != $LINE_NO))	{

					$this->PDF->eCell(185, 6, '', 'T', 0, 'C', 0);
					$this->PDF->AddPage();
					$this->tableheader();
				}

				if ($NUM_ROWS == $LINE_NO)	{

					$this->PDF->eCell(185, 6, '', 'T', 0, 'C', 0); 
					$this->PDF->Ln(10);
				}
			}

			# print row for signature

			$this->PDF->Ln(12);

			$this->PDF->eSetX(27);
			$this->PDF->eCell(40, 6, $this->LANG->get('requestcreatedby'), 'T', 0, 'C', 0);
			$this->PDF->eSetX(143);
			$this->PDF->eCell(40, 6, $this->LANG->get('itemrecipient'), 'T', 0, 'C', 0);
			
			return TRUE;
		}

		public function pdfprint($ID_s)	{

			# create usable array

			if (! $ID_s = id_explode($ID_s)) return FALSE;

			# first check te gived base exists or not

			$this->SQL->query("	SELECT SCHEMA_NAME FROM INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME = '$this->BASE'");

			if (! $this->SQL->num_rows()) return FALSE;

			# check existens

			$this->IDs	=	array();

			foreach ($ID_s as $ID)	{

				$this->SQL->query("	SELECT `personID`
							FROM $this->BASE.suplie_request_header
							WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

				if ($this->SQL->num_rows()) $this->IDs[] = $ID;
			}

			if (! count($this->IDs)) return FALSE;

			# set time limit

			set_time_limit(0);

			# create object

			$this->PDF = new ePDF('P','mm','A4');
			
			if (defined('TEXT_DIRECTION') && (TEXT_DIRECTION == 'rtl')) $this->PDF->RTL = TRUE;

			# sets elementary page data

			$this->setpage();
			
			$printed = $error = FALSE;

			foreach ($this->IDs as $ID)	{
			
				$this->lock();
			
				$result = $this->createpage($ID);
	
				if ($result === FALSE) {
				
					$error = TRUE; break;
				}  
				
				if ($result) $printed = TRUE;
				
				$this->unlock();
				
				usleep(300000);	
			}

			if ((! $printed) or ($error)) return FALSE;
			
			# force download

			$this->PDF->Output('printed.pdf', 'D');

			return TRUE;
		}

	}

?>

