<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag feedstock request composing to services lists
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}
	
	check_year_for_write('service_lists');

	pagepermission('service_lists', 'w');

	load_c('SQL');

	$__SQL	= new SQL;

	if ((isset($_POST['selected'])) && (! is_empty($_POST['selecteditems'])))	{

		load_m('feedstockrequest2listwrite');

		$ID_s		=	explode(',', $_POST['selecteditems']);

		$__REQUEST	=	new FEEDSTOCKREQUEST2LISTWRITE();

		$RESULT		=	$__REQUEST->write($ID_s);

		$NEWID		=	$__REQUEST->getid();

		unset($REQUEST, $__SQL);

		if ($RESULT !== TRUE)	{

			# analize error type

			if (strpos($RESULT, '->') !== FALSE)	{

				list ($errtype, $point, $pointID)	= explode('->', $RESULT);

				$ERROR	=	$__LANG->get($errtype, $__LANG->get($point).': '.$pointID);

			}	else	 {

				$ERROR	= $__LANG->get($RESULT);
			}

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $ERROR);
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		header("location: loader.php?cat=requestwrited&id=$NEWID");

		exit;
	}

	load_m('reversfeedstockrequestidread');

	$__REVERS	=	new REVERSWITHREQUESTREAD();

	$REVERSIDS	=	$__REVERS->idread();

	unset($__REVERS, $__SQL);

	if (! $REVERSIDS)	{

		$view	=	new View('sucessbox');
		$view	->	assign('SELF', 'loader.php?cat=section&amp;id=service_lists');
		$view	->	assign('MESSAGE', $__LANG->get('noopenedforrequest'));
		$view	->	assign('OK', $__LANG->get('ok'));
		$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=service_lists');
		$view	->	display();
		exit;
	}

	$view	=	new View('feedstockrequest2servicelists');

	$view	->	assign('SELECT_REVERSES_TO_REQUEST', $__LANG->get('selectservicelist'));
	$view	->	assign('OPENED_REVERSES', $__LANG->get('openenedreverses'));
	$view	->	assign('SELECTED_REVERSES', $__LANG->get('selectedreverses'));
	$view	->	assign('WRITE', $__LANG->get('write'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=service_lists');
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));

	# form data

	$view	->	assign('REVERSIDS', $REVERSIDS); unset($REVERSIDS);
	$view	->	assign('YEAR', $_SESSION['year']);

	$view	->	display();
?>
