<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag direct feedstock enter into stock
	 */

	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}
	 
	check_year_for_write('feedstock');

	pagepermission('feedstock', 'w');

	if (isset($_POST['submit']))	{

		unset($_POST['submit']);

		load_c('SQL');

		$__SQL	= new SQL();

		load_m('directstockenter');

		$__FEEDSTOCK	=	new DIRECTSTOCKENTER('feedstock');

		$RESULT		=	$__FEEDSTOCK ->	enter($_POST);

		unset($__FEEDSTOCK, $__SQL);

		if ($RESULT === TRUE)	{

			$view	=	new View('sucessbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('MESSAGE', $__LANG->get('datawritten'));
			$view	->	assign('OK', $__LANG->get('ok'));
			$view	->	assign('BACKTO', backward());
			$view	->	display();
			exit;
		}

		$view	=	new View('errorbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get($RESULT));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	if (isset($_POST['selected']))	{

		# go to second view for enter quantity

		load_c('SQL');

		$__SQL	= new SQL();

		if ((! is_empty($_POST['code'])) && (is_empty($_POST['id'])))	{

			load_m('idsearch');

			$search	=	new IDSEARCH();

			$base	=	'ebagstock';

			$ID	=	$search	->	bycode($base.'.feedstock', $_POST['code']);

			unset($search);
			
		}

		if (! is_empty($_POST['id'])) $ID = $_POST['id'];

		if (isset($ID))	{

			load_m('feedstockread');

			$__FEEDSTOCK	=	new FEEDSTOCKREAD();

			$FEEDSTOCKDATA	=	$__FEEDSTOCK->read($ID);

			unset($__FEEDSTOCK);
		}
		
		unset($__SQL);

		if ((! is_empty($_POST['code'])) && ($FEEDSTOCKDATA) && ($_POST['code'] != $FEEDSTOCKDATA['code'])) unset($FEEDSTOCKDATA);

		if ((! isset($FEEDSTOCKDATA)) or (! $FEEDSTOCKDATA))	{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get('feedstocknotmatch'));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		$view	=	new View('enterquantity');
		
		$view	->	assign('ENTER_ORIGIN_AND_QUANTITY', $__LANG->get('enteroriginquantity'));
		$view	->	assign('PERSONID', $__LANG->get('personIDlong'));
		$view	->	assign('CODE', $__LANG->get('code'));
		$view	->	assign('NAME', $__LANG->get('feedstockname'));
		$view	->	assign('UNIT', $__LANG->get('unit'));
		$view	->	assign('BILL_NUMBER', $__LANG->get('bill_number'));
		$view	->	assign('DELIVERY_LIST_NUMBER', $__LANG->get('delivery_list_number'));
		$view	->	assign('QUANTITY', $__LANG->get('quantity'));
		$view	->	assign('STOCKITEMNAME', 'feedstockname');

		# form data

		$view	->	assign('ITEMID', $ID);
		$view	->	assign('ITEMCODE', $FEEDSTOCKDATA['code']);
		$view	->	assign('ITEMNAME', $FEEDSTOCKDATA['feedstockname']);
		$view	->	assign('ITEMUNIT', $FEEDSTOCKDATA['unit']);

		unset($FEEDSTOCKDATA);

		$view 	->	assign('WRITE', $__LANG->get('write'));
		$view 	->	assign('RESET', $__LANG->get('reset'));
		$view	->	assign('BACKTO', backward());
		$view 	->	assign('CANCEL', $__LANG->get('cancel'));	

		$view	->	display();
		exit;
	}

	# first view for select id & code

	$view	=	new View('idcodeenter');

	$view 	->	assign('ENTER_ID_OR_CODE', $__LANG->get('enterfeedstock'));
	$view 	->	assign('PERSONID', $__LANG->get('feedstockbynumber'));
	$view 	->	assign('CODE', $__LANG->get('feedstockbycode'));
	$view 	->	assign('OK', $__LANG->get('ok'));
	$view 	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=feedstocks');
	$view 	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	display();
?>
