<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 *	Check system for installation
	 */
	 
	include('installationconf.php');
	
	if (isset($_POST['cancel']))	{
	
		include(BASEDIR.'views/installationcancelled.html');
		
		exit;
	}

	foreach(array('lang', 'direction') as $key)	{
	
		if (! isset($_GET[$key]))	{
		
			if (isset($_POST[$key])) {$_GET[$key] = $_POST[$key];} else {exit('Please run the install.php script to start new installation');}
		      
		}	else	{
		
			$_POST[$key] = $_GET[$key];
		}
	}
	
	if (isset($_POST['next']))	{
	
		header('location: installationlicense.php?lang='.$_GET['lang'].'&direction='.$_GET['direction']);
		
		exit;
	}
	
	# load language
	
	load_f('loadlanguage');
	
	$__LANG = loadlanguage('install', $_GET['lang']);
	
	# check the system
	
	load_m('systemcheck');
	
	$system = new SystemCheck();
	
	$required = $system->required();
	
	$recommended = $system->recommended();
	
	$passed = $system->passed();
	
	unset($system);
	
	load_c('View');
	
	$view = new View('installprecheck');
	
	$view->assign('SELF', url_encode($_SERVER['PHP_SELF']));
	
	$view->assign('SYSTEM_CHECK', $__LANG['system_check']);
	
	$view->assign('SYSTEM_REQUIREMENTS', $__LANG['system_requirements']);
	$view->assign('SYSTEM_RECOMMENDEDS', $__LANG['system_recommendeds']);
	$view->assign('UNABLE_TO_CHECK', $__LANG['unable_to_check']);
	
	$view->assign('REQUIRED', $required);
	$view->assign('RECOMMENDED', $recommended);
	$view->assign('PASSED', $passed); 
	
	unset($required, $recommended, $passed);
	
	$view->assign('CANCEL', $__LANG['cancel']);
	$view->assign('RE_CHECK', $__LANG['re_check']);
	$view->assign('NEXT', $__LANG['next']);

	$view->display();
	
?>