<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 *	Configure installation
	 */
	 
	set_time_limit(0);
	
	include('installationconf.php');
	
	foreach (array('lang', 'direction') as $key)	{
	
		if (! isset($_GET[$key]))	{
		
			if (isset($_POST['language___'.$key])) {$_GET[$key] = $_POST['language___'.$key];} else {exit('Please run the install.php script to start new installation.');}
		      
		}	else	{
		
			$_POST['language___'.$key] = $_GET[$key];
		}
	}
	
	# load language
	
	load_f('loadlanguage');
	
	$__LANG = loadlanguage('install', $_GET['lang']);
	
	# install
	
	if (isset($_POST['install']))	{

		load_m('installconfiguration');
		
		$configuration = new InstallConfiguration($_POST);
		
		if (! $error = $configuration->error())	{
		
		      # succesfull installation, redirect to next step
		      
		      header('location: installdatabase.php?lang='.$_POST['language___lang'].'&direction='.$_POST['language___direction']);
		      
		      exit;
		}
		
		$report = $configuration->getreport();
		
		unset($configuration);
	}
	
	if ((function_exists('apc_store')) && (@apc_store('test', 'test'))) {$apc = TRUE;} else {$apc = FALSE;}
	
	# show installation window

	include (BASEDIR.'classes/View.class.php');
	
	$view = new View('installconfiguration');
	
	$view->assign('SELF', url_encode($_SERVER['PHP_SELF']));
	
	$view->assign('LABEL', $__LANG['configuration']);
	$view->assign('SELECTED_LANGUAGE', $__LANG['selected_language']);

	$view->assign('PROTOCOL', $__LANG['protocol']);
	$view->assign('SECURE_PORT', $__LANG['secure_port']);
	
	$view->assign('MYSQL_CONNECTION', $__LANG['mysql_connection']);
	$view->assign('HOST', $__LANG['host']);
	$view->assign('USER', $__LANG['user']);
	$view->assign('GRANT', $__LANG['need_grant']);
	$view->assign('PASSWORD', $__LANG['password']);
	$view->assign('REPASSWORD', $__LANG['repassword']);
	$view->assign('APC_CACHE', $__LANG['apc_cache']);
	$view->assign('USE_APC_CACHE', $__LANG['use_apc_cache']);
	$view->assign('APC', $apc);
	$view->assign('YES', $__LANG['yes']);
	$view->assign('NO', $__LANG['no']);

	$view->assign('DATE_AND_TIME', $__LANG['date_and_time']);
	
	load_c('timezones');
	$timezones = new timezones();
	
	$view->assign('TIME_ZONE', $__LANG['time_zone']);
	$view->assign('TIMEZONES', $timezones->getlist()); 
	$view->assign('CURRENTZONE', $timezones->getcurrent()); unset($timezones);
	
	$view->assign('DATE_FORMAT', $__LANG['date_format']);

	$view->assign('SMTP_SETTINGS', $__LANG['smtp_settings']);
	$view->assign('BLANK_MEANS', $__LANG['blank_means']);
	$view->assign('SMTP_SECURE', $__LANG['smtp_secure']);
	$view->assign('PORT', $__LANG['port']);
	
	$secures = array('none'=>$__LANG['none'], 'ssl'=>'ssl', 'tls'=>'tls');
	$view->assign('SECURES', $secures); unset($secures);
	
	$view->assign('PAYMENTS_SETTINGS', $__LANG['payments_settings']);
	$view->assign('CURRENCY', $__LANG['currency']);
	$view->assign('VALUTA', $__LANG['valuta']);
	$view->assign('EXCHANGE_RATE', $__LANG['exchange_rate']);
	
	$view->assign('TAX_SETTINGS', $__LANG['tax_settings']);
	$view->assign('DEFAULT_SERVICES_TAX', $__LANG['default_services_tax']);
	$view->assign('DEFAULT_SALES_TAX', $__LANG['default_sales_tax']);
	
	$view->assign('DELIVERY_SETTINGS', $__LANG['delivery_settings']);
	$view->assign('DEFAULT_SERVICES_DEADLINE', $__LANG['default_services_deadline']);
	$view->assign('DEFAULT_SALES_DEADLINE', $__LANG['default_sales_deadline']);
	
	$view->assign('OFFERS_SETTINGS', $__LANG['offers_settings']);
	$view->assign('OFFER_HEADER_FILL', $__LANG['offer_header_fill']);
	
	$view->assign('DISPLAY', $__LANG['display']);
	$view->assign('ROW_NUMBERS_IN_TABLE', $__LANG['row_numbers_in_table']);
	
	$view->assign('BACKUP_SETTINGS', $__LANG['backup_settings']);
	$view->assign('DAILY_BACKUP', $__LANG['daily_backup']);
	$view->assign('BACKUP_DIRECTORY', $__LANG['backup_directory']);
	
	$view->assign('CLAMAV_SCAN', $__LANG['clamav_scan']);
	$view->assign('CLAMAV_PATH', $__LANG['clamav_path']);

	$view->assign('ERROR_SETTINGS', $__LANG['error_settings']);
	$view->assign('ERROR_MAIL_TO', $__LANG['error_mail_to']);
	
	$view->assign('REMINDER_SETTINGS', $__LANG['reminder_settings']);
	$view->assign('DAYSCHECK', $__LANG['dayscheck']);
	
	$view->assign('NEXT', $__LANG['next']);
	$view->assign('CANCEL', $__LANG['cancel']);
	
	# assign initial data
	
	if (! isset($error))	{
	
		$_POST['protocol___type']				=	'http';
		$_POST['protocol___secure_port']			=	443;
		$_POST['connection___host']				=	'localhost';
		$_POST['tax___default_tax_for_service']			=	20;
		$_POST['tax___default_tax_for_sales']			=	20;
		$_POST['delivery___default_deadline_for_service']	=	7;
		$_POST['delivery___default_deadline_for_shipment']	=	21;
		$_POST['date___dateformat'] 				=	'd.m.Y.';
		$_POST['offer___headerfill']				=	1;
		$_POST['display___increment']				=	15;
		$_POST['mail___secure']					=	'none';
		$_POST['backup___daily_backup']				=	1;
		$_POST['reminder___dayscheck']				=	7;
	}
	
	if (isset($report)) $view->assign('REPORT', $report);
	
	$view->display();
?>