<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag service list change
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('offers');

	pagepermission('offers', 'w');

	if (isset($_GET['id']))		{

		$OFFERID = $_SESSION['ID'] = $_GET['id'];

	}	else	  {

		$OFFERID = $_SESSION['ID'];
	}
	
	if ((! isset($_GET['p_err'])) && isset($_SESSION['_POST_ERR'])) unset($_SESSION['_POST_ERR']);

	load_c('SQL');

	$__SQL	= new SQL;

	if (isset($_POST['submit']))	{

		load_m('offerupdate');

		$__OFFER	=	new OFFERUPDATE();

		unset($_POST['submit']);

		$RESULT		=	$__OFFER->update($OFFERID, $_POST);

		unset($__SQL, $__OFFER);

		if ($RESULT !== TRUE)	{
		
			$_POST['_err_address'] = backward();

			$_SESSION['_POST_ERR']	=  	$_POST;

			$view	=	new View('errorbox');
			$view	->	assign('SELF', $_POST['_err_address']."&amp;id=$OFFERID&amp;p_err=1");
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		header("location: loader.php?cat=offerupdated&id=$OFFERID");

		exit;
	}

	# read offer data

	if (post_data_verified())	{

		$_POST = enc_quotes($_SESSION['_POST_ERR']);

		unset($_SESSION['_POST_ERR']);

	}	else	  {

		load_m('offerread');

		$__OFFER	=	new	OFFERREAD();
		
		$_POST		=	$__OFFER->read($OFFERID);

		unset($__OFFER);

		if (! is_array($_POST))		{

			$view	=	new View('errorbox');
			$view	->	assign('SELF',  $_SESSION['FROM']);
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($_POST));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}
	}

	$__PAYMENTS	=	new PAYMENTloader($__CONF->get('cache', 'use_apc_cache'));

	$PAYMENT_FORMS	=	$__PAYMENTS->getnames();

	unset($__PAYMENTS);

	$__DELIVERYS	=	new DELIVERYloader($__CONF->get('cache', 'use_apc_cache'));

	$DELIVERY_TYPES	=	$__DELIVERYS->gettypes();

	unset($__DELIVERYS);	

	$view	=	new View('offer');

	$view	->	assign('SELF', backward());
	$view	->	assign('OFFERLABEL', $__LANG->get('offerchange', $OFFERID.'/'.$_POST['offer_year']));
	$view	->	assign('OFFERID', $OFFERID);
	$view	->	assign('CONTACTID', $__LANG->get('contactID'));
	$view	->	assign('CONTACTNAME', $__LANG->get('contactname'));
	$view	->	assign('DEADLINE', $__LANG->get('deadline'));
	$view	->	assign('PAYMENT_FORM', $__LANG->get('payment_form'));
	$view	->	assign('DELIVERY_FORM', $__LANG->get('delivery_form'));
	$view	->	assign('SESSIONDISCOUNT', $__LANG->get('session_discount'));
	$view	->	assign('SERVICEDISCOUNT', $__LANG->get('service_discount_in'));
	$view	->	assign('ARTICLEDISCOUNT', $__LANG->get('article_discount_in'));
	$view	->	assign('OFFERINVALUTA', $__LANG->get('offer_in_valuta'));
	$view	->	assign('DAYSWORD', $__LANG->get('daysword'));
	$view	->	assign('COLUMNCODE', $__LANG->get('columnname_code'));
	$view	->	assign('COLUMNNAME', $__LANG->get('columnname_name'));
	$view	->	assign('COLUMNQUANTITY', $__LANG->get('columnname_quantity'));
	$view	->	assign('COLUMNUNIT', $__LANG->get('columnname_unit'));
	$view	->	assign('COLUMNTAX', $__LANG->get('columnname_tax'));
	$view	->	assign('COMMENT', $__LANG->get('comment'));
	$view	->	assign('ANNOTATION', $__LANG->get('annotation'));
	$view	->	assign('WRITE', $__LANG->get('write'));
	$view	->	assign('SEARCH', $__LANG->get('search'));
	$view	->	assign('SUMMARY', $__LANG->get('summary'));
	$view	->	assign('PRICETXT', $__LANG->get('price'));
	$view	->	assign('USED_SESSION_DISCOUNT', $__LANG->get('used_session_discount'));
	$view	->	assign('USED_ARTICLE_DISCOUNT', $__LANG->get('used_article_discount'));
	$view	->	assign('USED_SERVICE_DISCOUNT', $__LANG->get('used_service_discount'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('BACKTO', $_SESSION['FROM']);
	$view	->	assign('CANCEL', $__LANG->get('cancel'));

	$view	->	assign('PAYMENT_FORMS', $PAYMENT_FORMS); unset($PAYMENT_FORMS);
	$view 	->	assign('DELIVERY_TYPES', $DELIVERY_TYPES); unset($DELIVERY_TYPES);

	$_POST['valuta'] = $__CONF->get('payments', 'valuta');

	unset($__SQL);
	
	$view	->	display();

?>
