<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag add new item to order to stock
	 */

	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}
	 
	check_year_for_write('orders_to_stock');

	pagepermission('orders', 'w');

	if (isset($_POST['submit']))	{

		load_c('SQL');

		$__SQL	= new SQL();

		load_m('add2order2stock');

		$__ORDER2STOCK	=	new ADD2ORDER2STOCK();
		
		$RESULT		=	$__ORDER2STOCK->insert($_POST['code'], $_POST['stocktype'], $_POST['quantity']);

		unset($__ORDER2STOCK, $__SQL);

		if ($RESULT===TRUE)	{

			# inserted

			$view	=	new View('sucessbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('MESSAGE', $__LANG->get('datawritten'));
			$view	->	assign('OK', $__LANG->get('ok'));
			$view	->	assign('BACKTO', backward());
			$view	->	display();
			exit;
		}
		

		# analize error type

		if (strpos($RESULT, '->') !== FALSE)	{

			list ($errtype, $point, $pointID)	= explode('->', $RESULT);

			$ERROR	= $__LANG->get($errtype, $__LANG->get($point).': '.$pointID);

		}	else	 {

			$ERROR	= $__LANG->get($RESULT);
		}

		$view	=	new View('errorbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $ERROR);
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	$view	=	new View('neworder2stockitem');

	$view	->	assign('NEW_ORDER_TO_STOCK_ITEM', $__LANG->get('neworder2stockitem'));
	$view	->	assign('BASE', $_SESSION['BASE']);
	$view	->	assign('CODE', $__LANG->get('code'));
	$view	->	assign('STOCK_ITEM_TYPE', $__LANG->get('stockitemtype'));
	$view	->	assign('ARTICAL', $__LANG->get('artical'));
	$view	->	assign('FEEDSTOCK', $__LANG->get('feedstock'));
	$view	->	assign('SUPPLIER', $__LANG->get('supplier'));
	$view	->	assign('OPENED_ORDER_TO_STOCK_NO', $__LANG->get('open_order_id'));
	$view	->	assign('QUANTITY_ON_ORDER', $__LANG->get('quantity_on_order'));
	$view	->	assign('QUANTITY_IN_STOCK', $__LANG->get('quantity_in_stock'));
	$view	->	assign('QUANTITY', $__LANG->get('quantity'));
	$view	->	assign('WRITE', $__LANG->get('write'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=orders_to_stock');

	$view	->	display();

?>
