<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag create new salary	
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('salarys');

	pagepermission('salarys', 'w');

	load_c('SQL');

	$__SQL	= new SQL();

	if (isset($_POST['submit']))	{
	
		load_m('salarycomment');
		
		$__COMMENT = new SALARYCOMMENT();

		$__COMMENT->salaryID($_POST['person_id']);
		
		$__COMMENT->employeeID($_POST['employee_id']);

		if ((isset($_POST['month'])) && ($_POST['month'])) $__COMMENT->month($_POST['month']);
		
		if ((isset($_POST['semimonth'])) && ($_POST['semimonth']))  $__COMMENT->semimonth($_POST['semimonth']);

		$RESULT = $__COMMENT->write($_POST['comment'], $_POST['annotation']);
		
		$changedID = $__COMMENT->getID();
		
		unset($__COMMENT, $__SQL);

		if ($RESULT !== TRUE)	{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}
		
		$view	=	new View('sucessbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('salarychanged', $changedID));
		$view	->	assign('OK', $__LANG->get('ok'));
		$view	->	assign('BACKTO', backward());
		$view	->	display();
		exit;
	}

	# read employees to form

	load_m('employeesread');

	$__EMPLOYEES	=	new EMPLOYEESREAD();

	$EMPLOYEES	=	$__EMPLOYEES->read();

	unset($__EMPLOYEES);

	if (! $EMPLOYEES)	{

		$view	=	new View('errorbox');
		$view	->	assign('SELF', 'loader.php?cat=section&amp;id=salarys');
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('noemployees'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}
	
	# display the form

	$view	=	new View('salary_comments');
	
	$view	->	assign('SELF', backward());
	$view	->	assign('SALARY_COMMENTS', $__LANG->get('salary_comments'));
	$view	->	assign('NUMBER', $__LANG->get('personIDlong'));
	$view	->	assign('MONTHLY', $__LANG->get('salary_monthly'));
	$view	->	assign('SEMI_MONTHLY', $__LANG->get('salary_semimonthly'));
	$view	->	assign('EMPLOYEE', $__LANG->get('employee')); 
	$view	->	assign('EMPLOYEES', $EMPLOYEES); unset($EMPLOYEES);

      
	$MONTHS = $MONTH_PARTS = array();
	
	for ($i=1; $i<=12; $i++)	{
	
		# months
	
		$MONTHS[$i] = $__LANG->get("monthname$i");
	
		# semi-months
		
		$j = $i*2;
		
		$MONTH_PARTS[$j-1] = $MONTHS[$i].'&nbsp;&nbsp;&nbsp;I';

		$MONTH_PARTS[$j]   = $MONTHS[$i].'&nbsp;&nbsp;II';
	}

	$view	->	assign('MONTHNAMES', $MONTHS); unset($MONTHS);
	$view	->	assign('MONTH_PART_NAMES', $MONTH_PARTS); unset($MONTH_PARTS);

	$view	->	assign('COMMENT', $__LANG->get('comment'));
	$view	->	assign('ANNOTATION', $__LANG->get('annotation'));
	$view	->	assign('NOT_FOUND_MSG', $__LANG->get('notfound'));
	$view	->	assign('READ', $__LANG->get('read'));
	$view	->	assign('OK', $__LANG->get('ok'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=salarys');

	$view	->	display();

?>