<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag salarys personal constansts to employees
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('salarys');

	pagepermission('salarys', 'w');

	load_c('SQL');

	$__SQL	= new SQL();

	if (isset($_POST['submit']))	{

		load_m('personalsalarysettingswrite');

		$__SETTINGS	=	new PERSONALSALARYSETTINGSWRITE();

		$RESULT		=	$__SETTINGS->write($_POST);
		
		unset($__SETTINGS, $__SQL);

		if ($RESULT !== TRUE)	{

			$_POST['_err_address'] = backward();
		
			$_SESSION['_POST_ERR'] = $_POST;

			$view	=	new View('errorbox');
			$view	->	assign('SELF', $_POST['_err_address'].'&amp;p_err=1');
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		$view	=	new View('sucessbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('datawritten'));
		$view	->	assign('OK', $__LANG->get('ok'));
		$view	->	assign('BACKTO', backward());
		$view	->	display();
		exit;
	}
	
	# If Post Data is set from other page delete it and start new selection
	
	if (! post_get_data_verified()) unset($_SESSION['_POST_ERR']);

	if ((isset($_POST['selected'])) or (isset($_SESSION['_POST_ERR'])))	{

		# note: in a case that no record found the reader
		#	will return default valus to display view correctly

		if (isset($_SESSION['_POST_ERR']))	{

			$_POST = enc_quotes($_SESSION['_POST_ERR']);
	
			unset($_SESSION['_POST_ERR']);

		}	else	  {

			load_m('salarypersonalsettingsread');

			$__SETTINGS	=	new PERSONALSALARYSETTINGSREAD();

			$_POST		=	$__SETTINGS->read($_POST['employeeID'], $_POST['employeename']);

			unset($__SETTINGS, $__SQL);
		}

		$view	=	new View('salary_personal');

		$view	->	assign('SELF', backward());

		$view	->	assign('CURRENCY', $__CONF->get('payments', 'currency'));
		$view	->	assign('SALARY_PERSONAL_SETTINGS', $__LANG->get('salary_personal_settings'));
		$view	->	assign('NUMBER', $__LANG->get('personIDlong'));
		$view	->	assign('FIX_PAYMENT', $__LANG->get('fix_payment'));
		$view	->	assign('SEMI_MONTHLY_FIRST_PART', $__LANG->get('semi_monthly_first'));
		$view	->	assign('PAYMENT_ACCORDING_TO_HOURS', $__LANG->get('payment_according_to_hours'));
		
		$view	->	assign('BONUS_ACCORDING_TO_PRODUCTION', $__LANG->get('bonus_according_to_production'));
		$view	->	assign('BONUS_ACCORDING_TO_SERVICES', $__LANG->get('bonus_according_to_services'));
		$view	->	assign('BONUS_ACCORDING_TO_PRODUCT_SELL', $__LANG->get('bonus_according_to_product_sell'));
		$view	->	assign('BONUS_ACCORDING_TO_SERVICE_SELL', $__LANG->get('bonus_according_to_service_sell'));
		$view	->	assign('BONUS_TYPES', array(0=>$__LANG->get('none'), 1=>$__LANG->get('bonus_to_all_fix'), 2=>$__LANG->get('bonus_to_all_percent'), 3=>$__LANG->get('bonus_by_code')));

		$view	->	assign('ADDITIONALS', $__LANG->get('addition_deduction'));
		$view	->	assign('NAME', $__LANG->get('name'));
		$view	->	assign('VALUE', $__LANG->get('value'));
		$view	->	assign('BASE', $__LANG->get('base'));
		$view	->	assign('TYPE', $__LANG->get('type'));

		$view	->	assign('START', $__LANG->get('start'));
		$view	->	assign('PREVIOUS', $__LANG->get('previous'));
		$view	->	assign('FIXED', $__LANG->get('fixed'));
		$view	->	assign('PERCENT', $__LANG->get('percent'));
		
		$view	->	assign('SALARY_PERSONAL_CREDITS', $__LANG->get('personal_credits'));
		$view	->	assign('NOTICE', $__LANG->get('personalcreditsnotice'));

		$view	->	assign('WRITE', $__LANG->get('write'));
		$view	->	assign('RESET', $__LANG->get('reset'));
		$view	->	assign('CANCEL', $__LANG->get('cancel'));
		$view	->	assign('BACKTO', backward());

		$view	->	display();

		exit;
	}

	# display employee select form

	load_m('employeesread');

	$__EMPLOYEES	=	new EMPLOYEESREAD();

	$EMPLOYEES	=	$__EMPLOYEES->read();

	unset($__EMPLOYEES);

	if (! $EMPLOYEES)	{

		$view	=	new View('errorbox');
		$view	->	assign('SELF', 'loader.php?cat=section&amp;id=salarys');
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('noemployees'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	$view	=	new View('employeeselect');

	$view	->	assign('SELECTEMPLOYEE', $__LANG->get('selectemployee'));
	$view	->	assign('NAME', $__LANG->get('employeename'));
	$view	->	assign('EMPLOYEES', $EMPLOYEES); unset($EMPLOYEES);
	$view	->	assign('OK', $__LANG->get('ok'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=salarys');
	
	unset($__SQL);

	$view	->	display();

?>
