<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag send mass mail
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	pagepermission('addressbook', 'r');

	# note : used uploads root because of chat.tmp (to not be oberwritten accidentally);

	define ('TEMP', '../uploads/');

	load_c('SQL');

	$__SQL	= new SQL();

	if (isset($_POST['send']))	{

		if ($_POST['selecteditems'])	{

			$RECIPIENTS = explode(',', $_POST['selecteditems']);

		}	else	   {

			$view	=	new View('errorbox');
			$view	->	assign('SELF', 'loader.php?cat=section&amp;id=addressbook');
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get('norecipiens'));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		set_time_limit(0);

		load_c('smtpmail');

		$mail = new SmtpMail();

		$mail->host($__CONF->get('mail', 'host'));

		if ($__CONF->get('mail', 'secure'))	$mail->secure($__CONF->get('mail', 'secure'));
		if ($__CONF->get('mail', 'port')) 	$mail->port($__CONF->get('mail', 'port'));

		if ($__CONF->get('mail', 'user')) 	$mail->user($__CONF->get('mail', 'user'));
		if ($__CONF->get('mail', 'password')) 	$mail->password(($__CONF->get('mail', 'password')));

		# not: limit can be bigger, depending of server
		#	how many mail can be send in one session

		$mail->limit(20);

		# read company mail from base

		load_m('companymail');

		$__COMPANYMAIL	= new COMPANYMAIL();

		$COMPANYMAIL 	= $__COMPANYMAIL->read();

		unset ($__COMPANYMAIL);

		if (isset($COMPANYMAIL['mail']) && $COMPANYMAIL['mail']) $mail->from($COMPANYMAIL['mail']);
		
		if (isset($COMPANYMAIL['companyname']) && $COMPANYMAIL['companyname']) $mail->senderName($COMPANYMAIL['companyname']);

		$mail->to($RECIPIENTS);

		if ($_POST['subject']) $mail->subject($_POST['subject']);

		if ($_POST['message'])	{
		
			$mail->message($_POST['message']);
			
			$mail->nl2brConverting();
		}
		
		if (isset($_POST['html5']) && $_POST['html5']) $mail->html5();
		
		if (isset($_POST['reply']) && $_POST['reply']) $mail->reply($COMPANYMAIL['mail']);

		# message from file
	
		if (isset($_FILES))	{

			if (isset($_FILES['htmlfile']['tmp_name'])) {

				if (move_uploaded_file($_FILES['htmlfile']['tmp_name'], TEMP.$_FILES['htmlfile']['name']))	{

					$msgfile	=	TEMP.$_FILES['htmlfile']['name'];

					$mail		->	messageFromFile($msgfile);
				}
			}

			# inline pictures

			if (isset($_FILES['inline']['tmp_name']))	{

				if ($count = count($_FILES['inline']['tmp_name']))	{

					$inlines=array();

					for ($i=0; $i<$count; $i++)	{

						if ($_FILES['inline']['tmp_name'][$i])	{

							if (move_uploaded_file($_FILES['inline']['tmp_name'][$i], TEMP.$_FILES['inline']['name'][$i])) array_push($inlines, TEMP.$_FILES['inline']['name'][$i]);
						}
					}

					if (count($inlines)) $mail->embeddPictures($inlines);
				}
			}  

			# attachments

			if (isset($_FILES['attachment']['tmp_name']))	{

				if ($count=count($_FILES['attachment']['tmp_name']))	{

					$attachments=array();

					for ($i=0; $i<$count; $i++)	{

						if ($_FILES['attachment']['tmp_name'][$i])	{

							if (move_uploaded_file($_FILES['attachment']['tmp_name'][$i], TEMP.$_FILES['attachment']['name'][$i])) array_push($attachments, TEMP.$_FILES['attachment']['name'][$i]);
						}
					}

					if (count($attachments)) $mail->attach($attachments);
				}
			}
		}

		$RESULT = $mail->send();

		# delete temporary files

		if (isset($msgfile)) @unlink($msgfile);

		if ((isset($inlines)) && (count($inlines)))	{

			foreach ($inlines as $inline) @unlink($inline);
		}

		if ((isset($attachments)) && (count($attachments)))	{

			foreach ($attachments as $attachment) @unlink($attachment);
		}

		unset($__SQL);
		
		if ($RESULT !== TRUE)	{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get('errorsendingmail'));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		$view	=	new View('sucessbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('mailhassend'));
		$view	->	assign('OK', $__LANG->get('ok'));
		$view	->	assign('BACKTO', backward());
		$view	->	display();
		exit;

		unset($mail);
	}

	load_m('readmails');

	$__MAILS	=	new READMAILS();

	$CONTACTS	=	$__MAILS->read();

	unset($__MAILS, $__SQL);

	if (! $CONTACTS)	{

		$view	=	new View('errorbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('nomailslist'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	$view	=	new View('mail');

	$view	->	assign('SELF', backward());

	$view	->	assign('SEND_MAIL', $__LANG->get('sendmail'));
	$view	->	assign('CONTACTSLABEL', $__LANG->get('contacts'));
	$view	->	assign('RECIPIENTS', $__LANG->get('recipients'));
	$view	->	assign('SUBJECT', $__LANG->get('subject'));
	$view	->	assign('DECODE_HTML5', $__LANG->get('decode_html5'));
	$view	->	assign('REPLY_TO_POSTMASTER', $__LANG->get('reply_to_postmaster'));
	$view	->	assign('MESSAGE', $__LANG->get('message'));
	$view	->	assign('MESSAGE_FROM_FILE', $__LANG->get('messagefromfile'));
	$view	->	assign('INLINE_PICTURES', $__LANG->get('inlinepictures'));
	$view	->	assign('ADD', $__LANG->get('add'));
	$view	->	assign('MORE', $__LANG->get('more'));
	$view	->	assign('ATTACHMENTS', $__LANG->get('attachments'));
	$view	->	assign('SEND', $__LANG->get('send'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=addressbook');

	# mails

	$view	->	assign('CONTACTS', $CONTACTS); unset($CONTACTS);

	$view	->	display();
?>

