<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 5.0.0
	 */

	/**
	 * eBag users delete
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}
	
	pagepermission('users', 'w');

	load_c('SQL');

	$__SQL	= new SQL();

	# verifyed delete it

	if (isset($_POST['YES']))	{

		load_m('userdelete');

		$__USER	=	new USERDELETE();
		
		$RESULT	= 	$__USER->delete($_POST['id']);
		
		unset($__USER, $__SQL);

		if ($RESULT === TRUE)	{

			# deleted

			$view	=	new View('sucessbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('MESSAGE', $__LANG->get('userdeleted', $_POST['id']));
			$view	->	assign('OK', $__LANG->get('ok'));
			$view	->	assign('BACKTO', $_SESSION['FROM']);
			$view	->	display();
			exit;
		}

		# not allowed to delete (last user)

		$view	=	new View('errorbox');
		$view	->	assign('SELF', $_SESSION['FROM']);
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get($RESULT));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	# input check

	$ID	= $_GET['id'];

	load_m('namesearch');

	$search= new NAMESEARCH();

	$SURNAME	=	$search->byID('sur', 'ebag.users', $ID);
	$LASTNAME	=	$search->byID('last', 'ebag.users', $ID);
	
	unset($search, $__SQL);

	if ((! $SURNAME) or (! $LASTNAME)) 	{

		# record was deleted in meantime

		$view	=	new View('errorbox');
		$view	->	assign('SELF', $_SESSION['FROM']);
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('alreadydeleted'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	# verify

	$view	=	new View('verify');
	$view	->	assign('SELF', backward());
	$view	->	assign('QUESTION', $__LANG->get('suretodeluser', $ID.' ('.$__LANG->get('lastname').': '.$SURNAME.' '.$LASTNAME.')'));
	$view	->	assign('YES', $__LANG->get('yes'));
	$view	->	assign('NO', $__LANG->get('no'));
	$view	->	assign('ID', $ID);
	$view	->	assign('BACKTO', $_SESSION['FROM']);
	$view	->	display();

?>
