<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag bill delete
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class BILLDELETE	{

		function __construct()	{

			global $__SQL;

			$this->SQL		=	&$__SQL;

			$this->BASE		=	$_SESSION['BASE'];

			$this->baseyear		=	$_SESSION['year'];
		}

		private function lock()		{

			$this->SQL->query("	LOCK TABLES 	$this->BASE.bills_header WRITE, $this->BASE.bills_data WRITE, $this->BASE.claims WRITE,
								$this->BASE.deliverys_header WRITE, $this->BASE.deliverys_data WRITE,
								$this->BASE.services_header WRITE, $this->BASE.services_data WRITE");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function delete($ID, $DATA)	{

			$ID		=	$this->SQL->escape($ID);

			$delete_reason	=	$this->SQL->n_escape($DATA['delete_reason']);

			unset($DATA);

			$this->SQL->transaction();
		
			$this->lock();

			# exists yet ?

			$this->SQL->query("	SELECT `contactname` 
						FROM $this->BASE.bills_header WHERE 
						`personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'alreadydeleted';
			}

			# update header

			$this->SQL->query("	UPDATE $this->BASE.bills_header
						SET `deleted`=NULL, `delete_reason`=$delete_reason
						WHERE `personID`='$ID' LIMIT 1	");

			# update reverses header

			$this->SQL->query("	SELECT `reversID` 
						FROM $this->BASE.services_data 
						WHERE personID IN (	SELECT `dataID` 
									FROM $this->BASE.bills_data WHERE `billID`='$ID' AND `datatype`='s') 
									GROUP BY `reversID`	");

			if ($this->SQL->num_rows())	{

				$this->SQL->IT1_RESULT = $this->SQL->RESULT;

				while ($RESULT = $this->SQL->IT1_RESULT->fetch_row())	{

					$reversID	=	$RESULT[0];

					$this->SQL->query("	UPDATE $this->BASE.services_header
								SET `billed`='0', `billID`=NULL 
								WHERE `personID`='$reversID' LIMIT 1	");
				}

				unset ($this->SQL->IT1_RESULT);
			}

			# update deliverys header

			$this->SQL->query("	SELECT `deliveryID` 
						FROM $this->BASE.deliverys_data
						WHERE personID IN (	SELECT `dataID` 
									FROM $this->BASE.bills_data
									WHERE `billID`='$ID' AND `datatype`='d') 
									GROUP BY `deliveryID`	");

			if ($this->SQL->num_rows())	{

				$this->SQL->IT1_RESULT = $this->SQL->RESULT;

				while ($RESULT = $this->SQL->IT1_RESULT->fetch_row())	{

					$deliveryID	=	$RESULT[0];

					$this->SQL->query("	UPDATE $this->BASE.deliverys_header
								SET `billed`='0', `billID`=NULL 
								WHERE `personID`='$deliveryID' LIMIT 1	");

				}

				unset ($this->SQL->IT1_RESULT);
			}

			# delete bill & claims data

			# note: bill data deleted permanently because the service & delivery data have it anyway

			$this->SQL->query("	DELETE FROM $this->BASE.bills_data
						WHERE `billID`='$ID'	");


			$this->SQL->query("	DELETE FROM 
						$this->BASE.claims 
						WHERE `billID`='$ID' AND `baseyear`='$this->baseyear' LIMIT 1	");

			$this->SQL->commit();

			$this->unlock();

			return TRUE;
		}
	}

?>
