<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag contact read & write
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}
	
	load_f('is_longer');

	class CONTACTWRITE	{

		var $SQL;

		function __construct()	{

			global $__SQL;

			$this->SQL	=	&$__SQL;
			
			$this->BASE	=	$_SESSION['BASE'];
		}

		/**
		 * Write new contact
		 */

		public function write($DATA)	{

			# Check user input	
			
			$err = FALSE;

			if (isset($DATA['delivery']))	{

				if ((is_empty($DATA['delivery_city'])) or (is_empty($DATA['delivery_street'])) or (is_empty($DATA['delivery_zip']))) $err='usererror';
			}

			if ((is_empty($DATA['contactname'])) or (is_longer($DATA['contactname'], 40)) or (is_empty($DATA['city'])) or (is_empty($DATA['street']))) $err='usererror';

			if ($err) return $err;

			# Fill the eventual unset elements

			$disableds	=	array('delivery_country', 'delivery_city', 'delivery_street', 'delivery_zip', 'delivery_day_of_week');

			foreach ($disableds as $disabled) {if (! isset($DATA[$disabled])) $DATA[$disabled]='';}

			unset($disableds);

			# Escape the data

			$this->SQL->query("LOCK TABLES $this->BASE.addressbook WRITE");

			foreach ($DATA as $key=>$val)	$DATA[$key] = $this->SQL->n_escape($val);

			extract($DATA); unset($DATA);

			# Check the contact exists

			$this->SQL->query("	SELECT `personID` 
						FROM $this->BASE.addressbook 
						WHERE `contactname`=$contactname AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$this->SQL->query('UNLOCK TABLES');

				return 'contactexists';
			}

			# Write new contact

			$COMMAND =	"INSERT INTO $this->BASE.addressbook VALUES (
					NULL, $contactname, $contactperson, $country, $city, $zip, $street, $telephone1, $telephone2, $fax,
					$mobilephone, $mail, $website, $contacttype, $delivery_country, $delivery_city, $delivery_street,
					$delivery_zip, $delivery_day_of_week, '0', '0', '0', '0', $account1, $bank1, $account2, $bank2,
					$tax_id_number, '0')";

			$this->SQL->query($COMMAND);

			$this->SQL->query('UNLOCK TABLES');

			return TRUE;
		}
	}


?>
