<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag delivery change
	 */

	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class DELIVERYCHANGE	{

		function __construct()	{

			global $__SQL;

			$this->SQL		=	&$__SQL;

			$this->BASE		=	$_SESSION['BASE'];

			$this->STOCKBASE	=	'ebagstock';
		}

		private function lock()	{

			$this->SQL->query("	LOCK TABLES	$this->BASE.deliverys_header WRITE, $this->BASE.deliverys_data WRITE, 
								$this->BASE.orders_header WRITE, $this->BASE.orders_data WRITE, 
								$this->STOCKBASE.finished_goods_stock WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function change($DATA)	{

			$deliveryID = $DATA['deliveryID'];

			if ((isset($DATA['personID'])) && (count($DATA['personID']))) 	{
			
				$personIDs = array();
			
				foreach ($DATA['personID'] as $ID)	{

					if ($ID) $personIDs[] = $ID;
				}

				if (! count($personIDs)) unset($personIDs);
			}

			$comment	=	$this->SQL->nr_escape($DATA['comment']);
			$annotation	=	$this->SQL->nr_escape($DATA['annotation']);

			unset($DATA);

			$this->SQL->transaction();
		
			$this->lock();			

			# check exists yest

			$this->SQL->query("	SELECT	`contactname` 
						FROM $this->BASE.deliverys_header
						WHERE `personID`='$deliveryID' LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'unexistentdelivery';				
			}

			# update header			

			$this->SQL->query("	UPDATE $this->BASE.deliverys_header
						SET `comment`=$comment, `annotation`=$annotation
		  				WHERE `personID`='$deliveryID' AND `deleted` IS NOT NULL LIMIT 1	");

			# if no personID is sent finish

			if (! isset($personIDs))	{

				$this->SQL->commit();

				$this->unlock();

				return TRUE;
			}

			foreach ($personIDs as $personID)	{

				$this->SQL->query("	SELECT `code`, `quantity`, `datapersonID`
							FROM $this->BASE.deliverys_data
							WHERE `personID`='$personID' LIMIT 1	");

				if (! $this->SQL->num_rows())	{

					$errtxt	= 'unknownerror';

					break;
				}

				$RESULT		= 	$this->SQL->RESULT->fetch_assoc();

				$code		= 	$this->SQL->nr_escape($RESULT['code']);

				$quantity	=	$RESULT['quantity'];

				$datapersonID	=	$RESULT['datapersonID'];

				# delete data	
				
				$this->SQL->query("	UPDATE $this->BASE.deliverys_data 
							SET `deleted`=NULL
							WHERE `personID`='$personID' LIMIT 1	");

				# write back item to orders

				$this->SQL->query("	UPDATE $this->BASE.orders_data
							SET `deliverylistID`=NULL, `date_of_delivery`=NULL
							WHERE `personID`='$personID' AND `deleted` IS NOT NULL LIMIT 1	");

				# check & update order state

				$this->SQL->query("	SELECT `orderID` 
							FROM $this->BASE.orders_data 
							WHERE `personID`='$datapersonID' AND `deleted` IS NOT NULL LIMIT 1	");

				if (! $this->SQL->num_rows())	{

					$errtxt = 'unexistentorder';

					break;
				}

				$RESULT		=	$this->SQL->RESULT->fetch_row();

				$orderID	=	$RESULT[0];

				$this->SQL->query("	SELECT COUNT(*) 
							FROM $this->BASE.orders_data 
							WHERE `orderID`='$orderID' AND `date_of_delivery` IS NULL AND `deleted` IS NOT NULL	");

				$RESULT		=	$this->SQL->RESULT->fetch_row();
				$not_delivered	=	$RESULT[0];

				# note: delivery states 2=>part, 1=>yes, 0=>no

				if ($not_delivered)	{

					$this->SQL->query("	SELECT COUNT(*) 
								FROM $this->BASE.orders_data 
								WHERE `orderID`='$orderID' AND `deleted` IS NOT NULL	");

					$RESULT		=	$this->SQL->RESULT->fetch_row();
					$allrow		=	$RESULT[0];

					if ($not_delivered == $allrow) {$DELIVERED = 0;} else {$DELIVERED = 2;}

				}	else	  {

					$DELIVERED = 1;
				}

				$this->SQL->query("	UPDATE $this->BASE.orders_header
							SET `delivered`='$DELIVERED'
							WHERE `personID`='$orderID' AND `deleted` IS NOT NULL LIMIT 1	");

				# update the stock

				$this->SQL->query("	UPDATE $this->STOCKBASE.finished_goods_stock 
							SET	quantity=quantity+$quantity,
								quantity_ordered=quantity_ordered+$quantity 
							WHERE `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");
			}

			# check for empty delivery

			$this->SQL->query("	SELECT `datapersonID` 
						FROM $this->BASE.deliverys_data
						WHERE  `deliveryID`='$deliveryID' AND `deleted` IS NOT NULL	");

			if (! $this->SQL->num_rows())	{

				# nothing left, delete header to

				$this->SQL->query("	UPDATE $this->BASE.deliverys_header 
							SET `deleted`=NULL 
							WHERE `personID`='$deliveryID' AND `deleted` IS NOT NULL LIMIT 1	");
			}	else	  {
			
				$newIds = array();

				while ($RESULT = $this->SQL->RESULT->fetch_row()) $newIds[] = $RESULT[0];

				$newIDstr	=	implode(',' , $newIds);

				$this->SQL->query("	SELECT `orderID` 
							FROM $this->BASE.orders_data 
							WHERE `personID` IN ($newIDstr) GROUP BY `orderID`	LIMIT 1		");
							
				$connectedIDs = array();

				while ($RESULT = $this->SQL->RESULT->fetch_row()) $connectedIDs[] = $RESULT[0];

				$connected_with_orders	=	'-'.implode('-', $connectedIDs).'-';

				$this->SQL->query("	UPDATE $this->BASE.deliverys_header 
							SET `connected_with_orders`='$connected_with_orders'
							WHERE `personID`='$deliveryID' AND `deleted` IS NOT NULL LIMIT 1	");
			}

			$this->SQL->commit();

			$this->unlock();

			return TRUE;
		}
	}
?>
