<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag delete delivery
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class DELIVERYDELETE	{

		function __construct()	{

			global $__SQL;

			$this->SQL		=	&$__SQL;

			$this->BASE		=	$_SESSION['BASE'];

			$this->STOCKBASE	=	'ebagstock';
		}

		private function lock()		{

			$this->SQL->query("	LOCK TABLES	$this->BASE.deliverys_header WRITE, $this->BASE.deliverys_data WRITE,
								$this->BASE.orders_header WRITE, $this->BASE.orders_data WRITE, 
								$this->STOCKBASE.finished_goods_stock WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function delete($ID, $DATA)	{

			$ID	=	$this->SQL->escape($ID);

			$this->SQL->transaction();
		
			$this->lock();

			# check billed is

			$this->SQL->query("	SELECT `billed` 
						FROM $this->BASE.deliverys_header
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'unexistentdelivery';
			}

			$RESULT	=	$this->SQL->RESULT->fetch_row();

			if ($RESULT[0])	{

				$this->SQL->rollback();

				$this->unlock();

				return 'billeddelivery';
			}
			
			$delete_reason	=	$this->SQL->n_escape($DATA['delete_reason']); unset($DATA);

			# delete header

			$this->SQL->query("	UPDATE $this->BASE.deliverys_header
						SET `deleted`=NULL , `delete_reason`=$delete_reason 
						WHERE `personID`='$ID' LIMIT 1		");

			# write back articles into stock

			$this->SQL->query("	SELECT `code`, `quantity`, `datapersonID` 
						FROM $this->BASE.deliverys_data
						WHERE `deliveryID`='$ID' AND `deleted` IS NOT NULL	");

			if ($this->SQL->num_rows())	{
	
				$this->SQL->IT1_RESULT = $this->SQL->RESULT;

				while ($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

					$code		=	$this->SQL->nr_escape($RESULT['code']);
					$quantity	=	$RESULT['quantity'];
					$datapersonID	=	$RESULT['datapersonID'];

					# update the stock

					$this->SQL->query("	UPDATE $this->STOCKBASE.finished_goods_stock
								SET	quantity=quantity+$quantity, 
									quantity_ordered=quantity_ordered+$quantity 
								WHERE `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");

					# update the connected order

					$this->SQL->query("	UPDATE $this->BASE.orders_data
								SET `date_of_delivery`=NULL, `deliverylistID`=NULL 
								WHERE `personID`='$datapersonID' AND `deleted` IS NOT NULL LIMIT 1	");

					# check the orders delivery state

					$this->SQL->query("	SELECT `orderID` 
								FROM $this->BASE.orders_data
								WHERE `personID`='$datapersonID' AND `deleted` IS NOT NULL LIMIT 1	");

					if ($this->SQL->num_rows())	{

						$RESULT1	=	$this->SQL->RESULT->fetch_row();

						$orderID	=	$RESULT1[0];

						$this->SQL->query("	SELECT COUNT(*) 
									FROM $this->BASE.orders_data 
									WHERE `orderID`='$orderID' AND `date_of_delivery` IS NULL AND `deleted` IS NOT NULL	");

						# note: delivery states 2=>part, 1=>yes

						if ($this->SQL->num_rows())	{

							$RESULT1	=	$this->SQL->RESULT->fetch_row();
							$not_delivered	=	$RESULT1[0];

							$this->SQL->query("	SELECT COUNT(*) 
										FROM $this->BASE.orders_data 
										WHERE `orderID`='$orderID' AND `deleted` IS NOT NULL	");

							$RESULT1	=	$this->SQL->RESULT->fetch_row();
							$allrow		=	$RESULT1[0];

							if ($not_delivered == $allrow) {$DELIVERED = 0;} else {$DELIVERED = 2;}


						}	else	  {
	
							$DELIVERED = 1;
						}

						$this->SQL->query("	UPDATE $this->BASE.orders_header
									SET `delivered`='$DELIVERED'
									WHERE `personID`='$orderID' AND `deleted` IS NOT NULL LIMIT 1	");
					}
				}
			}

			# delete data

			$this->SQL->query("	UPDATE $this->BASE.deliverys_data 
						SET `deleted`=NULL 
						WHERE `deliveryID`='$ID'	");
			$this->SQL->commit();

			$this->unlock();

			return TRUE;
		}
	}
?>
