<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag delivery details
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class DELIVERYDETAILS	{

		function __construct()	{

			global $__SQL, $__CONF, $__LANG;

			$this->SQL	=	&$__SQL;

			$this->LANG	=	&$__LANG;

			$this->FORMAT	=	$__CONF->get('date', 'sql_format');
			
			$this->APC	=	$__CONF->get('cache', 'use_apc_cache');

			$this->BASE	=	$_SESSION['BASE'];
		}

		public function base($BASE)	{

			$this->BASE	=	$BASE;
		}

		private function lock()	{

			$this->SQL->query("LOCK TABLES $this->BASE.deliverys_header WRITE, $this->BASE.deliverys_data WRITE");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function read($ID)	{

			$ID	=	$this->SQL->escape($ID);

			$DATA	=	FALSE;

			# first check te gived base exists or not

			$this->SQL->query("SELECT SCHEMA_NAME FROM INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME = '$this->BASE'");

			if (! $this->SQL->num_rows()) return 'unexistentdelivery';

			# read arrays
			
			$__PAYMENTS	= new PAYMENTloader($this->APC);

			$PAYMENT_FORMS	= $__PAYMENTS->getnames();
			
			unset($__PAYMENTS);
			
			$__DELIVERYS	= new DELIVERYloader($this->APC);

			$DELIVERY_TYPES	= $__DELIVERYS->gettypes();
			
			unset($__DELIVERYS);
			
			# read

			$this->lock();

			$this->SQL->query("	SELECT 	`contactname`, `country` ,`city`, `zip`, `street`, `comment`, `annotation`, 
							`delivery_form`, `payment_form`, `currency`, `connected_with_orders`, `billed`, `billID`,
							DATE_FORMAT(`date_of_creation`, '$this->FORMAT') AS `date_of_creation`
						FROM $this->BASE.deliverys_header
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$DATA	=	$this->SQL->RESULT->fetch_assoc();

				$DATA['delivery_year']	=	str_replace('ebagdata', '' , $this->BASE);

				if ($DATA['billed'])	{

					$DATA['billed']	= $this->LANG->get('yes').'('.$this->LANG->get('personIDlong').': '.$DATA['billID'].')';

				}	else	  {

					$DATA['billed']	= $this->LANG->get('no');
				}
				

				if (isset($PAYMENT_FORMS[$DATA['payment_form']])) $DATA['payment_form']	= $PAYMENT_FORMS[$DATA['payment_form']];

				unset($PAYMENT_FORMS);

				if (isset($DELIVERY_TYPES[$DATA['delivery_form']])) $DATA['delivery_form'] = $DELIVERY_TYPES[$DATA['delivery_form']];

				unset($DELIVERY_TYPES);

				if ($DATA['connected_with_orders'])	{

					$LIST	=	explode('-', $DATA['connected_with_orders']);
	
					unset($LIST[count($LIST)-1], $LIST[0]);

					$FROM	=	base64_encode("deliverydetails&amp;id=$ID");

					$LENGTH	=	0;

					foreach ($LIST as $key=>$val)	{

						$LIST[$key]	=	"<a href=\"loader.php?cat=orderdetails&amp;id=$val&amp;from=$FROM\">$val</a>\n";

						$len		=	strlen($val)+1;

						if (($LENGTH+$len) > 25)	{

							$LIST[$key] 	= 	'<br>'.$LIST[$key];
							$LENGTH		=	0;
						}	else	  {

							$LENGTH		+=	$len;
						}
					}

					$DATA['connected_with_orders']	= implode(',', $LIST);
				}

				# read data
		
				$this->SQL->query("	SELECT `code`, `name`, `quantity`, `unit`, `price`, `tax`
							FROM $this->BASE.deliverys_data 
							WHERE `deliveryID`='$ID' AND `deleted` IS NOT NULL ORDER BY `personID`	");

				if ($this->SQL->num_rows())	{
				
					# Initialize vars

					$DATA['price_sum'] = $DATA['price_tax'] = $DATA['price_sum_tax'] = 0;
					
					$DATA['code'] = $DATA['name'] = $DATA['quantity'] = $DATA['unit'] = $DATA['price'] = $DATA['tax'] = $DATA['sum'] = $DATA['sum_tax'] = array();

					while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{

						$DATA['code'][]		=	$RESULT['code'];
						$DATA['name'][]		=	$RESULT['name'];
						$DATA['quantity'][]	=	$RESULT['quantity'];
						$DATA['unit'][]		=	$RESULT['unit'];
						$DATA['price'][]	=	$RESULT['price'];
						$DATA['tax'][]		=	$RESULT['tax'];

						$SUM			=	$RESULT['price']*$RESULT['quantity'];
						
						$TAX			=	$SUM * $RESULT['tax']/100;
						
						$SUM_TAX		=	$SUM + $TAX;

						$DATA['sum'][]		=	number_format($SUM, 2, '.', '');
						
						$DATA['sum_tax'][]	=	number_format($SUM_TAX, 2, '.', '');

						$DATA['price_sum']	+=	$SUM;
						
						$DATA['price_tax']	+=	$TAX;
						
						$DATA['price_sum_tax']	+=	$SUM_TAX;

					}

					$DATA['price_sum']	=	number_format($DATA['price_sum'], 2, '.', '');
					$DATA['price_tax']	=	number_format($DATA['price_tax'], 2, '.', '');
					$DATA['price_sum_tax']	=	number_format($DATA['price_sum_tax'], 2, '.', '');

				}	else	  {

					$DATA	=	FALSE;
				}
			}

			$this->unlock();

			return $DATA;
		}
	}
