<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag read default data for finished phase change form
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class FINISHEDPHASECHANGEDEFAULT	{

		function __construct()	{

			global $__SQL, $__LANG, $__CONF;

			$this->SQL	=	&$__SQL;

			$this->LANG	=	&$__LANG;

			$this->BASE	=	$_SESSION['BASE'];

			$this->FORMAT	=	$__CONF->get('date', 'sql_format');
			
			$this->APC	=	$__CONF->get('cache', 'use_apc_cache');
		}

		private function lock()	{

			$this->SQL->query("LOCK TABLES 	$this->BASE.production_orders_header WRITE, 
							$this->BASE.production_orders_phases WRITE,
							$this->BASE.addressbook WRITE, 
							$this->BASE.employees WRITE 	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function read($ID)	{

			$ID				=	$this->SQL->escape($ID);

			$DATA				=	'unexistentproductionorder';
			
			# read phases
			
			$__PHASES	=	new PHASEloader($this->APC);

			$PHASES		=	$__PHASES->getall();

			unset($__PHASES);

			$this->lock();
			
			# read header data

			$this->SQL->query("	SELECT `code`, `articalname`, `contactname`, `quantity`, 
						DATE_FORMAT(`date_of_creation`, '$this->FORMAT') AS `date_of_creation`,
						DATE_FORMAT(`date_of_finishing`, '$this->FORMAT') AS `date_of_finishing`
						FROM $this->BASE.production_orders_header
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->unlock();
	
				return 'unexistentproductionorder';
			}

			$DATA	=	$this->SQL->RESULT->fetch_assoc();

			$DATA['productionorderID']	=	$ID;

			if ($DATA['date_of_finishing'])	{

				$this->unlock();

				return 'finishedproductionorder';
			}

			# read finished phases

			$this->SQL->query("	SELECT `personID`, `finisher`, `production_phase`, `process_time`
						FROM $this->BASE.production_orders_phases
					  	WHERE `productionorderID`='$ID' AND `date` IS NOT NULL ORDER BY `personID` ");

			if (! $this->SQL->num_rows())	{

				$this->unlock();

				return 'finishedphasesnotfound';
			}

			if ($this->SQL->num_rows())	{

				$this->SQL->IT1_RESULT = $this->SQL->RESULT;

				while($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

					$personID	=	$RESULT['personID'];
					$phase		=	$RESULT['production_phase'];
					$FINISHER	=	$RESULT['finisher'];

					$DATA['finished_phases'][$personID]	=	$PHASES[$phase];

					$DATA['process_times'][$personID]	=	$RESULT['process_time'];

					if ($FINISHER)	{

						list($TYPE, $FINISHERID)	=	explode('_', $FINISHER);

						if ($TYPE == 'employee')	{

							$COMMAND = "	SELECT `employeename` 
									FROM $this->BASE.employees 
									WHERE `personID`='$FINISHERID' AND `deleted` IS NOT NULL LIMIT 1	";

						}	else	   {

							$COMMAND = "	SELECT `contactname` 
									FROM $this->BASE.addressbook 
									WHERE `personID`='$FINISHERID' AND `deleted` IS NOT NULL LIMIT 1	";
						}

						$this->SQL->query($COMMAND);

						if ($this->SQL->num_rows())	{

							$RESULT1 = $this->SQL->RESULT->fetch_row();

							$DATA['phase_finishers'][$personID]	=	$RESULT1[0];

						}	else	 {

							$DATA['phase_finishers'][$personID]	=	$this->LANG->get('finisherwasdeleted');
						}
					}
				}

				unset($this->SQL->IT1_RESULT);
			}

			$this->unlock();

			return $DATA;
		}
	}

?>
