<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag save inventory & delete temporary inventory table
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	load_f('date2sql');

	class INVENTORYMAKE	{

		function __construct()		{

			global $__SQL, $__CONF;

			$this->SQL		=	&$__SQL;

			$this->TEMPBASE		=	'ebagtemp';

			$this->BASE		=	$_SESSION['BASE'];

			$this->STOCKBASE	=	'ebagstock';

			$this->FORMAT		=	$__CONF->get('date', 'dateformat');
		}

		private function lock()	{

			$this->SQL->query("	LOCK TABLES	$this->TEMPBASE.$this->INVTABLE WRITE, 
								$this->STOCKBASE.$this->STOCKTABLE WRITE,
								$this->BASE.inventory_header WRITE, 
								$this->BASE.inventory_data WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function make($DATA, $INVTABLE, $STOCKTABLE)	{

			if ((! $this->INVTABLE = $INVTABLE) or (! $this->STOCKTABLE = $STOCKTABLE)) return 'unknownerror';

			if ($this->STOCKTABLE == 'stock') $this->STOCKTABLE = 'finished_goods_stock';

			if ((! isset($DATA['employeeID'])) or (! $DATA['employeeID'])) return 'usererror';

			$employeeID	=	$DATA['employeeID'];

			$date_of_creation = date2sql($DATA['date_of_creation'], $this->FORMAT);

			if (! $date_of_creation) return 'dateerror';

			$comment	=	$this->SQL->n_escape($DATA['comment']);

			$user		=	$this->SQL->n_escape($_SESSION['username']);

			# start transaction

			$this->SQL->transaction();
		
			$this->lock();

			# header data
			
			$this->SQL->query("	INSERT INTO $this->BASE.inventory_header
						VALUES 
						(NULL, '$this->STOCKTABLE', '$date_of_creation', '$employeeID', $user, $comment, '0')	");

			$inventoryID	=	$this->SQL->lastid();

			# read & write inventory data

			$this->SQL->query("	SELECT * FROM $this->TEMPBASE.$this->INVTABLE	");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'inventorytableempty';
			}

			$this->SQL->IT1_RESULT = $this->SQL->RESULT;

			while ($IT1_RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

				$personID	=	$IT1_RESULT['stockID'];
				$n_quantity	=	$IT1_RESULT['new_quantity'];

				$this->SQL->query("	SELECT `quantity` 
							FROM $this->STOCKBASE.$this->STOCKTABLE
							WHERE `personID`='$personID' AND `deleted` IS NOT NULL LIMIT 1	");

				# note: step over eventually (in meantime) deleted articles

				if ($this->SQL->num_rows())	{

					$RESULT		=	$this->SQL->RESULT->fetch_row();

					$b_quantity	=	$RESULT[0];

					$this->SQL->query("	UPDATE $this->STOCKBASE.$this->STOCKTABLE
								SET `quantity`='$n_quantity' 
								WHERE `personID`='$personID' AND `deleted` IS NOT NULL LIMIT 1	");

					$this->SQL->query("	INSERT INTO $this->BASE.inventory_data
								VALUES 
								(NULL, '$inventoryID', '$personID', '$b_quantity', '$n_quantity', '0')	");
				}
			}

			unset($this->SQL->IT1_RESULT);

			# in a case that is every artical stepped over

			$this->SQL->query("	SELECT `personID` 
						FROM $this->BASE.inventory_data
						WHERE `inventoryID`='$inventoryID' LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'inventoryitemsdeleted';
			}

			# drop inventory temporary table

			$this->SQL->query("	DROP TABLE IF EXISTS $this->TEMPBASE.$this->INVTABLE	");

			$this->SQL->commit();

			$this->unlock();

			return TRUE;			
		}
	}

?>
