<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag offer delete
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class OFFERDELETE	{

		function __construct()	{

			global $__SQL;

			$this->SQL	=	&$__SQL;
			$this->BASE	=	$_SESSION['BASE'];
		}

		private function lock()	{

			$this->SQL->query("LOCK TABLES	$this->BASE.offers_header WRITE, 
							$this->BASE.offers_data WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		private function state($ID)	{

			$STATE	=	FALSE;

			$this->SQL->query("	SELECT `ordered` 
						FROM $this->BASE.offers_header 
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$RESULT	=	$this->SQL->RESULT->fetch_row();

				if ($RESULT[0]) $STATE = 'orderedoffer';

			}	else	  {

				$STATE = 'unexistentoffer';
			}

			return $STATE;
		}

		public function delete($ID, $DATA)	{

			$ID	=	$this->SQL->escape($ID);

			$this->SQL->transaction();
		
			$this->lock();

			$STATE = $this->state($ID);

			if ($STATE)	{

				$this->SQL->rollback();

				$this->unlock();

				return $STATE;
			}

			$delete_reason	=	$this->SQL->n_escape($DATA['delete_reason']);

			$this->SQL->query("	UPDATE	$this->BASE.offers_header 
						SET `deleted`=NULL , `delete_reason`=$delete_reason
						WHERE `personID`='$ID' LIMIT 1	");

			$this->SQL->query("	UPDATE $this->BASE.offers_data 
						SET `deleted`=NULL 
						WHERE `offerID`='$ID'	");

			$this->SQL->commit();

			$this->unlock();

			return TRUE;
		}
	}

?>
