<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag order stock close & open
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class ORDER2STOCKCLOSE	{

		function __construct()	{

			global $__SQL;

			$this->SQL		=	&$__SQL;

			$this->BASE		=	$_SESSION['BASE'];

			$this->STOCKBASE	=	'ebagstock';
		}

		private function lock()	{

			$this->SQL->query("LOCK TABLES 	$this->BASE.orders_to_stock_header WRITE, 
							$this->BASE.orders_to_stock_data WRITE, 
							$this->STOCKBASE.finished_goods_stock WRITE, 
							$this->STOCKBASE.feedstock WRITE	");	
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function close($ID)	{

			$ID	=	$this->SQL->escape($ID);

			$this->SQL->transaction();
		
			$this->lock();

			$this->SQL->query("	SELECT `ordered`, `delivered` 
						FROM $this->BASE.orders_to_stock_header 
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'unexistentorder2stock';
			}

			$RESULT	=	$this->SQL->RESULT->fetch_assoc();
			
			# is ordered ?

			if ($RESULT['ordered']) {$ORDERED = TRUE;} else {$ORDERED = FALSE;}			
		
			# is delivered ?
			
			if ($RESULT['delivered'])	{
			
				$this->SQL->rollback();

				$this->unlock();

				return 'reopendeliveredorder2stock';
			}

			if ($ORDERED)	  {

				$STATE	=	0;
				$DATE	=	"NULL";

			}	else	  {

				$STATE	=	1;
				$DATE	=	$this->SQL->n_escape(date("Y-m-d"));
			}

			# update header

			$this->SQL->query("	UPDATE $this->BASE.orders_to_stock_header 
						SET `ordered`='$STATE', `date_of_order`=$DATE
		  				WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			# update data

			$this->SQL->query("	UPDATE $this->BASE.orders_to_stock_data 
						SET `ordered`='$STATE' 
						WHERE `order2stockID`='$ID' AND `deleted` IS NOT NULL	");

			# update stock

			$this->SQL->query("	SELECT `code`, `quantity`, `type`
						FROM $this->BASE.orders_to_stock_data
						WHERE `order2stockID`='$ID' AND `deleted` IS NOT NULL	");

			$STOCKTABLES	=	array(	'a'	=>	'finished_goods_stock',
							'f'	=>	'feedstock'	);

			if ($this->SQL->num_rows())	{

				$this->SQL->IT1_RESULT = $this->SQL->RESULT;

				while ($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

					$code		=	$this->SQL->nr_escape($RESULT['code']);
					$quantity	=	$RESULT['quantity'];

					$STOCKTABLE	=	$STOCKTABLES[$RESULT['type']];

					if ($ORDERED)	{

						# add to unordered

						$this->SQL->query("	UPDATE $this->STOCKBASE.$STOCKTABLE 
									SET	quantity_on_opened_order_to_stock=quantity_on_opened_order_to_stock+$quantity,
										quantity_ordered_to_stock=quantity_ordered_to_stock-$quantity
									WHERE `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");

					}	else	 {

						# add to ordered

						$this->SQL->query("	UPDATE $this->STOCKBASE.$STOCKTABLE 
									SET	quantity_on_opened_order_to_stock=quantity_on_opened_order_to_stock-$quantity,
										quantity_ordered_to_stock=quantity_ordered_to_stock+$quantity
									WHERE `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");
					}
				}
			}

			unset($this->SQL->IT1_RESULT);
			
			$this->SQL->commit();

			$this->unlock();

			if ($ORDERED)	{return 'opened';} else {return 'closed';}
		}
	}

?>
