<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag order to stock delete
	 */ 
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class ORDER2STOCKDELETE	{

		function __construct()	{

			global $__SQL;

			$this->SQL		=	&$__SQL;

			$this->BASE		=	$_SESSION['BASE'];

			$this->STOCKBASE	=	'ebagstock';
		}

		private function lock()	{

			$this->SQL->query("	LOCK TABLES 	$this->BASE.orders_to_stock_header WRITE, 
								$this->BASE.orders_to_stock_data WRITE, 
								$this->STOCKBASE.finished_goods_stock WRITE, 
								$this->STOCKBASE.feedstock WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function delete($ID, $DATA)	{

			$ID	=	$this->SQL->escape($ID);

			$this->SQL->transaction();
		
			$this->lock();

			# exist or not

			$this->SQL->query("	SELECT `ordered`
						FROM $this->BASE.orders_to_stock_header
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'unexistentorder2stock';
			}

			$RESULT	=	$this->SQL->RESULT->fetch_row();

			if ($RESULT[0]) {$ORDERED = TRUE;} else {$ORDERED = FALSE;}

			# check for delivered items on order

			$this->SQL->query("	SELECT `personID` 
						FROM $this->BASE.orders_to_stock_data
						WHERE `order2stockID`='$ID' AND `date_of_delivery` IS NOT NULL AND `deleted` IS NOT NULL	");

			if ($this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'partiallydeliveredorder2stock';
			}

			$this->SQL->query("	SELECT `personID`, `code`, `quantity`, `type`
						FROM $this->BASE.orders_to_stock_data
						WHERE `order2stockID`='$ID' AND `deleted` IS NOT NULL	");

			$STOCKTABLES	=	array(	'a'	=>	'finished_goods_stock',
							'f'	=>	'feedstock'	);

			if ($this->SQL->num_rows())	{

				$this->SQL->IT1_RESULT = $this->SQL->RESULT;

				while ($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

					$STOCKTABLE	=	$STOCKTABLES[$RESULT['type']];

					$personID	=	$RESULT['personID'];

					$code		=	$this->SQL->nr_escape($RESULT['code']);

					$quantity	=	$RESULT['quantity'];

					# delete item

					$this->SQL->query("	UPDATE $this->BASE.orders_to_stock_data 
								SET `deleted`=NULL WHERE `personID`='$personID' LIMIT 1	");

					# update stock

					if ($ORDERED)	{

						$this->SQL->query("	UPDATE $this->STOCKBASE.$STOCKTABLE 
									SET quantity_ordered_to_stock=quantity_ordered_to_stock-$quantity
							  		WHERE `code`=$code  AND `deleted` IS NOT NULL LIMIT 1	");

					}	else	 {

						$this->SQL->query("	UPDATE $this->STOCKBASE.$STOCKTABLE
									SET quantity_on_opened_order_to_stock=quantity_on_opened_order_to_stock-$quantity
									WHERE `code`=$code  AND `deleted` IS NOT NULL LIMIT 1	");
					}	
				}

				unset($this->SQL->IT1_RESULT);

				# delete header

				$delete_reason	=	$this->SQL->n_escape($DATA['delete_reason']);

				$this->SQL->query("	UPDATE $this->BASE.orders_to_stock_header 
							SET `deleted`=NULL, `ordered`='0', `delete_reason`=$delete_reason
							WHERE `personID`='$ID' LIMIT 1	");
			}

			$this->SQL->commit();

			$this->unlock();

			return TRUE;
		}
	}
?>
