<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag order to stock details read
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class ORDER2STOCKDETAILS	{

		function __construct()	{

			global $__SQL, $__LANG, $__CONF;

			$this->SQL	=	&$__SQL;

			$this->LANG	=	&$__LANG;

			$this->FORMAT	=	$__CONF->get('date', 'sql_format');

			$this->BASE	=	$_SESSION['BASE'];
		}

		public function base($BASE)	{

			$this->BASE	=	$BASE;
		}

		private function lock()	{

			$this->SQL->query("LOCK TABLES	$this->BASE.orders_to_stock_header WRITE, 
							$this->BASE.orders_to_stock_data WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function read($ID)		{

			$DATA	=	FALSE;

			$ID	=	$this->SQL->escape($ID);

			$this->lock();

			$this->SQL->query("	SELECT DATE_FORMAT(`date_of_order`, '$this->FORMAT') AS `date_of_order`, `contactname`, `country`, `city`, `zip`, `street`, `comment`, `connected_with_orders`
						FROM $this->BASE.orders_to_stock_header
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$DATA	= $this->SQL->RESULT->fetch_assoc();

				$DATA['order2stock_year']	=	str_replace('ebagdata', '' , $this->BASE);

				if (! $DATA['date_of_order'])	$DATA['date_of_order'] = $this->LANG->get('no');

				# create list of connected orders

				$LIST	=	explode('-', $DATA['connected_with_orders']);

				unset($LIST[count($LIST)-1], $LIST[0]);

				$DATA['connected_with_orders']	=	implode(',', $LIST);
	
				unset($LIST);

				$this->SQL->query("	SELECT `personID`, `code`, `name`, `unit`, `quantity`, 
								DATE_FORMAT(`date_of_delivery`, '$this->FORMAT') AS `date_of_delivery`, 
								`delivery_list_number`
							FROM $this->BASE.orders_to_stock_data
							WHERE `order2stockID`='$ID' AND `deleted` IS NOT NULL ORDER BY `personID`	");
				
			
				if ($this->SQL->num_rows())	{
				
					# Initialize vars
				
					$DATA['code'] = $DATA['name'] = $DATA['quantity'] = $DATA['unit'] = $DATA['picture'] = $DATA['alt'] = array();

					while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{

						$DATA['code'][]		=	$RESULT['code'];
						$DATA['name'][]		=	$RESULT['name'];
						$DATA['quantity'][]	=	$RESULT['quantity'];
						$DATA['unit'][]		=	$RESULT['unit'];

						if ($RESULT['date_of_delivery'])	{

							$PICTURE	=	'delivered';
							$ALT		=	$this->LANG->get('delivered').': '.$RESULT['date_of_delivery'].' '.$this->LANG->get('personIDlong').' '.$RESULT['delivery_list_number'];

						}	else	  {

							$PICTURE	=	'not_delivered';			
							$ALT		=	$this->LANG->get('notdelivered');
						}

						$DATA['picture'][]	=	$PICTURE;
						$DATA['alt'][]		=	$ALT;
					}

				}	else	  {

					$DATA	=	FALSE;
				}
			}

			$this->unlock();

			return $DATA;
		}
	}

?>

