<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 5.0.0
	 */

	/**
	 * eBag order to stock read
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class ORDER2STOCKREAD	{

		function __construct()	{

			global $__SQL, $__LANG, $__CONF;

			$this->SQL	=	&$__SQL;

			$this->LANG	=	&$__LANG;
			
			$this->FORMAT	=	$__CONF->get('date', 'sql_format');

			$this->BASE	=	$_SESSION['BASE'];
		}

		private function lock()	{

			$this->SQL->query("LOCK TABLES	$this->BASE.orders_to_stock_header WRITE, 
							$this->BASE.orders_to_stock_data WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function read($ID)		{

			$DATA	=	'unexistentorder2stock';

			$ID	=	$this->SQL->escape($ID);

			$this->lock();

			$this->SQL->query("	SELECT 	DATE_FORMAT(`date_of_order`, '$this->FORMAT') AS `date_of_order`,
							`contactname`, `country`, `city`, `zip`, `street`, `comment`, `connected_with_orders`
						FROM $this->BASE.orders_to_stock_header
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$DATA	= $this->SQL->RESULT->fetch_assoc();

				if (! $DATA['date_of_order'])	$DATA['date_of_order'] = $this->LANG->get('no');
				
				$DATA['order2stock_year'] = str_replace('ebagdata', '' , $this->BASE);

				# create list of connected orders

				$LIST	=	explode('-', $DATA['connected_with_orders']);

				unset($LIST[count($LIST)-1], $LIST[0]);

				$DATA['connected_with_orders']	=	implode(',', $LIST);
	
				unset($LIST);

				$this->SQL->query("	SELECT `personID`, `code`, `name`, `unit`, `quantity`, `date_of_delivery`
							FROM $this->BASE.orders_to_stock_data
							WHERE `order2stockID`='$ID' AND `deleted` IS NOT NULL ORDER BY `personID` ");
			
				if ($this->SQL->num_rows())	{
				
					# Initialize vars
				
					$DATA['personID'] = $DATA['code'] = $DATA['name'] = $DATA['quantity'] = $DATA['unit'] = $DATA['locked'] = array();

					while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{

						$DATA['personID'][]	=	$RESULT['personID'];
						$DATA['code'][]		=	$RESULT['code'];
						$DATA['name'][]		=	$RESULT['name'];
						$DATA['quantity'][]	=	$RESULT['quantity'];
						$DATA['unit'][]		=	$RESULT['unit'];

						# create one field with all personID`s

						if (! isset($DATA['IDs'])) {$DATA['IDs'] = $RESULT['personID'];} else {$DATA['IDs'] .= ','.$RESULT['personID'];}

						if ($RESULT['date_of_delivery'])	{

							$DATA['locked'][]	=	TRUE;

						}	else	  {
	
							$DATA['locked'][]	=	FALSE;
						}
					}

				}	else	  {

					$DATA	=	'unexistentorder2stock';
				}
			}

			$this->unlock();

			return $DATA;
		}
	}

?>
