<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag create list of deliverable items from gived IDs
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class PARTIALLYDELIVERYLIST	{

		function __construct()	{

			global $__SQL;

			$this->SQL		=	&$__SQL;

			$this->BASE		=	$_SESSION['BASE'];
		}

		private function lock()	{

			$this->SQL->query("	LOCK TABLES 	$this->BASE.orders_data WRITE, 
								$this->BASE.orders_header WRITE,
								$this->BASE.production_orders_header WRITE	");
		}
	
		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function readIDs($IDs)	{

			$this->ID_s	=	array();
			$this->ID_str	=	'';

			$array	=	explode(',', $IDs);

			foreach ($array as $item)		{

				$ID	=	(integer)($item);

				if (! $ID) continue;

				$this->SQL->query("	SELECT `contactname` 
							FROM $this->BASE.orders_header
							WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

				if ($this->SQL->num_rows()) $this->ID_s[]=$ID;
			}

			if (! count($this->ID_s)) return FALSE;

			$this->ID_str	=	implode(',', $this->ID_s);

			return TRUE;
		}

		public function create_list($DATA)	{

			$IDs	=	$DATA['orderIDs'];

			$this->lock();

			# make list
		
			if (! $this->readIDs($IDs))	{

				$this->unlock();

				return 'unexistentorder';
			}

			# read articles

			$this->SQL->query("	SELECT	`personID`, `orderID`, `code`, `articalname`, `quantity`, `unit`
						FROM $this->BASE.orders_data
			  			WHERE `orderID` IN ($this->ID_str) AND `date_of_delivery` IS NULL
						AND ((orders_data.productionorderID IS NULL) OR (orders_data.productionorderID NOT IN (SELECT `personID` FROM $this->BASE.production_orders_header WHERE `date_of_finishing` IS NULL)))
						ORDER BY `orderID`, `personID` "	);

			if (! $this->SQL->num_rows())	{

				$this->unlock();

				return 'cannotdeliveryfromorder';
			}

			# Initialize vars
			
			$DATA['personID'] = $DATA['code'] = $DATA['name'] = $DATA['quantity'] = $DATA['unit'] = $DATA['orderID'] = array();
			
			$this->SQL->IT1_RESULT	=	$this->SQL->RESULT;

			while	($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

				$DATA['personID'][]	=	$personID	=	$RESULT['personID'];
				$DATA['code'][]		=	$RESULT['code'];
				$DATA['name'][]		=	$RESULT['articalname'];
				$DATA['quantity'][]	=	$RESULT['quantity'];
				$DATA['unit'][]		=	$RESULT['unit'];

				$orderID		=	$RESULT['orderID'];

				$this->SQL->query("	SELECT `personID` 
							FROM $this->BASE.orders_data
							WHERE `orderID` = '$orderID' AND `deleted` IS NOT NULL	");

				$LINE	=	1;

				while ($RESULT1 = $this->SQL->RESULT->fetch_row())	{

					if ($personID == $RESULT1[0])	{break;} else {$LINE++;}
				}

				$DATA['orderID'][]	=	"$orderID -> $LINE";
			}

			$DATA['orderIDs'] = $this->ID_str;

			unset($this->SQL->IT1_RESULT);

			$this->unlock();

			return $DATA;
		}
	}

?>
