<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag personal salary settings & credits write
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class PERSONALSALARYSETTINGSWRITE	{

		function __construct()	{

			global $__SQL, $__CONF;

			$this->SQL	=	&$__SQL;
			
			$this->CONF	=	&$__CONF;

			$this->BASE	=	$_SESSION['BASE'];
		}

		private function lock()	{

			$this->SQL->query("	LOCK TABLES $this->BASE.salarys_personal_data WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		private function nonzero($VALUE)	{

			if ((! is_empty($VALUE)) && ($VALUE)) return TRUE;

			return FALSE;
		}

		public function write($DATA)	{

			$employeeID	=	$this->SQL->escape($DATA['employeeID']);
			
			foreach(array('employeeID', 'name_str', 'value_str', 'base_str', 'type_str', 'start_str', 'previous_str', 'fixed_str', 'percent_str', 'selected', 'employeename', 'submit') as $unset) unset($DATA[$unset]);

			# check bonuses

			if ((! is_empty($DATA['fix_payment']))  && (! is_empty($DATA['working_hour_value']))) return 'bothpaymenttype';

			if ((is_empty($DATA['fix_payment']))  && (is_empty($DATA['working_hour_value']))) return 'nopaymenttype';

			if (	((! is_empty($DATA['fix_payment'])) && ($DATA['fix_payment']<=0)) or 
				((! is_empty($DATA['working_hour_value'])) && ($DATA['working_hour_value']<=0))) return 'usererror';

			# check first part %
			
			if (! is_empty($DATA['fix_payment']))	{
			
				if ((is_empty($DATA['fix_payment_first_part'])) or ($DATA['fix_payment_first_part'] <= 0) or ($DATA['fix_payment_first_part'] >= 100)) return 'first_part_error';
			}
			
			# check bonuses
			
			# 0=>none, 1=>bonus_to_all_fix, 2=>bonus_to_all_percent, 3=>bonus_by_code
			
			foreach(array('bonus_to_production', 'bonus_to_services', 'bonus_to_product_sell', 'bonus_to_service_sell') as $bonus_type)	{
			
				if (! isset($DATA[$bonus_type])) $DATA[$bonus_type] = 0;
				
				$fix_bonus_type     = str_replace('bonus_to', 'bonus_fix', $bonus_type);
				
				$percent_bonus_type = str_replace('bonus_to', 'bonus_percent', $bonus_type);
				
				$bonus_type_value   = $bonus_type.'_value';
				
				$DATA[$fix_bonus_type] = $DATA[$percent_bonus_type] = 0;
				
				if (($DATA[$bonus_type] == 1) or ($DATA[$bonus_type]==2))	{
				
					if ((! isset($DATA[$bonus_type_value])) or (is_empty($DATA[$bonus_type_value])) or (! (double)$DATA[$bonus_type_value])) $DATA[$bonus_type_value] = 0;

					$value	= (double)$DATA[$bonus_type_value];

					if ($value < 0) 	{
	
						 $errtxt = 'negativbonus';
						 
						 break;
					}
					
					if ($DATA[$bonus_type] == 1)	{
					
						$DATA[$fix_bonus_type] = $value;
						
					}	else	  {
					
						$DATA[$percent_bonus_type] = $value;
					}
				}
				
				unset($DATA[$bonus_type_value]);
			}
			
			if (isset($errtxt)) return $errtxt;

			# check additionals

			if (isset($DATA['additional_name']))	{

				if ($count = count($DATA['additional_name']))	{

					for ($i=0; $i<$count; $i++)	{

						# step over empty rows

						if (	(is_empty($DATA['additional_name'][$i])) &&
							(is_empty($DATA['additional_value'][$i]))	)	continue;

						if (! isset($DATA['additional_value'][$i]))	{

							$errtxt = 'usererror';
							break;
						}

						$DATA['additional_value'][$i] = (double)$DATA['additional_value'][$i];

						# note:	additionals value can be negative and positive
						#	but not have sense to store zero

						if (	(is_empty($DATA['additional_name'][$i])) or
							(is_empty($DATA['additional_base'][$i])) or
							(! $DATA['additional_value'][$i])	)	{

							$errtxt = 'usererror';
							break;
						}
						
						if (! isset($PROCESSED['additional_name']))  $PROCESSED['additional_name']  = array();
						if (! isset($PROCESSED['additional_value'])) $PROCESSED['additional_value'] = array();
						if (! isset($PROCESSED['additional_base']))  $PROCESSED['additional_base']  = array();
						if (! isset($PROCESSED['additional_type']))  $PROCESSED['additional_type']  = array();
		
						$PROCESSED['additional_name'][] 	=	htmlspecialchars($DATA['additional_name'][$i], $this->CONF->get('specialchars', 'flag'), 'UTF-8', FALSE);
						$PROCESSED['additional_value'][] 	=	$DATA['additional_value'][$i];
						$PROCESSED['additional_base'][]		=	$DATA['additional_base'][$i];
						$PROCESSED['additional_type'][]		=	$DATA['additional_type'][$i];
					}
				}
			}

			if (isset($errtxt)) return $errtxt;

			if (! isset($PROCESSED['additional_name']))	{

				unset($DATA['additional_name'], $DATA['additional_value'], $DATA['additional_base'], $DATA['additional_type']);

			}	else	  {

				$DATA['additional_name']	=	$PROCESSED['additional_name'];
				$DATA['additional_value']	=	$PROCESSED['additional_value'];
				$DATA['additional_base']	=	$PROCESSED['additional_base'];
				$DATA['additional_type']	=	$PROCESSED['additional_type'];
			}

			# check credits
			
			if (isset($DATA['credit_name']))	{

				if ($count = count($DATA['credit_name']))	{

					for ($i=0; $i<$count; $i++)	{

						# step over empty rows

						if (	(is_empty($DATA['credit_name'][$i])) &&
							(is_empty($DATA['credit_value'][$i]))	)	continue;
							
						if (! isset($DATA['credit_value'][$i]))	{

							$errtxt = 'usererror';
							break;
						}

						$DATA['credit_value'][$i] = (double)$DATA['credit_value'][$i];

						# but not have sense to store zero

						if (	(is_empty($DATA['credit_name'][$i])) or
							($DATA['credit_value'][$i] <=0 )	)	{

							$errtxt = 'usererror';
							break;
						}
						
						if (! isset($PROCESSED['credit_name']))  $PROCESSED['credit_name']  = array();
						if (! isset($PROCESSED['credit_value'])) $PROCESSED['credit_value'] = array();
	
						$PROCESSED['credit_name'][] 	=	htmlspecialchars($DATA['credit_name'][$i], $this->CONF->get('specialchars', 'flag'), 'UTF-8', FALSE);
						$PROCESSED['credit_value'][] 	=	$DATA['credit_value'][$i];
					}
				}
			}

			if (isset($errtxt)) return $errtxt;

			if (! isset($PROCESSED['credit_name']))	{

				unset($DATA['credit_name'], $DATA['credit_value']);

			}	else	  {

				$DATA['credit_name']	=	$PROCESSED['credit_name'];
				$DATA['credit_value']	=	$PROCESSED['credit_value'];
			}

			$SERIALIZED	=	$this->SQL->mysqli->real_escape_string(serialize($DATA));

			$this->SQL->transaction();
		
			$this->lock();

			$this->SQL->query("	DELETE FROM $this->BASE.salarys_personal_data
						WHERE `employeeID`='$employeeID' LIMIT 1	" );


			$this->SQL->query("	INSERT INTO $this->BASE.salarys_personal_data
						VALUES
						('$employeeID', '$SERIALIZED')	");

			$this->SQL->commit();

			$this->unlock();

			return TRUE;			
		}
	}

?>
