<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 5.0.0
	 */

	/**
	 * eBag production order update
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	load_f('date2sql');
	
	load_f('datecompare');

	load_f('is_real_positive');

	load_f('is_int_positive');
	
	class PRODUCTIONORDER2STOCKUPDATE	{

		var 	$ORDER_TO_STOCK		=	FALSE;
		
		var	$STOCKTABLES		=	array(1=>'finished_goods_stock', 2=>'operating_suplies');

		function __construct()	{

			global $__SQL, $__CONF;

			$this->SQL		=	&$__SQL;

			$this->CONF		=	&$__CONF;

			$this->UNIT		=	new UNITloader($this->CONF->get('cache', 'use_apc_cache'));

			$this->BASE		=	$_SESSION['BASE'];

			$this->STOCKBASE	=	'ebagstock';
		}

		private function lock($stocktype)	{
		
			if ($this->STOCKTABLES[$stocktype] == 'operating_suplies') {$OPERATING_SUPLIES = ", $this->STOCKBASE.operating_suplies WRITE	";} else {$OPERATING_SUPLIES = '';}
		
			$this->SQL->query("LOCK TABLES	$this->BASE.production_orders_header WRITE, 
							$this->BASE.production_orders_data WRITE, 
							$this->STOCKBASE.feedstock WRITE,	
							$this->STOCKBASE.finished_goods_stock WRITE 
							$OPERATING_SUPLIES ");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		private function prepare($DATA)	{

			$CODES		=	$DATA['code'];
			$NAMES		=	$DATA['name'];
			$QUANTITYS	=	$DATA['quantity'];
			$UNITS		=	$DATA['unit'];
			$TYPES		=	$DATA['type'];

			$LENGTH		=	count($CODES);

			if (! $LENGTH) return 'usererror';

			$RETURN	=	array();

			for ($i=0; $i<$LENGTH; $i++)	{

				$code		=	$CODES[$i];
				$name		=	$NAMES[$i];
				$quantity	=	$QUANTITYS[$i];
				$unit		=	$UNITS[$i];
				$type		=	$TYPES[$i];				

				# empty rows

				if ((is_empty($code)) && (is_empty($name)) && (is_empty($quantity)) && (is_empty($unit))) continue;
				
				# initialize vars
				
				if (! isset($RETURN['code'])) 		$RETURN['code'] = array();
				if (! isset($RETURN['name'])) 		$RETURN['name'] = array();
				if (! isset($RETURN['quantity']))	$RETURN['quantity']= array();
				if (! isset($RETURN['unit'])) 		$RETURN['unit'] = array();
				if (! isset($RETURN['type'])) 		$RETURN['type'] = array();

				# user input

				if ((is_empty($code)) or (is_empty($name))) $RETURN = 'usererror';

				if ($this->UNIT->is_int_unit($unit))	{

					if (! is_int_positive($quantity)) $RETURN = 'usererror';
						
				}	else	 {

					if (! is_real_positive($quantity)) $RETURN = 'usererror';
				}				

				if ($RETURN == 'usererror') break;
				
				# feedstock or artical exists
				
				if ($type == 'a') {$stock = 'finished_goods_stock'; $return_str = 'articalnotexist';} else {$stock = 'feedstock'; $return_str = 'feedstocknotexist';}

				$code	=	$RETURN['code'][]	=	$this->SQL->n_escape($code);

				$this->SQL->query("	SELECT `personID` 
							FROM $this->STOCKBASE.$stock
							WHERE `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");

				if (! $this->SQL->num_rows()) {$RETURN = $return_str; break;}

				$RETURN['name'][]	=	$this->SQL->n_escape($name);
				$RETURN['quantity'][]	=	$quantity;
				$RETURN['unit'][]	=	$this->SQL->n_escape($unit);
				$RETURN['type'][]	=	$this->SQL->n_escape($type);
			}
	
			if ((is_array($RETURN)) && (! count($RETURN))) $RETURN = 'usererror';

			return $RETURN;			
		}

		public function	update($ID, $DATA)	{

			$ID			=	$this->SQL->escape($ID);
			
			$technology		=	$this->SQL->n_escape($DATA['technology']);
			
			$drawingID		=	$this->SQL->n_escape($DATA['drawingID']);
			
			$articalquantity	=	$DATA['articalquantity'];
			
			$date_of_deadline	=	date2sql($DATA['date_of_deadline'], $this->CONF->get('date', 'dateformat'));
		
			if (! $date_of_deadline) return 'dateerror';
			
			$STOCKTABLE 		=	$this->STOCKTABLES[$DATA['stocktype']];
			
			$this->SQL->transaction();
		
			$this->lock($DATA['stocktype']);

			# check existens & finishing & reread creation date

			$this->SQL->query("	SELECT `code`, `date_of_creation`, `date_of_finishing`, `quantity`
						FROM $this->BASE.production_orders_header 
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'unexistentproductionorder';
			}

			$RESULT	= $this->SQL->RESULT->fetch_assoc();

			if ($RESULT['date_of_finishing'])	{

				$this->SQL->rollback();

				$this->unlock();

				return 'finishedproductionorder';
			}
			
			# check date
			
			if (datecompare($RESULT['date_of_creation'], '>', $date_of_deadline))	{
			
				$this->SQL->rollback();

				$this->unlock();
			
				return 'dateerror';
			}
			
			$date_of_deadline = $this->SQL->n_escape($date_of_deadline);
			
			$articalcode	  = $this->SQL->n_escape($RESULT['code']);
			
			$quantity_before  = $RESULT['quantity'];
			
			# check the code exits yet & read unit
			
			$this->SQL->query("	SELECT `unit` 
						FROM $this->STOCKBASE.$STOCKTABLE
						WHERE `code`=$articalcode AND `deleted` IS NOT NULL LIMIT 1	");
						
			if (! $this->SQL->num_rows())	{
			
				$this->SQL->rollback();

				$this->unlock();

				return 'unexistentitem';
			}
			
			$RESULT = $this->SQL->RESULT->fetch_row();
			
			# check quantity by unit
			
			if ($this->UNIT->is_int_unit($RESULT[0]))	{

				if (! is_int_positive($articalquantity)) $error = 'usererror';
					
			}	else	 {

				if (! is_real_positive($articalquantity)) $error = 'usererror';
			}
			
			if (isset($error))	{
			
				$this->SQL->rollback();

				$this->unlock();

				return $error;
			}

			# prepare (feedstocks & articles) data

			$DATA = $this->prepare($DATA);

			if ((! isset($DATA['code'])) or (! count($DATA['code']))) $DATA = 'usererror';

			if (! is_array($DATA)) 	{

				$this->SQL->rollback();

				$this->unlock();

				return $DATA;
			}

			# update header

			$this->SQL->query("	UPDATE $this->BASE.production_orders_header
						SET `date_of_deadline`=$date_of_deadline, `quantity`='$articalquantity', `drawingID`=$drawingID, `technology`=$technology 
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");
						
			
			# update produced quantity in stock

			$this->SQL->query("	UPDATE $this->STOCKBASE.$STOCKTABLE
						SET quantity_in_production=quantity_in_production+($articalquantity-$quantity_before)
						WHERE `code`=$articalcode AND `deleted` IS NOT NULL LIMIT 1	"); 
						
			# write back feedstock quantities and articles quantities as part into stock
			# Note: the articles quantities are unchanged yet

			$this->SQL->query("	SELECT `code`, `quantity`, `type` 
						FROM $this->BASE.production_orders_data
						WHERE `productionorderID`='$ID' AND `deleted` IS NOT NULL	");

			$this->SQL->IT1_RESULT	=	$this->SQL->RESULT;

			if ($this->SQL->num_rows())	{

				while($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

					$code		=	$this->SQL->nr_escape($RESULT['code']);
					$quantity	=	$RESULT['quantity'];
					
					if ($RESULT['type']=='a')	{
					
						$this->SQL->query("	UPDATE $this->STOCKBASE.finished_goods_stock
									SET quantity_as_part=quantity_as_part-($quantity*$quantity_before)
									WHERE `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");
					}	else	{
					
						$this->SQL->query("	UPDATE $this->STOCKBASE.feedstock 
									SET	quantity=quantity+($quantity*$quantity_before), 
										quantity_in_production=quantity_in_production-($quantity*$quantity_before)
									WHERE `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");
					}
				}
			}

			unset($this->SQL->IT1_RESULT);

			# delete old data

			$this->SQL->query("	DELETE FROM $this->BASE.production_orders_data 
						WHERE `productionorderID`='$ID'		");
			# write new data

			$COUNT		=	count($DATA['code']);

			for ($i=0; $i<$COUNT; $i++)	{

				$code		=	$DATA['code'][$i];
				$name		=	$DATA['name'][$i];
				$quantity	=	$DATA['quantity'][$i];
				$unit		=	$DATA['unit'][$i];
				$type		=	$DATA['type'][$i];

				# check for same code

				$this->SQL->query("	SELECT `personID` 
							FROM $this->BASE.production_orders_data 
							WHERE `code`=$code AND `productionorderID`='$ID' AND `type`=$type AND `deleted` IS NOT NULL LIMIT 1	");

				if ($this->SQL->num_rows())	{

					# update

					$this->SQL->query("	UPDATE $this->BASE.production_orders_data 
								SET quantity=quantity+$quantity
								WHERE `code`=$code AND `productionorderID`='$ID' AND `type`=$type AND `deleted` IS NOT NULL LIMIT 1	");
				}	else	  {

					# insert new one

					$this->SQL->query("	INSERT INTO $this->BASE.production_orders_data 
								VALUES  
								(NULL, '$ID', $code, $name, $unit, '$quantity', $type, '0')	");
				}

				$SUM	=	(double)$articalquantity*(double)$quantity; 

				# check stock state and set to order
				
				if (! $this->ORDER_TO_STOCK)	{
				
					if ($type == "'a'")	{
					
						# finished goods stock
						# note: origin 1 is product which will not be ordered
						
						$this->SQL->query("	SELECT	quantity+quantity_ordered_to_stock+quantity_on_opened_order_to_stock-quantity_ordered-quantity_as_part-$SUM
									FROM $this->STOCKBASE.finished_goods_stock 
									WHERE `code`=$code AND `origin`!='1' AND `deleted` IS NOT NULL LIMIT 1	");

						if ($this->SQL->num_rows())	{

							$RESULT	= $this->SQL->RESULT->fetch_row();
							
							if ($RESULT[0] < 0) $this->ORDER_TO_STOCK = TRUE;
						}
						  
					}	else	{
					
						# feedstock
						
						$this->SQL->query("	SELECT quantity+quantity_ordered_to_stock+quantity_on_opened_order_to_stock-$SUM
									FROM $this->STOCKBASE.feedstock 
									WHERE `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");

						# note: must to be row, checked before

						$RESULT	= $this->SQL->RESULT->fetch_row();

						if ($RESULT[0] < 0) $this->ORDER_TO_STOCK = TRUE;
					}
				}
				
				if ($type == "'a'")	{
				
					# update finished goods stock
				
					# Note : finished goods stock final quantity will be updated when the production order is 
					#	 closed now update only quantity used as part
					
					$this->SQL->query("	UPDATE $this->STOCKBASE.finished_goods_stock
								SET quantity_as_part=quantity_as_part+$SUM
								WHERE `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");
				}	else	 {
				
					# update feedstock

					# Note: the feedstock quantity can be negative,
					#	other case will cause that the production orders cannot be created if you not have
					#	feedstock, and you cannot to work (example: making a whole project without ordering yet)

					$this->SQL->query("	UPDATE $this->STOCKBASE.feedstock
								SET quantity_in_production=quantity_in_production+$SUM, quantity=quantity-$SUM
								WHERE `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");
				}
			}

			$this->SQL->commit();

			$this->unlock();

			return TRUE;
		}
	}

?>
