<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag single delivery
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class SINGLEDELIVERY	{

		function __construct()	{

			global $__SQL, $__CONF;

			$this->SQL		=	&$__SQL;

			$this->CONF		=	&$__CONF;

			$this->BASE		=	$_SESSION['BASE'];

			$this->STOCKBASE	=	'ebagstock';
		}

		public function getid()		{

			if (isset($this->deliveryID)) {return $this->deliveryID;} else {return FALSE;}
		}

		private function lock()	{

			$this->SQL->query("	LOCK TABLES 	$this->BASE.orders_header WRITE, 
								$this->BASE.orders_data WRITE, 
								$this->BASE.deliverys_header WRITE, 
								$this->BASE.deliverys_data WRITE, 
								$this->BASE.production_orders_header WRITE, 
								$this->STOCKBASE.finished_goods_stock WRITE, 
								ebag.companydata WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function delivery($DATA)	{

			# collect the data

			$datapersonID	=	$DATA['datapersonID'];

			if (isset($DATA['add2deliveryID']))	{

				$this->deliveryID = $this->SQL->escape($DATA['add2deliveryID']);

				$ACTION	=	'updated';

			}	else	  {

				$ACTION	=	'writed';
			}

			$comment	=	$DATA['comment'];

			$annotation	=	$DATA['annotation'];

			unset($DATA);

			# set & read essentials
		
			# start transaction

			$this->SQL->transaction();
		
			$this->lock();

			# read the orderID

			$this->SQL->query("	SELECT `orderID`, `productionorderID`
						FROM $this->BASE.orders_data
			  			WHERE `personID`='$datapersonID' AND `deleted` IS NOT NULL LIMIT 1"	);

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'unexistentorderitem';
			}

			$RESULT		=	$this->SQL->RESULT->fetch_assoc();

			$orderID	=	$RESULT['orderID'];

			# check production order

			if ($productionorderID = $RESULT['productionorderID'])	{

				$this->SQL->query("	SELECT `code` 
							FROM $this->BASE.production_orders_header
							WHERE `personID`='$productionorderID' AND `date_of_finishing` IS NULL AND `deleted` IS NOT NULL LIMIT 1	");

				if ($this->SQL->num_rows())	{

					$this->SQL->rollback();

					$this->unlock();

					return 'produced2delivery';
				}
			}

			$currency	=	$this->SQL->n_escape($this->CONF->get('payments', 'currency'));

			$companyID	=	FALSE;

			$this->SQL->query("SELECT MAX(`personID`) AS `personID` FROM ebag.companydata");

			if ($this->SQL->num_rows())	{

				$RESULT		=	$this->SQL->RESULT->fetch_row();
				$companyID	=	"'".$RESULT[0]."'";
			}

			if (($currency == 'NULL') or (! $companyID))	{

				$this->SQL->rollback();

				$this->unlock();

				if (! $companyID) {return 'nocompanyID';} else {return 'fatalerror';}
			}			

			# check the deliveryID if is defined

			if (isset($this->deliveryID))	{

				$this->SQL->query("	SELECT `contactID` 
							FROM $this->BASE.orders_header
							WHERE `personID`='$orderID' AND `deleted` IS NOT NULL LIMIT 1	");

				if (! $this->SQL->num_rows())	{

					$this->SQL->rollback();

					$this->unlock();

					return 'unexistentorder';
				}

				$RESULT		=	$this->SQL->RESULT->fetch_row();

				$contactID	=	$RESULT[0];

				$this->SQL->query("	SELECT `contactID`, `billed`, `payment_form`, `delivery_form`
							FROM $this->BASE.deliverys_header
							WHERE `personID`='$this->deliveryID' AND `deleted` IS NOT NULL LIMIT 1	");

				if (! $this->SQL->num_rows())	{

					$this->SQL->rollback();

					$this->unlock();

					return 'unexistentdelivery';
				}

				$RESULT	=	$this->SQL->RESULT->fetch_assoc();

				$payment_form	=	$RESULT['payment_form'];

				$delivery_form	=	$RESULT['delivery_form'];

				if ($contactID != $RESULT['contactID'])	$errtxt = 'delivery2wrongcontact';

				if ($RESULT['billed'])	$errtxt	= 'delivery2billed';

				if (isset($errtxt))	{

					$this->SQL->rollback();

					$this->unlock();

					return $errtxt;
				}
			}

			# check the item is not delivered yet 

			$this->SQL->query("	SELECT `code`, `quantity`
						FROM $this->BASE.orders_data 
						WHERE `personID`='$datapersonID' AND `date_of_delivery` IS NULL AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'deliveredonce';
			}

			$RESULT		=	$this->SQL->RESULT->fetch_row();

			$code		=	$this->SQL->nr_escape($RESULT[0]);

			$quantity	=	$RESULT[1];

			# check artical exists & in the stock is enough

			$this->SQL->query("	SELECT `quantity`
						FROM $this->STOCKBASE.finished_goods_stock 
						WHERE `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'articalnotexist';
			}

			$RESULT	=	$this->SQL->RESULT->fetch_row();

			if ($quantity > $RESULT[0])	{

				$this->SQL->rollback();

				$this->unlock();

				return 'notenough2delivery';
			}
			
			$now	=	date("Y-m-d");

			if (! isset($this->deliveryID))		{

				# read header data from order and write it to delivery

				# note: if delivery address is defined delivery there

				$this->SQL->query("	SELECT `delivery_country` 
							FROM $this->BASE.orders_header
							WHERE `personID`='$orderID' LIMIT 1	");

				if (! $this->SQL->num_rows())	{

					$this->SQL->rollback();

					$this->unlock();

					return 'unexistentorder';
				}

				$RESULT	=	$this->SQL->RESULT->fetch_row();

				if ($RESULT[0])		{

					# read second delivery

					$this->SQL->query("	SELECT 	`contactID`, `contactname`, `delivery_country` AS `country`, `delivery_city` AS `city`,
									`delivery_street` AS `street`, `delivery_zip` AS `zip`, `account1`, `bank1`,
									`account2`, `bank2`, `delivery_day_of_week`, `contacttype`, `seller`, `delivery_form`, `payment_form`
								FROM $this->BASE.orders_header WHERE `personID`='$orderID' LIMIT 1	");

				}	else	  {

					$this->SQL->query("	SELECT	`contactID`, `contactname`, `country`, `city`, `zip`, `street`, `account1`, `bank1`, 
									`account2`, `bank2`, `delivery_day_of_week`, `contacttype`, `seller`, `delivery_form`, 
									`payment_form` 
								FROM $this->BASE.orders_header WHERE `personID`='$orderID' LIMIT 1	");
				}

				$RESULT	=	$this->SQL->RESULT->fetch_assoc();

				foreach ($RESULT as $key=>$val)	$RESULT[$key] = $this->SQL->nr_escape($val);

				extract($RESULT);

				$comment	=	$this->SQL->n_escape($comment);

				$annotation	=	$this->SQL->n_escape($annotation);

				$this->SQL->query("	INSERT INTO $this->BASE.deliverys_header 
							VALUES 
							( 	NULL, $companyID, $contactID, $contactname, $country, $city, $zip, $street,
								$account1, $bank1, $account2, $bank2, $delivery_day_of_week, $contacttype, $seller, 
								$comment, $annotation, $currency, $delivery_form, $payment_form,
								NULL, '0', NULL, '$now', NULL, '0' )	");

				$this->deliveryID	=	$this->SQL->lastid();

			}	else	  {

				# update exist delivery header

				if ((! is_empty($comment)) or (! is_empty($annotation)))	{

					$this->SQL->query("	SELECT `comment`, `annotation`, `payment_form`, `delivery_form` 
								FROM $this->BASE.deliverys_header
								WHERE `personID`='$this->deliveryID' AND `deleted` IS NOT NULL LIMIT 1	");

					$RESULT		=	$this->SQL->RESULT->fetch_assoc();

					# check delivery & payment form is the same

					if ($payment_form  != $RESULT['payment_form'])	$errtxt = 'differentpaymentfromdefined';

					if ($delivery_form != $RESULT['delivery_form'])	$errtxt = 'differentdeliveryformdefined';

					if (isset($errtxt))	{

						$this->SQL->rollback();

						$this->unlock();

						return $errtxt;
					}

					if (! is_empty($comment)) $comment = $this->SQL->r_escape($RESULT['comment']).$this->SQL->escape($comment);

					if (! is_empty($annotation)) $annotation = $this->SQL->r_escape($RESULT['annotation']).$this->SQL->escape($annotation);

					$this->SQL->query("	UPDATE $this->BASE.deliverys_header
								SET `comment`='$comment', `annotation`='$annotation'
								WHERE `personID`='$this->deliveryID' AND `deleted` IS NOT NULL LIMIT 1	");
				}
			}

			# read constans to calculate real prices to delivery list
			
			# note: exchange rate will read from order because maybe was offered
			#	so keep the offered price

			$this->SQL->query("	SELECT	`article_discount`, `exchange_rate`, `session_discount`, `use_session_discount`, `use_article_discount` 
						FROM $this->BASE.orders_header 
						WHERE `personID`='$orderID' AND `deleted` IS NOT NULL LIMIT 1	");

			$RESULT	=	$this->SQL->RESULT->fetch_assoc();

			extract($RESULT);

			$SESSION_COEF = $ARTICLE_COEF = 1;

			if (($use_session_discount) && ($session_discount>0))	$SESSION_COEF = (100-$session_discount) / 100;

			if (($use_article_discount) && ($article_discount>0))	$ARTICLE_COEF = (100-$article_discount) / 100;

			$GLOBAL_COEF	=	$SESSION_COEF * $ARTICLE_COEF * $exchange_rate;


			$this->SQL->query("	SELECT `code`, `articalname`, `quantity`, `unit`, `price`, `tax` 
						FROM $this->BASE.orders_data
			  			WHERE `personID`='$datapersonID' AND `deleted` IS NOT NULL LIMIT 1	");
	
			$RESULT	=	$this->SQL->RESULT->fetch_assoc();

			$code		=	$this->SQL->nr_escape($RESULT['code']);

			$articalname	=	$this->SQL->nr_escape($RESULT['articalname']);

			$unit		=	$this->SQL->nr_escape($RESULT['unit']);

			$price		=	$RESULT['price'] * $GLOBAL_COEF;
			
			$tax		=	$this->SQL->nr_escape($RESULT['tax']);

			$quantity	=	$RESULT['quantity'];

			# write item into delivery data

			$this->SQL->query("	INSERT INTO 
						$this->BASE.deliverys_data 
						VALUES 	(NULL, '$this->deliveryID', $code, $articalname, '$quantity', $unit, '$price', $tax, '$datapersonID', '0')	");

			# update order data

			$this->SQL->query("	UPDATE $this->BASE.orders_data
						SET `deliverylistID`='$this->deliveryID', `date_of_delivery`='$now'
						WHERE `personID`='$datapersonID' AND `deleted` IS NOT NULL LIMIT 1	");

			# update delivery header connected_with_order

			$this->SQL->query("	SELECT `connected_with_orders` 
						FROM $this->BASE.deliverys_header
			  			WHERE 	(`connected_with_orders` NOT REGEXP '-$orderID-' OR `connected_with_orders` IS NULL) 
							AND `personID`='$this->deliveryID' AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$RESULT	=	$this->SQL->RESULT->fetch_row();

				if ($connected_with_orders = $RESULT[0])	{

					$connected_with_orders	.=	"$orderID-";

				}	else	  {

					$connected_with_orders	=	"-$orderID-";
				}

				$this->SQL->query("	UPDATE $this->BASE.deliverys_header
							SET `connected_with_orders`='$connected_with_orders' 
							WHERE `personID`='$this->deliveryID' AND `deleted` IS NOT NULL LIMIT 1	");
			}

			# check there is more not delivered item on this order

			$this->SQL->query("	SELECT COUNT(*) 
						FROM $this->BASE.orders_data
						WHERE `date_of_delivery` IS NULL AND `orderID`='$orderID' AND `deleted` IS NOT NULL	");

			$RESULT	=	$this->SQL->RESULT->fetch_row();

			# note: delivery states 2=>part, 1=>yes

			if ($RESULT[0])	{$DELIVERED = 2;} else {$DELIVERED = 1;}


			$this->SQL->query("	UPDATE $this->BASE.orders_header
						SET `delivered`='$DELIVERED' 
						WHERE `personID`='$orderID' AND `deleted` IS NOT NULL LIMIT 1	");

			# update the stock

			$this->SQL->query("	UPDATE $this->STOCKBASE.finished_goods_stock
						SET 	quantity=quantity-$quantity, 
							quantity_ordered=quantity_ordered-$quantity 
						WHERE `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");

			$this->SQL->commit();

			$this->unlock();

			return $ACTION;	
		}
	}
