<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag operativ suplie write
	 */

	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}
	 
	load_f('is_real_positive');
	
	load_f('is_longer');

	class SUPLIEWRITE	{

		function __construct()	{

			global $__SQL;

			$this->SQL		=	&$__SQL;
			$this->STOCKBASE	=	'ebagstock';
		}

		private function prepare($DATA)		{

			# Check user input

			if ((is_empty($DATA['supliename'])) or 
			    (is_empty($DATA['code'])) or
			    (is_longer($DATA['code'], 25)) or
			    (is_empty($DATA['unit']))) return FALSE;
			    
			# note: accept 0 as price because can be internal production

			if ((! is_empty($DATA['purchase_price'])) && ((! is_numeric($DATA['purchase_price'])) or ($DATA['purchase_price'] < 0))) return FALSE;
			
			# Change empty purchase_price to zero
			
			if (is_empty($DATA['purchase_price'])) $DATA['purchase_price'] = 0;

			# Escape the data

			foreach ($DATA as $key=>$val)	$DATA[$key] = $this->SQL->n_escape($val);

			return $DATA;
		}

		public function lock()	{

			$this->SQL->query("LOCK TABLES $this->STOCKBASE.operating_suplies WRITE");
		}

		public function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function write($DATA)	{

			if (! $DATA = $this->prepare($DATA)) return 'usererror';

			$this->lock();

			extract($DATA); unset($DATA);

			# check the operativ suplie exists

			$this->SQL->query("	SELECT `personID` 
						FROM $this->STOCKBASE.operating_suplies 
						WHERE `code`=$code AND `deleted` is NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$this->unlock();
				return 'suplieexists';
			}

			$COMMAND	=	"INSERT INTO $this->STOCKBASE.operating_suplies VALUES 
						(NULL, $code, $supliename, $dimensions, $unit, '0', '0', $purchase_price, $comment, '0')";

			$this->SQL->query($COMMAND);

			$this->unlock();

			return TRUE;

		}

		public function copy($DATA)	{
	
			$RESULT	= $this->write($DATA);

			return $RESULT;
		}
	}

?>
