<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag delete working hours for one or more employees
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	load_f('date2sql');

	class WORKINGHOURSDELETE	{
	
		var $employeeIDs	=	array();

		function __construct()	{

			global $__SQL, $__CONF;

			$this->SQL	=	&$__SQL;

			$this->BASE	=	$_SESSION['BASE'];

			$this->FORMAT	=	$__CONF->get('date', 'dateformat');
		}

		private function addID($id)	{

			if ((integer)$id) $this->employeeIDs[]=(integer)$id;
		}


		public function delete($IDs, $date)	{

			$this->employeeIDs	=	array();

			if (strpos($IDs, ',') !== FALSE)	{

				$LIST	=	explode(',', $IDs);

				foreach ($LIST as $id) $this->addID($id);

				unset($LIST);

			}	else	  {

				$this->addID($IDs);
			}

			if (! count($this->employeeIDs)) return 'unexistentemployee';

			# check date

			if (! $date) return 'dateerror';

			if (! $date = date2sql($date, $this->FORMAT)) return 'dateerror';

			$ID_str	=	implode(',', $this->employeeIDs);

			$this->SQL->query("	DELETE FROM
						$this->BASE.working_hours
						WHERE `date`='$date' AND `employeeID` IN ($ID_str)	");
			return TRUE;
		}
	}

?>
