<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag reads employee working hours data at request
	 */
	 
	if ((! isset($_GET['base'])) or (! isset($_GET['id'])) or (! isset($_GET['date']))) exit;

	# Turn off magic quotes runtime

	if (get_magic_quotes_runtime())	set_magic_quotes_runtime(false);

	# If magic quotes is enabled strip slashes from code

	if (get_magic_quotes_gpc())	{

		foreach ($_GET as $key=>$val) $_GET[$key] = stripslashes($val);
	}

	$BASE		=	$_GET['base'];
	$employeeID	=	$_GET['id'];
	$date		=	$_GET['date'];

	include('../functions/date2sql.php');

	# read configuration

	include('../classes/INIload.class.php');

	$__CONF	= new INI_load('../conf/eBag.ini');
	
	# format the date

	$FORMAT	=	$__CONF->get('date', 'dateformat');

	$date	=	date2sql($date, $FORMAT); unset($FORMAT);
	
	# create connection

	$mysqli = new mysqli($__CONF->get('connection', 'host'), $__CONF->get('connection', 'user'), $__CONF->get('connection', 'password'));
	
	if ($mysqli->connect_error) exit;

	$mysqli->set_charset("utf8");

	$mysqli->query("SET NAMES 'utf8' COLLATE 'utf8_bin'");

	# query

	$RESULT	= $mysqli->query("	SELECT 	`work_hours`, `overtime_work_hours`, `night_work`, `night_overtime_work`, 
						`holiday_work`, `sick_leave`, `sick_leave_100`, `annual_leave`, `holiday` 
					FROM $BASE.working_hours WHERE `employeeID`='$employeeID' AND `date`='$date' AND `deleted` IS NOT NULL LIMIT 1	");

	if (! $RESULT->num_rows) exit;

	$ARRAY	=	$RESULT->fetch_assoc();

	extract($ARRAY); unset($ARRAY);

	header('Expires: Sun, 10 Jan 2010 12:00:00 GMT'); 
	header('Last-Modified: '.@gmdate( 'D, d M Y H:i:s').' GMT');
	header('Cache-Control: no-cache, no-store, must-revalidate');
	header('Pragma: no-cache');
	header('Content-Type: text/xml');

	echo <<<"EOT"
<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<response>
	<data>
		<work_hours>$work_hours</work_hours>
		<overtime_work_hours>$overtime_work_hours</overtime_work_hours>
		<night_work>$night_work</night_work>
		<night_overtime_work>$night_overtime_work</night_overtime_work>
		<holiday_work>$holiday_work</holiday_work>
		<sick_leave>$sick_leave</sick_leave>
		<sick_leave_100>$sick_leave_100</sick_leave_100>
		<annual_leave>$annual_leave</annual_leave>
		<holiday>$holiday</holiday>
	</data>
</response>
EOT;
?>
